install.packages("reshape2")
install.packages("ggplot2")
install.packages("plyr")
install.packages("scales")
install.packages("foreign")
install.packages("car")
install.packages("DAAG")
install.packages("MASS")
install.packages("leaps")
install.packages("car")
install.packages("bootStepAIC")
install.packages("forecast")
install.packages("glmulti")
install.packages("rJava")
install.packages("ISLR")
install.packages("boot")
install.packages("dplyr")
install.packages("broom")


library(leaps)
library(reshape2) 
library(ggplot2)
library(plyr)
library(scales)
library(foreign)
library(car)
library(randomForest)
library(DAAG)
library(MASS)
library(bootStepAIC)
library(leaps)
library(forecast)
library(glmulti)
library(rJava)
library(ISLR)
library(boot)
library(dplyr)
library(broom)


options(digits=6)

####### 1Bio_18_MULT

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/18_pts"
dir.create("1Bio_18_MULT")



setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT")

mainDir <- "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT"
dir.create("18_mult_tb_total")
dir.create("18_mult_value_im")
dir.create("RESULTS")



#

### Pre-processamento dos dados ### 

#

# Ajustando o diretorio de trabalho para trabalhar com a planilha dos individuos.

#

setwd("C:/3_CURUAI/0_BEST_MODEL")

p_ind <- read.csv("planilha_individuos.csv", header=TRUE, sep=";")

#

# Convertendo todos os angulos para radianos

#

p_ind$ang_topo_rad <- (p_ind$ang_topo*3.14)/180

p_ind$ang_fuste_rad <- (p_ind$ang_fuste*3.14)/180

#

#Removendo os pontos de arbutos os que cairam fora da area de estudo. Os pontos sao 13, 14, 15, 16, 23, 24, 25; removendo tambem os pontos de ANINGA e os pontos de especies que nao foram identificadas.

#

p_ind_sub <- subset(p_ind [!p_ind$ponto == 13 & !p_ind$ponto == 14 & !p_ind$ponto == 15 & !p_ind$ponto == 16 & !p_ind$ponto == 23 & !p_ind$ponto == 24 & !p_ind$ponto == 25 & !p_ind$sp == "MB" & !p_ind$sp == "XXX" & !p_ind$sp == "", ])

#

#calculando altura total, de fuste, de copa e altura de inundacao

#

p_ind_sub$h_total <- p_ind_sub$d_solo_clin + ((tan(p_ind_sub$ang_topo_rad)*p_ind_sub$d_tronco))

p_ind_sub$h_fuste <- p_ind_sub$d_solo_clin + ((tan(p_ind_sub$ang_fuste_rad)*p_ind_sub$d_tronco))

p_ind_sub$h_copa <- p_ind_sub$h_total - p_ind_sub$h_fuste

p_ind_sub$h_inund <- p_ind_sub$m_agua + p_ind_sub$d_solo_laser

#alturas_erradas <- which(is.na(p_ind_sub$h_total))

#p_ind_sub <- p_ind_sub[-alturas_erradas,]

#

# calculando area basal

# primeiro calculo o raio da arvore, depois a area basal em m2/ha (divido por 0.0625)

#

p_ind_sub$raio <- (p_ind_sub$dap / 2) / 100  #dividi por 100 para mudar as unidades - de centimetros para metros.

p_ind_sub$area_basal <- (3.14 * (p_ind_sub$raio^2))/0.0625 # Lembrar que a area eh pi*raio^2. Dividi por 0.0625 para ter a area basal em m2/ha

#

#calculando a altura de lorey. h_lorey = (h_total * area_basal) / area_basal_parcela. Essa altura sera calculada por partes: primeiro eu vou calcular a parte de cima da equacao e, apos o summarize, vou calcular a parte de baixo.

#

p_ind_sub$h_lorey_cima = p_ind_sub$h_total * p_ind_sub$area_basal

#

# Calculando a densidade de madeira

#

p_ind_sub$wd <- p_ind_sub$sp

levels(p_ind_sub$wd) <- levels(p_ind_sub$sp)

p_ind_sub$wd <- factor(p_ind_sub$wd)

levels(p_ind_sub$wd) <- c(0.29, #AD Alchornea discolor
                          0.76, #AE Albertia edulis
                          0.50, #AJ Astrocaryum jauari (Fonte: Astrocaryum murumuru - http://db.worldagroforestry.org/)
                          0.77, #AL Acacia loretensis (Fonte: media de todas as Acacia sp. - http://db.worldagroforestry.org/)
                          0.74, #AN Acosmium nitens
                          0.76, #Andira sp. (Fonte: media de todas as Andira sp. - http://db.worldagroforestry.org/)
                          0.71, #BC Bothriospora corymbosa
                          0.64, #BG Banara guianensis
                          0.60, #BJ Byrsonima japurensis
                          0.74, #BO Buchenavia oxycarpa
                          0.87, #CA Crudia amazonica
                          0.46, #CB Crataeva benthamii
                          0.74, #CC Campsiandra comosa
                          0.37, #CH Cordia hirta (Fonte: Cordia nodosa - Manual)
                          0.74, #CL Cassia leiandra (Fonte: media de todas as Cassia sp. - http://db.worldagroforestry.org/)
                          0.70, #CM Caliptrantis multiflora
                          0.60, #CP Caraipa punctulata (Fonte: http://db.worldagroforestry.org/)
                          0.61, #CR Casearia arborea (Fonte: Casearia aculeata - Manual)
                          0.69, #DD Duroia duckei
                          0.69, #DM Dimorphandra macrostachya (Fonte: http://db.worldagroforestry.org/)
                          0.79, #EA Eschweilera albiflora
                          0.64, #ED Etaballia dubia
                          0.77, #EI Eugenia inundata (Fonte: media de todas as Eugenia sp. - http://db.worldagroforestry.org/)
                          0.38, #FG Ficus guianensis (Fonte: Ficus anthelmintica - Manual)
                          0.66, #GG Guarea guidonea
                          0.69, #HA Heisteria acuminata (Fonte: media de todas Heisteria sp. - http://db.worldagroforestry.org/)
                          0.47, #HC Hydrochorea corymbosa (Fonte: http://db.worldagroforestry.org/)
                          0.61, #IO Inga obidensis (Fonte: Inga pilosula - Manual)
                          0.61, #IP Inga pilosula
                          0.71, #LA Licania apetala
                          0.43, #LC Luehea cymulosa
                          0.46, #MA Macrolobium acaciifolium
                          0.79, #MC Mouriri acutiflora
                          0.71, #MG Maytenus guianensis (Fonte: media de todos Maytenus - http://db.worldagroforestry.org/)
                          0.56, #MN Mabea nitida
                          0.70, #MR Matayba arborescens (Fonte: http://db.worldagroforestry.org/)
                          0.66, #OM Ormosia macrocalyx (Fonte: http://db.worldagroforestry.org/)
                          0.25, #PM Pseudobombax munguba
                          0.39, #PO Paramachaerium ormosiodes
                          0.43, #PR Pterocarpus rhori (Fonte: Pterocarpus amazonum - Manual)
                          0.90, #PT Piranhea trifoliolata
                          0.86, #QR Quiina rhytidopis (Fonte: media de todas as Quiinas - http://db.worldagroforestry.org/)
                          0.76, #SF Sloanea floribunda
                          0.35, #SH Cecropia hololeuca (Fonte: Cecropia latiloba e Cecropia membranacea - Manual)
                          0.40, #SM Simaba multiflora
                          0.77, #SP Symmeria paniculata
                          0.76, #TB Tabebuia barbata
                          0.83, #TC Talisia cupularis (Fonte: media de todas as Talisia - http://db.worldagroforestry.org/)
                          0.84, #TD Terminalia dichotoma
                          0.57, #TS Triplaris surinamensis
                          0.55, #VC Vitex cymosa
                          0.66, #VG Vatairea guianensis
                          0.68, #ZC Zygia cataractae (Fonte: media de todas as Zygia - http://db.worldagroforestry.org/)
                          0.75, #ZL Zygia latifolia (Fonte: http://db.worldagroforestry.org/)
                          0.68) #ZR Zygia ramiflora (Fonte: media de todas as Zygia - http://db.worldagroforestry.org/)

#

# sumarizando tudo, para calcular outros atributos

#d_ind = densidade de individuos. Estou utilizando a funcao "max()" por que ai indiretamente eu estou selecionando o numero total de individuos. Dai eu divido por 0.0625 e transformo em densidade de inviduos por uma area igual a um ha. Ou seja, a grandeza d_ind = n_ind/ha.

#h_lorey = anteriormente eu tinha calculado a h_lorey_cima. Ainda faltava dividir esse valor pela area basal media da parcela. Agora que summarizamos tudo, temos o valor de area basal media. Entao a coluna h_lorey sera criada. 

#

p_ind_sub$wd <- as.numeric(paste(p_ind_sub$wd))

p_ind_sub$ind <- as.numeric(p_ind_sub$ind)

p_ind_sub$biomass1 <- 0.06 * p_ind_sub$wd * p_ind_sub$h_total * pi * ((p_ind_sub$dap/2)^2)
p_ind_sub$biomass2 <- 0.112 * (p_ind_sub$wd * p_ind_sub$h_total * (p_ind_sub$dap^2))^0.916
p_ind_sub$biomass3 <- 0.0509 * p_ind_sub$wd * p_ind_sub$h_total * (p_ind_sub$dap^2)

p_ind_sub$biomass_kg <- (p_ind_sub$biomass1 + p_ind_sub$biomass2 + p_ind_sub$biomass3)/3

#Passando kg para Tonelada( Ou seja divide o valor em kg da biomassa por 1000)

p_ind_sub$biomass_T <- p_ind_sub$biomass_kg/1000

write.csv(p_ind_sub,"p_ind_sub.csv")


# Nesta metodologia, se soma todos os valores da biomassa dos individuos, lembrando que a unidade final  (kg)
# Ento vou trocar o valor "mean no summarise, por sum)

p_ind_sub_summ <- ddply(p_ind_sub, .(ponto), summarise, 
                        n_ind = length(unique(ind)),
                        dap = mean(dap, na.rm=TRUE),              
                        h_inund = mean(h_inund, na.rm=TRUE), 
                        h_total = mean(h_total, na.rm=TRUE), 
                        h_fuste = mean(h_fuste, na.rm=TRUE), 
                        h_copa = mean(h_copa, na.rm=TRUE), 
                        area_basal = sum(area_basal, na.rm=TRUE),
                        biomass_T = sum(biomass_T,na.rm=TRUE),
                        h_lorey_media = sum(h_lorey_cima, na.rm=TRUE))

p_ind_sub_summ$h_lorey <- p_ind_sub_summ$h_lorey_media/p_ind_sub_summ$area_basal

p_ind_sub_summ$d_ind <- p_ind_sub_summ$n_ind/0.0625


# O fator de escala e utilizado para passar as parcelas para T por ha "
# referncia: 
#Carreiras, J. M. B., Vasconcelos, M. J., & Lucas, R. M. (2012). 
#Remote Sensing of Environment Understanding the relationship between aboveground biomass and ALOS PALSAR data in the forests 
#of Guinea-Bissau ( West Africa ). Remote Sensing of Environment, 121, 426-442. http://doi.org/10.1016/j.rse.2012.02.012
# PG 442

# Sf= 10000/Anp  Where SF is the scaling factor, and Anp is the nested plot area (m2)
# AGB: soma das arvores em uma parcela*sf

sf <- 10000/625
print(sf)

p_ind_sub_summ$biomass_Tha <- p_ind_sub_summ$biomass_T*sf

#inserindo os dados de LAI

#

setwd("C:/3_CURUAI/0_BEST_MODEL/01_dados/LAI")

lai <- read.csv("lai.csv", header=TRUE, sep=";")

lai_sub <- subset(lai [!lai$ponto == 13 & !lai$ponto == 14 & !lai$ponto == 15 & !lai$ponto == 16 & !lai$ponto == 23 & !lai$ponto == 24 & !lai$ponto == 25, ])

#

#juntando as planilhas p_ind_sub_summ e a planilha lai_sub

p_ind_sub_final <- cbind(p_ind_sub_summ,lai_sub[,2])

names(p_ind_sub_final) <- c(names(p_ind_sub_summ),"lai")

p_ind_sub_final <- p_ind_sub_final[,-2] #Removendo a coluna do numero de individuos

p_ind_sub_final <- p_ind_sub_final[,-9] #Removendo a coluna da parte de cima da altura de lorey

#

# Unidades das variaveis de campo:

# dap - centimetros
# n_ind - contagem simples
# todas as alturas - metros
# area basal - m2 / ha
# d_ind - numero de individuos / ha
# LAI - nao tem unidade

rm(lai,lai_sub,p_ind,p_ind_sub,p_ind_sub_summ)

# Para rodar sem problemas vou trocar a biomassaTha pela BiomassaT

p_ind_sub_final <- subset(p_ind_sub_final, select=c(1,2,3,4,5,6,7,11,8,9,10,12))

p_ind_sub_final <- cbind(p_ind_sub_final[1], p_ind_sub_final[-1])


write.csv(p_ind_sub_final, "C:/3_CURUAI/0_BEST_MODEL/18_pts/p_ind_sub_final.csv")


##############################################TROCAR 18-16###################################################
#

# Anlise exploratria das variveis dependentes

#

# # Histograma DAP
# 
# hist(p_ind_sub_final$dap, 
#      breaks = 10,
#      main = "Histograma DAP",
#      xlab = "DAP (cm)",
#      ylab = "Frequncia",
#      col = "light gray")
# 
# # Histograma Altura
# 
# hist(p_ind_sub_final$h_total, 
#      breaks = 10,
#      main = "Histograma Altura",
#      xlab = " Biomass (m)",
#      ylab = "Frequncia",
#      col = "light gray")
# 
# # Histograma LAI
# 
# hist(p_ind_sub_final$lai, 
#      breaks = 10,
#      main = "Histograma LAI",
#      xlab = "LAI",
#      ylab = "Frequncia",
#      col = "light gray")
# 
# # Histograma Biomassa
# 
# hist(p_ind_sub_final$biomass_Tha, 
#      breaks = 10,
#      main = "Histograma Biomassa",
#      xlab = "Biomassa (Mg/ha)",
#      ylab = "Frequncia",
#      col = "light gray")
# 
# #

#Ajustando o diretorio de trabalho para trabalhar com a planilha das imagens.

#

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/valores_das_imagens")

rs2_c <- read.csv("RS2_LW_C2.csv")
alos <- read.csv("PALSAR_FDB.csv")
tsx <- read.csv("TSX_HH.csv")


#

#sumarisando as tabelas das imagens

#

rs2_dual_summ <- ddply(rs2_c, .(ROI_Name), summarise,
                      rs2_hh = mean(c11),
                      rs2_hv = mean(c22),
                      rs2_hv_hh = mean(rs2_hv_hh),
                      rs2_hvmhh = mean(rs2_hvmhh))


alos_summ <- ddply(alos, .(ROI_Name), summarise, 
                   alos_hh = mean(alos_hh),
                   alos_hv = mean(alos_hv),
                   alos_hv_hh = mean(alos_hv_hh),
                   alos_hvmhh = mean(alos_hvmhh))

tsx_summ <- ddply(tsx, .(ROI_Name), summarise,
                   tsx_hh = mean(hh))


#removendo objetos que nao serao mais usados

#

rm(rs2_c,alos,tsx)



# Antes de tudo devo criar uma funcao para calcular as variaveis em dB

dB <- function (x){
  options(digits=10)
  10*log10(x)
}

#

####################################
#
# Segunda variavel dependente: Biomassa (toneladas/ha)
#
####################################

#

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT")

#

####################################
#
# Biomassa x RS2 dual
#
####################################

#

# Criando o df basico (lembrar que p_ind_sub_final[11] = biomass_Tha)


dfr <- data.frame(p_ind_sub_final[8], rs2_dual_summ) # p_ind_sub_final[11] = biomass_Tha

dfr$rs2_hh_db <- dB(dfr$rs2_hh)
dfr$rs2_hh <- NULL
dfr$rs2_hv_db <- dB(dfr$rs2_hv)
dfr$rs2_hv <- NULL
dfr$rs2s_hv_hh_db <- (dfr$rs2_hv_hh)
dfr$rs2_hv_hh <- NULL
dfr$rs2_hvmhh_db <- (dfr$rs2_hvmhh)
dfr$rs2_hvmhh <- NULL

# print(cor(dfr))
# write.csv(cor(dfr),"cor_rs2_bio.csv")
# scatterplotMatrix(dfr, diagonal="histogram", smooth=FALSE)
write.csv(dfr, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_value_im/dfr.csv")


# 
# #
# 
# ######################################################################################
# #
# # Biomass x ALOS dual
# #
# ######################################################################################
# 
# #
# 
# 
# #
# 
# # Criando o df basico (lembrar que p_ind_sub_final[11] = bio)
# 
# #


dfl <- data.frame(p_ind_sub_final[8], alos_summ) # p_ind_sub_final[11] = bio


dfl$alos_hh_db <- dB(dfl$alos_hh)
dfl$alos_hh <- NULL
dfl$alos_hv_db <- dB(dfl$alos_hv)
dfl$alos_hv <- NULL
dfl$alos_hv_hh_db <- (dfl$alos_hv_hh)
dfl$alos_hv_hh <- NULL
dfl$alos_hvmhh_db <- (dfl$alos_hvmhh)
dfl$alos_hvmhh <- NULL

# print(cor(dfl))
# write.csv(cor(dfl),"cor_alos_bio.csv")
# scatterplotMatrix(dfl, diagonal="histogram", smooth=FALSE)
write.csv(dfl, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_value_im/dfl.csv")
# 
# #
# 
# ######################################################################################
# #
# # Biomass x TERRASAR
# #
# ######################################################################################
# 
# #
# 
# 
# #
# 
# # Criando o df basico (lembrar que p_ind_sub_final[11] = bio)
# 
# #


dfx <- data.frame(p_ind_sub_final[8], tsx_summ)

dfx$tsx_hh_db <- dB(dfx$tsx_hh)
dfx$tsx_hh <- NULL


# print(cor(dfx))
# write.csv(cor(dfx),"cor_tsx_h_total.csv")
# scatterplotMatrix(dfx, diagonal="histogram", smooth=FALSE)
write.csv(dfx, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_value_im/dfx.csv")



# ######################################################################################
# #
# # JUNTANDO AS PLANILHAS
# #
# ######################################################################################



multmerge = function(mypath){
  filenames=list.files(path=mypath, full.names=TRUE)
  datalist = lapply(filenames, function(x){read.csv(file=x,header=T)})
  Reduce(function(x,y) {merge(x,y)}, datalist)}

Mfreq_id = multmerge("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_value_im")
write.csv(Mfreq_id, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_tb_total/Mfreq_id.csv")

Mfreqt <- arrange(Mfreq_id, X)
Mfreqt <-Mfreqt [-1]
Mfreqt <-Mfreqt [-2]
write.csv(Mfreqt, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_tb_total/Mfreq.csv")

print(Mfreqt)



##### Removendo as tabelas que no so mais necessrias

rm(alos_summ,dfl, dfr, dfx, rs2_dual_summ, tsx_summ)

# 
# #
# 
# 
# #
# ######################################################################################
# #
# # MODELOS
# #
# ######################################################################################
# 
# #
# 
# 
# #
# 
######Para salvar todas (-1, pois na tabela a coluna da biomassa ou lai
# no deve ser calculada na combinao#########################33
Comb <- 2^((ncol(Mfreqt))-1)
print(Comb)

############################## comb = 10 ##############################3




df <- Mfreqt




# ######################################################################################
# #
# # MODELOS GLM MULT LINK = IDENTITY
# #
# ######################################################################################
# 

Mfreq <- glmulti((biomass_Tha) ~ .,  data = df, 
                 level = 1,               # No interaction considered
                 method = "h",            # Exhaustive approach
                 crit = "aicc",            # AIC as criteria
                 confsetsize = Comb,         # Keep all model n^2 
                 plotty = F, report = F,  # plot or interim reports
                 fitfunction = "glm",
                 family=gaussian(link="identity")
)     # lm function

Mfreq@objects
MfreqBest <- summary(Mfreq@objects[[1]])# selecr best model 
print(MfreqBest)
Mfreq_aic_limt <- weightable(Mfreq)
Mfreq_aic_limt2 <- Mfreq_aic_limt[Mfreq_aic_limt$aicc <= min(Mfreq_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
Mfreq_aic_limt2

write.csv(Mfreq_aic_limt, "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1__INDEX/Mfreq_aic_limt.csv")


#Peso das variveis+model avarege

Mfreq@objects
Mfreq_18_bio_ident_peso<- coef.glmulti(Mfreq)
write.csv(Mfreq_18_bio_ident_peso, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_18_bio_ident_peso.csv")
print(Mfreq_18_bio_ident_peso)

tiff(filename ="C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_18_bio_ident_peso_plot.tiff",width = 15, height = 15, units = 'cm', res = 300)
plot(Mfreq_18_bio_ident_peso, type="s")
dev.off()


L <- nrow(Mfreq_aic_limt2)

DF_R2_RMSE_cv <- NULL

Model_fitted_y <- NULL



for (i in 1:L){
  z <- as.formula(paste(Mfreq_aic_limt2$model[i]))
  y <- glm(formula=z, data = df,
            family= gaussian("identity")
  )
sumary_y <- summary(y)
fitted_y <-c(fitted.values(y))
R2 <-  c(cor(df$biomass_Tha,fitted.values(y))^2)
LOOCV <- cv.glm(df, y, K = nrow(df))
RMSE_cv<- (LOOCV$delta[1])^0.5
name <- paste0("y",i)
namesumary_y <- paste0("sumary_y",i)
namefitted_y <- paste0("fitted_y", i)
nameR2 <- paste0("R2",i)
nameLOOCV <- paste0("LOOCV",i)
nameRMSE_cv <- paste0("RMSE_cv", i)
assign(name, y)
assign(namesumary_y, sumary_y)
assign(namefitted_y,fitted_y)
assign(nameLOOCV, LOOCV)
R2_RMSE_cv<- data.frame(R2,RMSE_cv)
DF_R2_RMSE_cv <- rbind(DF_R2_RMSE_cv, R2_RMSE_cv)
Model_fitted_y <- cbind(Model_fitted_y, fitted_y)
}

lmp <- function (modelobject) {
  if (class(modelobject) != "lm") stop("Not an object of class 'lm' ")
  f <- summary(modelobject)$fstatistic
  if (is.null(f)==TRUE) {p<-0} else {p <- pf(f[1],f[2],f[3],lower.tail=F)}
  attributes(p) <- NULL
  return(p)
}

# o p-valor teste F

p.value <- numeric(L)


for(d in 1:L) {
  lmf2 <- as.formula(paste(Mfreq_aic_limt2$model[d]))
  lm2 <- lm(formula=lmf2, data = df)
  p.value[d]<- lmp(lm2)
}

print(p.value)

p.value <-data.frame(p.value) 
print(p.value)

#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

Mfreq_index <- merge( Mfreq_aic_limt2, DF_R2_RMSE_cv, by=0, all=TRUE)
print(Mfreq_index)
Mfreq_index <- merge(Mfreq_index, p.value, by=0, all=TRUE)
print(Mfreq_index)

Mfreq_index <- Mfreq_index[-1]

# Mfreq_index<-tbl_df(Mfreq_index)

Mfreq_index <- Mfreq_index%>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

print(Mfreq_index)
write.csv(Mfreq_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_index.csv")


##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)

Mfreq_index_ord <-arrange(Mfreq_index, RMSE_cv)
colnames(Mfreq_index_ord)[1] <- "Model_index_y"
print(Mfreq_index_ord)

write.csv(Mfreq_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_y <- as.formula(paste(Mfreq_index_ord$model[1]))
Est_y_RMSE_cvt<- glm(formula=Est_y, data = df,
                     family= gaussian(link="identity"))


Est_y_RMSE_cv <- tidy(Est_y_RMSE_cvt)


Est_y_RMSE_cv <- Est_y_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_y_RMSE_cv)

write.csv(Est_y_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Est_y_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_y) <- paste("y", 1:L, sep = "")
Model_fitted_y <- merge(df$biomass_Tha, Model_fitted_y, by=0, all=TRUE)
colnames(Model_fitted_y)[2] <- "biomass_Tha"

print(Model_fitted_y)

write.csv(Model_fitted_y, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Model_fitted_y.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((Mfreq@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(Mfreq@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(Mfreq@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesy <- names(Model_fitted_y)[3:ncol(Model_fitted_y)]
# print(colNamesy)
# 
# 
# for (s in colNamesy){
#   print(Mfreq_predic <- ggplot(Model_fitted_y,  aes_string("biomass_Tha", s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method= "glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("Mfreq_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }
# 

rm(list= ls()[!(ls() %in% c('df','Comb', 'Mfreqt', 'Mfreq_id', 
                            'Mfreq_index_ord', 'Est_y_RMSE_cv'))])
   
   
   
# ######################################################################################
# #
# # MODELOS GLM MULT LINK = LOG
# #
# ######################################################################################



Mfreq_log <- glmulti((biomass_Tha) ~ .,  data = df, 
                     level = 1,               # No interaction considered
                     method = "h",            # Exhaustive approach
                     crit = "aicc",            # AIC as criteria
                     confsetsize = Comb,         # Keep all model n^2 
                     plotty = F, report = F,  # plot or interim reports
                     fitfunction = "glm",
                     family = gaussian(link="log")
)     

#Mfreq_log@objects
Mfreq_logBest <- summary(Mfreq_log@objects[[1]])# selecr best model
print(Mfreq_logBest) 
Mfreq_log_aic_limt <- weightable(Mfreq_log)
Mfreq_log_aic_limt2 <- Mfreq_log_aic_limt[Mfreq_log_aic_limt$aicc <= min(Mfreq_log_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
Mfreq_log_aic_limt2

print(Mfreq_log_aic_limt)

L <- nrow(Mfreq_log_aic_limt2)

DF_R2L_RMSEL_cv <- NULL

Model_fitted_yL <- NULL



for (i in 1:L){
  zL <- as.formula(paste(Mfreq_log_aic_limt2$model[i]))
  yL <- glm(formula=zL, data = df,
            family= gaussian(link="log")
  )
  sumary_yL <- summary(yL)
  fitted_yL <-c(fitted.values(yL))
  R2L <-  c(cor(df$biomass_Tha,fitted.values(yL))^2)
  LOOCVL <- cv.glm(df, yL, K = nrow(df))
  RMSEL_cv<- (LOOCVL$delta[1])^0.5
  nameL <- paste0("yL",i)
  namesumary_yL <- paste0("sumary_yL",i)
  namefitted_yL <- paste0("fitted_yL", i)
  nameR2L <- paste0("R2L",i)
  nameLOOCVL <- paste0("LOOCVL",i)
  nameRMSEL_cv <- paste0("RMSEL_cv", i)
  assign(nameL, yL)
  assign(namesumary_yL, sumary_yL)
  assign(namefitted_yL,fitted_yL)
  assign(nameLOOCVL, LOOCVL)
  R2L_RMSEL_cv<- data.frame(R2L,RMSEL_cv)
  DF_R2L_RMSEL_cv <- rbind(DF_R2L_RMSEL_cv, R2L_RMSEL_cv)
  Model_fitted_yL <- cbind(Model_fitted_yL, fitted_yL)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

Mfreq_L_index <- merge( Mfreq_log_aic_limt2, DF_R2L_RMSEL_cv, by=0, all=TRUE)
print(Mfreq_L_index)
Red <- glm(formula=(biomass_Tha) ~ 1, data = df,
           family= gaussian(link="log"))



p.value <- numeric(L)
for (i in 1:L){
  tL <- as.formula(paste(Mfreq_log_aic_limt2$model[i]))
  tLf <- glm(formula=tL, data = df,
             family= gaussian(link="log"))
  tLf <-anova(Red,tLf, test="F")
  p.value[i] <- tLf[2,6]
}

print(p.value)
p.value<- data.frame(p.value)
Mfreq_L_index <- merge(Mfreq_L_index, p.value, by=0, all=TRUE)
print(Mfreq_L_index)
Mfreq_L_index <- Mfreq_L_index[-1]

Mfreq_L_index <- Mfreq_L_index %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

print(Mfreq_L_index)


write.csv(Mfreq_L_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_L_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEL_cv (descrescente ordem)

Mfreq_L_index_ord <-arrange(Mfreq_L_index, RMSEL_cv)
colnames(Mfreq_L_index_ord)[1] <- "Model_index_yL"
print(Mfreq_L_index_ord)

write.csv(Mfreq_L_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_L_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_yL <- as.formula(paste(Mfreq_L_index_ord$model[1]))
Est_yL_RMSE_cvt<- glm(formula=Est_yL, data = df,
                      family= gaussian(link="log"))


Est_yL_RMSE_cv <- tidy(Est_yL_RMSE_cvt)


Est_yL_RMSE_cv <- Est_yL_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_yL_RMSE_cv)

write.csv(Est_yL_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Est_yL_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_yL) <- paste("yL", 1:L, sep = "")
Model_fitted_yL <- merge(df$biomass_Tha, Model_fitted_yL, by=0, all=TRUE)
colnames(Model_fitted_yL)[2] <- "biomass_Tha"

print(Model_fitted_yL)

write.csv(Model_fitted_yL, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Model_fitted_yL.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_log_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((Mfreq_log@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_log_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(Mfreq_log@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_log_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(Mfreq_log@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyL <- names(Model_fitted_yL)[3:ncol(Model_fitted_yL)]
# print(colNamesyL)
# 
# 
# for (s in colNamesyL){
#   print(Mfreq_log_predic <- ggplot(Model_fitted_yL,  aes_string(Model_fitted_yL$biomass_Tha, s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method="glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("Mfreq_log_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }

rm(list= ls()[!(ls() %in% c('df','Comb', 'Mfreqt', 'Mfreq_id', 
'Mfreq_index_ord', 'Est_y_RMSE_cv', 
'Mfreq_L_index_ord', 'Est_yL_RMSE_cv'))])





# ######################################################################################
# #
# # MODELOS GLM MULT LINK = GAMA (LINK=LOG)
# #
# ######################################################################################
# 



Mfreq_gama <- glmulti((biomass_Tha) ~ .,  data = df, 
                        level = 1,               # No interaction considered
                        method = "h",            # Exhaustive approach
                        crit = "aicc",            # AIC as criteria
                        confsetsize = Comb,         # Keep all model n^2 
                        plotty = F, report = F,  # plot or interim reports
                        fitfunction = "glm",
                        family = Gamma(link= "log")
)     

#Mfreq_gama@objects
Mfreq_gamaBest <- summary(Mfreq_gama@objects[[1]])# selecr best model
print(Mfreq_gamaBest) 
Mfreq_gama_aic_limt <- weightable(Mfreq_gama)
Mfreq_gama_aic_limt2 <- Mfreq_gama_aic_limt[Mfreq_gama_aic_limt$aicc <= min(Mfreq_gama_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
Mfreq_gama_aic_limt2



L <- nrow(Mfreq_gama_aic_limt2)

DF_R2g_RMSEg_cv <- NULL

Model_fitted_yg <- NULL



for (i in 1:L){
  zg <- as.formula(paste(Mfreq_gama_aic_limt2$model[i]))
  yg <- glm(formula=zg, data = df,
            family= Gamma(link="log")
  )
  sumary_yg <- summary(yg)
  fitted_yg <-c(fitted.values(yg))
  R2g <-  c(cor(df$biomass_Tha,fitted.values(yg))^2)
  LOOCVg <- cv.glm(df, yg, K = nrow(df))
  RMSEg_cv<- (LOOCVg$delta[1])^0.5
  nameg <- paste0("yg",i)
  namesumary_yg <- paste0("sumary_yg",i)
  namefitted_yg <- paste0("fitted_yg", i)
  nameR2g <- paste0("R2g",i)
  nameLOOCVg <- paste0("LOOCVg",i)
  nameRMSEg_cv <- paste0("RMSEg_cv", i)
  assign(nameg, yg)
  assign(namesumary_yg, sumary_yg)
  assign(namefitted_yg,fitted_yg)
  assign(nameLOOCVg, LOOCVg)
  R2g_RMSEg_cv<- data.frame(R2g,RMSEg_cv)
  DF_R2g_RMSEg_cv <- rbind(DF_R2g_RMSEg_cv, R2g_RMSEg_cv)
  Model_fitted_yg <- cbind(Model_fitted_yg, fitted_yg)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

Mfreq_g_index <- merge( Mfreq_gama_aic_limt2, DF_R2g_RMSEg_cv, by=0, all=TRUE)
print(Mfreq_g_index)

write.csv(Mfreq_g_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_g_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEg_cv (descrescente ordem)

Mfreq_g_index_ord <-arrange(Mfreq_g_index, RMSEg_cv)
colnames(Mfreq_g_index_ord)[1] <- "Model_index_YG"
print(Mfreq_g_index_ord)

write.csv(Mfreq_g_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_g_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_yg <- as.formula(paste(Mfreq_g_index_ord$model[1]))
Est_yg_RMSE_cvt<- glm(formula=Est_yg, data = df,
          family= Gamma(link="log"))


Est_yg_RMSE_cv <- tidy(Est_yg_RMSE_cvt)


Est_yg_RMSE_cv <- Est_yg_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))
  


print(Est_yg_RMSE_cv)

write.csv(Est_yg_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Est_yg_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_yg) <- paste("YG", 1:L, sep = "")
Model_fitted_yg <- merge(df$biomass_Tha, Model_fitted_yg, by=0, all=TRUE)
colnames(Model_fitted_yg)[2] <- "biomass_Tha"

print(Model_fitted_yg)

write.csv(Model_fitted_yg, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Model_fitted_yg.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
# mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_gama_resid_", names[p], ".tiff", sep = ""))
# tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
# mytitle = paste("Model", names[p])
# par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
# plot((Mfreq_gama@objects[[p]]), main = mytitle)
# dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
# mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_gama_resid2_", names[p], ".tiff", sep = ""))
# tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
# mytitle = paste("Residuals", names[p])
# plot(residuals(Mfreq_gama@objects[[p]]), main = mytitle, ylab="Residual") 
# dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
# mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_gama_resid_stanad_", names[p], ".tiff", sep = ""))
# tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
# mytitle = paste("Residuals standard", names[p])
# plot(residuals_standard <-  rstandard(Mfreq_gama@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
# dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyg <- names(Model_fitted_yg)[3:ncol(Model_fitted_yg)]
# print(colNamesyg)
# 
# 
# for (s in colNamesyg){
# print(Mfreq_Gama_predic <- ggplot(Model_fitted_yg,  aes_string(Model_fitted_yg$biomass_Tha, s)) +
#   geom_point(shape=16, size=1) +
#   geom_smooth(method= "glm", size=0.5) +
#   theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#         axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#         axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#         axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#         panel.background = element_blank(),
#         panel.grid.major = element_line(colour =  "grey80"), 
#         panel.grid.minor = element_blank(), 
#         axis.line.x=element_line(),
#         axis.line.y=element_line()) +
#   xlab (label = "AGB") +
#   ylab (label = "fitted.valuesed AGB")+
#     scale_x_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)) +
#     scale_y_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)))
# 
# ggsave(filename=paste("Mfreq_Gama_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }


#### Removendo tabelas que no seram mais usadas


rm(list= ls()[!(ls() %in% c('df','Comb', 'Mfreqt', 'Mfreq_id', 
                            'Mfreq_index_ord', 'Est_y_RMSE_cv', 
                            'Mfreq_L_index_ord', 'Est_yL_RMSE_cv',
                            'Mfreq_g_index_ord', 'Est_yg_RMSE_cv'))]) 



# ######################################################################################
# #
# # MODELOS LM LOG(Y)
# #
# ######################################################################################
# 




Mfreq_lmLogy <- glmulti((log(biomass_Tha)) ~ .,  data = df, 
                        level = 1,               # No interaction considered
                        method = "h",            # Exhaustive approach
                        crit = "aicc",            # AIC as criteria
                        confsetsize = Comb,         # Keep all model n^2 
                        plotty = F, report = F,  # plot or interim reports
                        fitfunction = "lm"
                        
)     

Mfreq_lmLogy@objects
Mfreq_lmLogyBest <- summary(Mfreq_lmLogy@objects[[1]])# selecr best model
print(Mfreq_lmLogyBest) 
Mfreq_lmLogy_aic_limt <- weightable(Mfreq_lmLogy)
Mfreq_lmLogy_aic_limt2 <- Mfreq_lmLogy_aic_limt[Mfreq_lmLogy_aic_limt$aicc <= min(Mfreq_lmLogy_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
Mfreq_lmLogy_aic_limt2

Mfreq_lmLogy_aic_limt2

Mfreq_lmLogyBest
L <- nrow(Mfreq_lmLogy_aic_limt2)



m = nrow(Mfreq_lmLogy_aic_limt2)
print(m)
RMSE_lmLogy <- numeric(m)  # GUARDA OS rmseLLCV PARA N MDOELOS SELECIONADOS 


# PASSANDO PARA TABLE 

Mfreqtt<-tbl_df(Mfreqt)
n = nrow(Mfreqtt)
print(n)
em <-numeric(n)    # GUARDA OS ERROS PARA N OBSERVAES


for(j in 1:m) {
  for(k in 1:n){
    lmcv<- Mfreqtt[-k, ]
    lmf <- as.formula(paste(Mfreq_lmLogy_aic_limt2$model[j]))
    lm <- lm(formula=lmf, data = lmcv)
    lmes <- fitted.values(lm, Mfreqtt[k, ])
    lmexp<-exp(lmes)
    em[k] <- (Mfreqtt[k, 1] - lmexp)
    RMSE_lmLogy[j] <- (mean(as.numeric(em)^2))^0.5
  } 
}

print(RMSE_lmLogy)


Model_fitted_lmLogy <- NULL

for (h in 1:L){
  zlmLogy <- as.formula(paste(Mfreq_lmLogy_aic_limt2$model[h]))
  lmLogy <- lm(formula=zlmLogy, data = df)
  fitted_lmLogy <- fitted.values(lmLogy)
  namefitted_lmLogy <- paste0("fitted_lmLogy", h)
  assign(namefitted_lmLogy,fitted_lmLogy)
  Model_fitted_lmLogy <- cbind(Model_fitted_lmLogy, fitted_lmLogy)
}

print(fitted_lmLogy)
print(Model_fitted_lmLogy)

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_lmLogy) <- paste("lmLogy", 1:L, sep = "")
Model_fitted_lmLogy <- merge(log(df$biomass_Tha), Model_fitted_lmLogy, by=0, all=TRUE)
colnames(Model_fitted_lmLogy)[2] <- "biomass_Tha"

print(Model_fitted_lmLogy)

write.csv(Model_fitted_lmLogy, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Model_fitted_lmLogy.csv")



# Calcular R^2 na escala

lmR <-numeric(m)

for(r in 1:m) {
  lmf <- as.formula(paste(Mfreq_lmLogy_aic_limt2$model[r]))
  lm <- lm(formula=lmf, data = df)
  lmR1<- fitted.values(lm)
  lmR2<- exp(lmR1)
  lmR[r] <-  cor(df$biomass_Tha,lmR2)^2
}

print(lmR)
# 
lmp <- function (modelobject) {
  if (class(modelobject) != "lm") stop("Not an object of class 'lm' ")
  f <- summary(modelobject)$fstatistic
  if (is.null(f)==TRUE) {p<-0} else {p <- pf(f[1],f[2],f[3],lower.tail=F)}
  attributes(p) <- NULL
  return(p)
}
print(lmp)

# Extrair o R^2 na escala logaritimica
lmRR <- numeric(m)
p.value <- numeric(m)


for(d in 1:m) {
  lmf2 <- as.formula(paste(Mfreq_lmLogy_aic_limt2$model[d]))
  lm2 <- lm(formula=lmf2, data = df)
  lmRR[d]<- summary.lm(lm2)$r.squared
  p.value[d]<- lmp(lm2)
}

print(lmRR)

#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

DF_R2_lmLogy_RMSEL_cv<- data.frame(lmR,RMSE_lmLogy,p.value)
print(DF_R2_lmLogy_RMSEL_cv)

Mfreq_lmLogy_index <- merge(Mfreq_lmLogy_aic_limt2, DF_R2_lmLogy_RMSEL_cv, by=0, all=TRUE)
print(Mfreq_lmLogy_index)

Mfreq_lmLogy_index <- Mfreq_lmLogy_index %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))


write.csv(Mfreq_lmLogy_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_lmLogy_index.csv")

print(Mfreq_lmLogy_index)

##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)


Mfreq_lmLogy_index_ord <-arrange(Mfreq_lmLogy_index, RMSE_lmLogy)
colnames(Mfreq_lmLogy_index_ord)[1] <- "Model_index_lmLogy"
print(Mfreq_lmLogy_index_ord)

write.csv(Mfreq_lmLogy_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Mfreq_lmLogy_index_ord.csv")

print(Mfreq_lmLogy_index_ord)


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_lmLogy <- as.formula(paste(Mfreq_lmLogy_index_ord$model[1]))
Est_lmLogy_RMSE_cvt<- lm(formula=Est_lmLogy, data = df)


Est_lmLogy_RMSE_cv <- tidy(Est_lmLogy_RMSE_cvt)


Est_lmLogy_RMSE_cv <- Est_lmLogy_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

print(Est_lmLogy_RMSE_cv)

write.csv(Est_lmLogy_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/Est_lmLogy_RMSE_cv.csv")


#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_lmLogy_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((Mfreq_lmLogy@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_lmLogy_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(Mfreq_lmLogy@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT",paste("Mfreq_lmLogy_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(Mfreq_lmLogy@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# 
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNameslmLogy <- names(Model_fitted_lmLogy)[3:ncol(Model_fitted_lmLogy)]
# print(colNameslmLogy)
# 
# 
# # Add as caracteris in ggplot
# 
# FUN <- function(dat, x, y) {
#   ggplot(dat, aes_string(x = x, y = y)) +
#     geom_point(shape=16, size=1) 
#   
#   
# }
# 
# for (F in colNameslmLogy){
#   Mfreq_logy_predic<- FUN(Model_fitted_lmLogy, 'biomass_Tha', F)+
#     geom_smooth(method = "lm") +
#     theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#           axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#           axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#           axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#           panel.background = element_blank(),
#           panel.grid.major = element_line(colour =  "grey80"),
#           panel.grid.minor = element_blank(),
#           axis.line.x=element_line(),
#           axis.line.y=element_line()) +
#     xlab (label = "AGB") +
#     ylab (label = "fitted.valuesed AGB")
#   
#   
#   print(Mfreq_logy_predic)
#   ggsave(filename=paste("Mfreq_logy_predic",F,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }
# 


rm(list= ls()[!(ls() %in% c('df','Comb', 'Mfreqt', 'Mfreq_id', 
                            'Mfreq_index_ord', 'Est_y_RMSE_cv', 
                            'Mfreq_L_index_ord', 'Est_yL_RMSE_cv',
                            'Mfreq_g_index_ord', 'Est_yg_RMSE_cv',
                            'Mfreq_lmLogy_index_ord','Est_lmLogy_RMSE_cv','FUN'))]) 




# ######################################################################################
# #
# # Organizando os resultados best model de cada mtodo
# #
# ######################################################################################
# 


# Criando um data frame com os resultados 
Result_mult_18_F <- NULL

# Padronizando o nome das colunas

Best_18_GLM_GAUSS_INDENT <-  Mfreq_index_ord %>%
  rename(Model_index = Model_index_y)%>%
  mutate("Model/Distr/Link" = "GLM/GAUSSIAN/IDENTFIC")%>%
  slice(1) 
  
Best_18_GLM_GAUSS_LOG <- Mfreq_L_index_ord%>%
  rename(R2 = R2L)%>%
  rename(Model_index = Model_index_yL)%>%
  rename(RMSE_cv = RMSEL_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "GLM/GAUSSIAN/LOG")

Best_18_GLM_GAMMA_LOG <- Mfreq_g_index_ord%>%
  rename(R2 = R2g)%>% 
  rename(Model_index = Model_index_YG)%>%
  rename(RMSE_cv = RMSEg_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "GLM/GAMMA/LOG")

Best_18_LM_LOGy <- Mfreq_lmLogy_index_ord%>%
  rename(R2 = lmR)%>%
  rename(Model_index = Model_index_lmLogy)%>%
  rename(RMSE_cv = RMSE_lmLogy)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "LM/log(y)")


# Juntando as tabelas com os melhores modelos 

Result_mult_18_F <- rbind(Best_18_GLM_GAUSS_INDENT, Best_18_GLM_GAUSS_LOG)

# Reordenando pelo RMSE_cv e trocando a ordem da coluna com os tipos de modelos

Result_mult_18_F <-arrange(Result_mult_18_F, RMSE_cv)

#Removendo a coluna peso 

Result_mult_18_F <- subset(Result_mult_18_F, select=-weights)


# Function moveme
moveMe <- function(data, tomove, where = "last", ba = NULL) {
  temp <- setdiff(names(data), tomove)
  x <- switch(
    where,
    first = data[c(tomove, temp)],
    last = data[c(temp, tomove)],
    before = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)-1))]
    },
    after = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)))]
    })
  x
}
  
Result_mult_18_Fim<-moveMe(Result_mult_18_F, c("Model/Distr/Link"), "first")

Result_mult_18_Fim

write.csv(Result_mult_18_Fim, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/RESULTS/Result_mult_18_Fim.csv")





