# install.packages("raster")
# install.packages ("rgdal")
# install.packages("MASS")
# install.packages("sp")
# install.packages("dismo")
# install.packages("XML")
# install.packages("maps")
# install.packages("dplyr")
# install.packages("broom")
# install.packages("tidyr")
# install.packages("data.table")
# install.packages("rasterVis")




library(dismo)
library(XML)
library(maps)
library(raster)
library(rgdal)
library(MASS)
library(sp)
library(dplyr)
library(broom)
library(tidyr)
library(data.table)
library(rasterVis)
library(ggplot2)

## Pasta onde esta a/ ou as imagens *tiff

setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS")

mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS"  ####### c
dir.create("1_MULT_bio")  ####### c


setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio"
dir.create("HIST")
dir.create("Predic")



setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/Imagens_100")

list <- list.files(pattern = glob2rx('*.tif'), full.names=TRUE)
print(list)


MULT_100_BANDS_R <- stack(list[1])
MULT_100_BANDS_R2 <- brick(MULT_100_BANDS_R)


names(MULT_100_BANDS_R2)



band_names = c('rs2_hh_db',	'rs2_hv_db',	'rs2s_hv_hh_db',	'rs2_hvmhh_db',	'alos_hh_db',	'alos_hv_db',	'alos_hv_hh_db',	
               'alos_hvmhh_db',	'tsx_hh_db')




names(MULT_100_BANDS_R2) <- band_names

writeRaster(x=MULT_100_BANDS_R2, filename='MULT_100_BANDS_R2.grd', datatype='FLT8S', overwrite=TRUE)
writeRaster(x=MULT_100_BANDS_R2, filename='C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1Bio_18_MULT/MULT_100_BANDS_R2.tif', datatype='FLT8S', overwrite=TRUE)

names(MULT_100_BANDS_R2)


dB <- function (x){
  options(digits=10)
  10*log10(x)
}

rs2_hh_db	<-dB(MULT_100_BANDS_R2[["rs2_hh_db"]])
rs2_hv_db	<-dB(MULT_100_BANDS_R2[["rs2_hv_db"]])
alos_hh_db 	<-dB(MULT_100_BANDS_R2[["alos_hh_db"]])
alos_hv_db	<-dB(MULT_100_BANDS_R2[["alos_hv_db"]])
tsx_hh_db	<-dB(MULT_100_BANDS_R2[["tsx_hh_db"]])



db_l <- addLayer(rs2_hh_db,	rs2_hv_db,	alos_hh_db ,	alos_hv_db,	tsx_hh_db)
names(db_l)

band_names_db = (c('rs2_hh_db',	'rs2_hv_db',	'alos_hh_db ',	'alos_hv_db',	'tsx_hh_db'))

names(db_l) <- band_names_db

names(db_l)

# Vc pode tratar as imagens como vetor
sel <- subset(MULT_100_BANDS_R2, 3:4)
names(sel)

sel2 <- subset(MULT_100_BANDS_R2, 7:8)
names(sel2)

MULT_100_BANDS_Rdb <- addLayer(db_l, sel, sel2)
names(MULT_100_BANDS_Rdb)


writeRaster(x=MULT_100_BANDS_Rdb, filename='MULT_100_BANDS_Rdb.grd', datatype='FLT8S', overwrite=TRUE)

writeRaster(x=MULT_100_BANDS_Rdb, filename='C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/MULT_100_BANDS_Rdb.tif', datatype='FLT8S', overwrite=TRUE)



# Criando mascara
masc <- subset(MULT_100_BANDS_Rdb,1)
masc[masc == 0] <- NA




# FUNO PARA PASSAR IMAGEM PARA DATAFRAME
as.data.table.raster <- function(x, row.names = NULL, optional = FALSE, xy=FALSE, inmem = canProcessInMemory(x, 2), ...) {
  stopifnot(require("data.table"))
  if(inmem) {
    v <- as.data.table(as.data.frame(x, row.names=row.names, optional=optional, xy=xy, ...))
  } else {
    tr <- blockSize(x, n=2)
    l <- lapply(1:tr$n, function(i) 
      as.data.table(as.data.frame(getValues(x, 
                                            row=tr$row[i], 
                                            nrows=tr$nrows[i]), 
                                  row.names=row.names, optional=optional, xy=xy, ...)))
    v <- rbindlist(l)
  }
  coln <- names(x)
  if(xy) coln <- c("x", "y", coln)
  setnames(v, coln)
  v
}

if (!isGeneric("as.data.table")) {
  setGeneric("as.data.table", function(x, ...)
    standardGeneric("as.data.table"))
}  

setMethod('as.data.table', signature(x='data.frame'), data.table::as.data.table)
setMethod('as.data.table', signature(x='Raster'), as.data.table.raster)



########### LOG

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_tb_total")
All_atrib <- read.csv("Mfreq.csv", header=TRUE, sep=",")


setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT")
MODEL_index_ord <- read.csv("Mfreq_L_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord = MODEL_index_ord[!MODEL_index_ord$p.value > 0.05,]



glimpse(MODEL_index_ord)

L <- nrow(MODEL_index_ord)

## NO ESQUECER DE TROCAR A PASTA DESTA FUNO E O NOME
outlierKD <- function(dt, var) {
  h2 <- paste0('MULTP_100_18_LOG_BIO_', s, '.tiff')
  outli <- file.path("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/HIST",h2)
  tiff(file=outli)
  var_name <- eval(substitute(var),eval(dt))
  tot <- sum(!is.na(var_name))
  na1 <- sum(is.na(var_name))
  m1 <- mean(var_name, na.rm = T)
  par(mfrow=c(2, 2), oma=c(0,0,3,0))
  boxplot(var_name, main="With outliers")
  hist(var_name, main="With outliers", xlab=NA, ylab=NA)
  outlier <- boxplot.stats(var_name)$out
  mo <- mean(outlier)
  var_name <- ifelse(var_name %in% outlier, NA, var_name)
  boxplot(var_name, main="Without outliers")
  hist(var_name, main="Without outliers", xlab=NA, ylab=NA)
  title("Outlier Check", outer=TRUE)
  dev.off()
} 


outlier_LIMIAR<- function(dt, var) {
  h2 <- paste0('MULTP_100_18_LOG_600_BIO_', s, '.tiff')
  outli <- file.path("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/HIST",h2)
  tiff(file=outli)
  var_name <- eval(substitute(var),eval(dt))
  tot <- sum(!is.na(var_name))
  na1 <- sum(is.na(var_name))
  m1 <- mean(var_name, na.rm = T)
  par(mfrow=c(2, 2), oma=c(0,0,3,0))
  boxplot(var_name, main="With outliers")
  hist(var_name, main="With outliers", xlab=NA, ylab=NA)
  outlier <- boxplot.stats(var_name)$out
  mo <- mean(outlier)
  var_name <- ifelse(var_name %in% outlier, NA, var_name)
  boxplot(var_name, main="Without outliers")
  hist(var_name, main="Without outliers", xlab=NA, ylab=NA)
  title("Outlier Check", outer=TRUE)
  dev.off()
} 

setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio"  ####### c
dir.create("1_MULT_bio_18_760")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/1_MULT_bio_18_760')



for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(MULT_100_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  
  
  ras[ras > 760] <- 760
  
  f <- paste0('MULTP_760_LOG_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}



setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio"  ####### c
dir.create("1_MULT_bio_18_600")  ####### c

write.csv(MODEL_index_ord, "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/MODEL_18_log.csv") 

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/1_MULT_bio_18_600')



for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(MULT_100_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  gg<-ras
  
  gww<- as.data.table.raster(gg)
  gww = gww[!(is.na(gww$layer)),]
  gww = gww[!gww$layer == 0,]
  outlierKD(gww, layer) 
  
  
  ras[ras > 600] <- 600
  gL<-ras
  
  gL<- as.data.table.raster(gL)
  gL = gL[!(is.na(gL$layer)),]
  gL = gL[!gL$layer == 0,]
  outlier_LIMIAR(gL, layer) 
  f <- paste0('MULTP_600_LOG_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}


setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio"  ####### c
dir.create("1_MULT_bio_18_250")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/1_MULT_bio_18_250')

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(MULT_100_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  
  ras[ras > 250] <- 250
  
  f <- paste0('MULTP_250_LOG_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}








################### Functions outliers

is_outlier_min <- function(x) {
  return(x < quantile(x, 0.25) - 1.5 * IQR(x))
}

is_outlier_max <- function(x) {
  return(x > quantile(x, 0.75) + 1.5 * IQR(x))
}



setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio"  ####### c
dir.create("1_MULT_bio_18_out")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/1_MULT_bio_18_out')

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(MULT_100_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  gg<-ras
  
  gww<- as.data.table.raster(gg)
  gww = gww[!(is.na(gww$layer)),]
  gww = gww[!gww$layer == 0,]
   
  gww2 <- gww %>%
    mutate(outlier_min = ifelse(is_outlier_min(layer), layer, as.numeric(NA)))%>%
    mutate(outlier_max = ifelse(is_outlier_max(layer), layer, as.numeric(NA)))
  
  Max_L1 <- min(gww2$outlier_max,na.rm=TRUE)
  
  print(Max_L1)
  
  Min_L1 <-  max(gww2$outlier_min, na.rm=TRUE)
  print(Min_L1)
  
  Max_L <- ifelse(Max_L1 == -Inf, max(gww$layer),  Max_L1) 
  print(Max_L)
  
  Min_L <- ifelse(Min_L1 == -Inf, min(gww$layer),  Min_L1) 
  print(Min_L)
  
  
  ras[ras > Max_L] <- Max_L
  ras[ras < Min_L] <- Min_L
  
  f <- paste0('MULTP_out_LOG_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}






















########### IDENT

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_tb_total")
All_atrib <- read.csv("Mfreq.csv", header=TRUE, sep=",")


setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT")
MODEL_index_ord <- read.csv("Mfreq_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord = MODEL_index_ord[!MODEL_index_ord$p.value > 0.05,]



glimpse(MODEL_index_ord)

L <- nrow(MODEL_index_ord)

## NO ESQUECER DE TROCAR A PASTA DESTA FUNO E O NOME
outlierKD <- function(dt, var) {
  h2 <- paste0('MULTP_100_18_IDENT_BIO_', s, '.tiff')
  outli <- file.path("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/HIST",h2)
  tiff(file=outli)
  var_name <- eval(substitute(var),eval(dt))
  tot <- sum(!is.na(var_name))
  na1 <- sum(is.na(var_name))
  m1 <- mean(var_name, na.rm = T)
  par(mfrow=c(2, 2), oma=c(0,0,3,0))
  boxplot(var_name, main="With outliers")
  hist(var_name, main="With outliers", xlab=NA, ylab=NA)
  outlier <- boxplot.stats(var_name)$out
  mo <- mean(outlier)
  var_name <- ifelse(var_name %in% outlier, NA, var_name)
  boxplot(var_name, main="Without outliers")
  hist(var_name, main="Without outliers", xlab=NA, ylab=NA)
  title("Outlier Check", outer=TRUE)
  dev.off()
} 


outlier_LIMIAR<- function(dt, var) {
  h2 <- paste0('MULTP_100_18_IDENT_600_BIO_', s, '.tiff')
  outli <- file.path("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/HIST",h2)
  tiff(file=outli)
  var_name <- eval(substitute(var),eval(dt))
  tot <- sum(!is.na(var_name))
  na1 <- sum(is.na(var_name))
  m1 <- mean(var_name, na.rm = T)
  par(mfrow=c(2, 2), oma=c(0,0,3,0))
  boxplot(var_name, main="With outliers")
  hist(var_name, main="With outliers", xlab=NA, ylab=NA)
  outlier <- boxplot.stats(var_name)$out
  mo <- mean(outlier)
  var_name <- ifelse(var_name %in% outlier, NA, var_name)
  boxplot(var_name, main="Without outliers")
  hist(var_name, main="Without outliers", xlab=NA, ylab=NA)
  title("Outlier Check", outer=TRUE)
  dev.off()
} 

setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio"  ####### c
dir.create("1_MULT_bio_18_IDENT_760")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/1_MULT_bio_18_IDENT_760')



for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(MULT_100_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  
  
  ras[ras > 760] <- 760
  
  f <- paste0('MULTP_760_IDENT_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}



setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio"  ####### c
dir.create("1_MULT_bio_18_IDENT_600")  ####### c

write.csv(MODEL_index_ord, "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/MODEL_18_IDENT.csv") 

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/1_MULT_bio_18_IDENT_600')



for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(MULT_100_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  gg<-ras
  
  gww<- as.data.table.raster(gg)
  gww = gww[!(is.na(gww$layer)),]
  gww = gww[!gww$layer == 0,]
  outlierKD(gww, layer) 
  
  
  ras[ras > 600] <- 600
  gL<-ras
  
  gL<- as.data.table.raster(gL)
  gL = gL[!(is.na(gL$layer)),]
  gL = gL[!gL$layer == 0,]
  outlier_LIMIAR(gL, layer) 
  f <- paste0('MULTP_600_IDENT_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}


setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio"  ####### c
dir.create("1_MULT_bio_18_IDENT_250")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/1_MULT_bio_18_IDENT_250')

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(MULT_100_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  
  ras[ras > 250] <- 250
  
  f <- paste0('MULTP_250_IDENT_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}








################### Functions outliers

is_outlier_min <- function(x) {
  return(x < quantile(x, 0.25) - 1.5 * IQR(x))
}

is_outlier_max <- function(x) {
  return(x > quantile(x, 0.75) + 1.5 * IQR(x))
}



setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio"  ####### c
dir.create("1_MULT_bio_18_IDENT_out")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/1_MULT_bio_18_IDENT_out')

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(MULT_100_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  gg<-ras
  
  gww<- as.data.table.raster(gg)
  gww = gww[!(is.na(gww$layer)),]
  gww = gww[!gww$layer == 0,]
  
  gww2 <- gww %>%
    mutate(outlier_min = ifelse(is_outlier_min(layer), layer, as.numeric(NA)))%>%
    mutate(outlier_max = ifelse(is_outlier_max(layer), layer, as.numeric(NA)))
  
  Max_L1 <- min(gww2$outlier_max,na.rm=TRUE)
  
  print(Max_L1)
  
  Min_L1 <-  max(gww2$outlier_min, na.rm=TRUE)
  print(Min_L1)
  
  Max_L <- ifelse(Max_L1 == -Inf, max(gww$layer),  Max_L1) 
  print(Max_L)
  
  Min_L <- ifelse(Min_L1 == -Inf, min(gww$layer),  Min_L1) 
  print(Min_L)
  
  
  ras[ras > Max_L] <- Max_L
  ras[ras < Min_L] <- Min_L
  
  f <- paste0('MULTP_out_IDENT_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}

