# install.packages("raster")
# install.packages ("rgdal")
# install.packages("MASS")
# install.packages("sp")
# install.packages("dismo")
# install.packages("XML")
# install.packages("maps")
# install.packages("dplyr")
# install.packages("broom")
# install.packages("tidyr")
# install.packages("data.table")
# install.packages("reshape2")
# install.packages("ggplot2")
# install.packages("plyr")
# install.packages("scales")
# install.packages("foreign")
# install.packages("car")
# install.packages("DAAG")
# install.packages("MASS")
# install.packages("leaps")
# install.packages("car")
# install.packages("bootStepAIC")
# install.packages("forecast")
# install.packages("glmulti")
# install.packages("rJava")
# install.packages("ISLR")
# install.packages("boot")
# install.packages("gridExtra")




library(dismo)
library(XML)
library(maps)
library(raster)
library(rgdal)
library(MASS)
library(sp)
library(dplyr)
library(broom)
library(tidyr)
library(data.table)
library(leaps)
library(reshape2) 
library(ggplot2)
library(plyr)
library(scales)
library(foreign)
library(car)
library(randomForest)
library(DAAG)
library(MASS)
library(bootStepAIC)
library(leaps)
library(forecast)
library(glmulti)
library(rJava)
library(ISLR)
library(boot)
library(broom)
library(grid)
library(gridExtra)
library(ggpmisc)

options(digits=6)


# 1Bio_18_MULT pela nova pasta xxxxxxx


#  1Bio_16_MULT pena nova pasta xxxxxxxxxxxxxxx


 # 1_MULT_bio  pena nova pasta xxxxxxxxxxxxxxx

############# LOG Y (escala log)


setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_tb_total")
All_atrib_18 <- read.csv("Mfreq.csv", header=TRUE, sep=",")
All_atrib_18 <- All_atrib_18%>%
  mutate(biomass_Tha = log(biomass_Tha))

glimpse(All_atrib_18)

fit_y <- NULL

R2_18 <- NULL


setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT")
MODEL_index_ord <- read.csv("Mfreq_lmLogy_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X.1 == 4) , ]


z <- as.formula(paste(MODEL_index_ord$model))


y_18 <- lm(formula= z, data=All_atrib_18)
fit_y <-c(fitted.values(y_18))
print(fit_y)
biomass_Tha<- All_atrib_18$biomass_Tha
R2_18 <-  c(cor(biomass_Tha,predict(y_18))^2)
fit <- cbind(biomass_Tha, fit_y)
fit_PAL_18<- as.data.frame(fit)
fit_PAL_18$id <- (nrow(fit_PAL_18))
fit_PAL_18$id2 <- seq_len(nrow(fit_PAL_18))

R2_18 <-(round(R2_18, 2))

L_r2x18 <- 5.6
L_r2y18 <- ((max(fit_y)))

glimpse(MODEL_index_ord)
RM_r2x18 <- round(MODEL_index_ord$Mfreq_RMSE_lmLogy[1], 2)


rm(fit_y, biomass_Tha, fit, y_18)

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_MULT/16_mult_tb_total")
All_atrib_16 <- read.csv("Mfreq.csv", header=TRUE, sep=",")
All_atrib_16 <- All_atrib_16%>%
  mutate(biomass_Tha = log(biomass_Tha))

fit_y <- NULL
R2_16 <- NULL

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_MULT")
MODEL_index_ord <- read.csv("Mfreq_lmLogy_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X ==3) , ]

z <- as.formula(paste(MODEL_index_ord$model))

y_16 <- lm(formula=z, data=All_atrib_16)
biomass_Tha<- All_atrib_16$biomass_Tha
R2_16 <-  c(cor(biomass_Tha,predict(y_16))^2)
fit_y <-c(fitted.values(y_16))
fit <- cbind(biomass_Tha, fit_y)
fit_PAL_16<- as.data.frame(fit)
fit_PAL_16$id <- (nrow(fit_PAL_16))
fit_PAL_16$id2 <- seq_len(nrow(fit_PAL_16))

#### Localizao R2 no grafico 

L_r2x16 <- ((max(biomass_Tha))+((max(biomass_Tha))*0.04))
L_r2y16 <- ((mean(fit_y))+((mean(fit_y))*0.02))

RM_r2x16 <- round(MODEL_index_ord$Mfreq_RMSE_lmLogy[1], 2)

ver <- merge(fit_PAL_16, fit_PAL_18, all=TRUE)

R2_16 <-(round(R2_16, 2))


rm(fit_y, biomass_Tha, fit, y_16)

write.csv(ver , "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/Predic/fit_Bio_log_y_PAL.csv")





myColors <- c('grey40', 'black')
names(myColors) <- levels(ver$id)
point_color <- scale_colour_manual(name = "Number of sample (AGB)",values = myColors)

shape1<- c(8, 16)
names(shape1)<-levels(ver$id)
point_sape <- scale_shape_manual("Number of sample (AGB)",values = shape1) 

setwd('C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/Predic')


a <- ggplot(data = ver,aes(biomass_Tha,fit_y)) 
b <- a + geom_point(aes(colour = factor(id), shape=factor(id)), size = 1, stroke = 1)
c <- b + geom_smooth(aes(colour = factor(id)), method = "glm", size=1)
d <- c + point_sape + point_color
f_log_y<-d+theme(axis.text.x = element_text(angle = 50,hjust=1, vjust=1.2,color="black", size = 6),
              axis.title.x = element_text(size=7, hjust=0.5, vjust=0),
              axis.text.y = element_text(angle = 0,hjust=1, vjust=0.2,color="black", size = 6),
              axis.title.y = element_text(size=7, hjust=0.5, vjust=0),
              panel.background = element_blank(),
              panel.grid.major = element_line(colour =  "grey95"), 
              panel.grid.minor = element_blank(), 
              axis.line.x=element_line(),
              axis.line.y=element_line(),
           legend.position= c(0, 1),  # troca a posio da legenda
           legend.background = element_rect(fill = "white", colour = "black", size = 0.5),
           legend.key = element_rect(fill = "white", colour="black", size=NULL),
           legend.key.size = unit(0.4, "cm"),
           legend.text = element_text(size = 6, colour = "black", angle = 0),
           legend.justification = c(0, 1),  # Trocar a posio da legenda
           legend.title= element_text(size=6, hjust=0.5, vjust=1.5)) +
        xlab (label = "AGB [t/ha]" ) +
        ylab (label = "Predicted AGB [t/ha] E(logYi)")+
        scale_x_continuous(breaks = round(seq(min(0), max(ver$biomass_Tha), by = 0.2),1)) +
        scale_y_continuous(breaks = round(seq(min(0), max(ver$fit_y), by = 0.2),1))+
        coord_fixed(ratio = 1)+
        annotate("text", x = L_r2x16, y=L_r2y16 , label = paste("(16) R=",R2_16), size=2)+
        annotate("text", x = L_r2x18, y=L_r2y18, label = paste("(18) R=",R2_18), size=2)+
  ggtitle(paste("RMSEcv(18) =",RM_r2x18," RMSEcv(16) =",RM_r2x16)) + 
  theme(plot.title = element_text(size=7,hjust = 0.5))


 

plot(f_log_y)

ggsave(filename = "f_log_y.png", units = "cm", width = 7, height = 7, dpi = 300)


rm(ver, fit_PAL_16, fit_PAL_18, a, b, c, d, R2_16, R2_18, L_r2x16, L_r2y16, L_r2x18, L_r2y18)




############# LOG Y (sem estar na escala log ---exp)


setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_tb_total")
All_atrib_18 <- read.csv("Mfreq.csv", header=TRUE, sep=",")
All_atrib_18 <- All_atrib_18%>%
  mutate(biomass_Tha = log(biomass_Tha))

fit_y <- NULL

R2_18_log_exp <- NULL

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT")
MODEL_index_ord <- read.csv("Mfreq_lmLogy_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X.1 == 1) , ]

z <- as.formula(paste(MODEL_index_ord$model))


y_18 <- lm(formula=z, data=All_atrib_18)
fit_y <-c(fitted.values(y_18))

print(fit_y)
fit_y <- exp(fit_y)
print(fit_y)
biomass_Tha<- exp(All_atrib_18$biomass_Tha)
R2_18_log_exp <-  c(cor(biomass_Tha,fit_y)^2)
fit <- cbind(biomass_Tha, fit_y)
fit_PAL_18<- as.data.frame(fit)
fit_PAL_18$id <- (nrow(fit_PAL_18))
fit_PAL_18$id2 <- seq_len(nrow(fit_PAL_18))

print(R2_18_log_exp)

R2_18_log_exp <-(round(R2_18_log_exp, 2))

L_r2x18_log_exp <- ((max(biomass_Tha))-(100))
L_r2y18_log_exp <- ((max(biomass_Tha))-(250))

RM_r2x18_logy <- round(MODEL_index_ord$Mfreq_RMSE_lmLogy[1], 2)

rm(fit_y, biomass_Tha, fit, y_18)

print(RM_r2x18_logy)

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_MULT/16_mult_tb_total")
All_atrib_16 <- read.csv("Mfreq.csv", header=TRUE, sep=",")
All_atrib_16 <- All_atrib_16%>%
  mutate(biomass_Tha = log(biomass_Tha))


fit_y <- NULL
R2_16_log_exp <- NULL

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_MULT")
MODEL_index_ord <- read.csv("Mfreq_lmLogy_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X == 24) , ]

z <- as.formula(paste(MODEL_index_ord$model))

y_16 <- lm(formula=z, data=All_atrib_16)
fit_y <-c(fitted.values(y_16))
fit_y <- exp(fit_y)
biomass_Tha<- exp(All_atrib_16$biomass_Tha)
R2_16_log_exp <-  c(cor(biomass_Tha,fit_y)^2)
fit <- cbind(biomass_Tha, fit_y)
fit_PAL_16<- as.data.frame(fit)
fit_PAL_16$id <- (nrow(fit_PAL_16))
fit_PAL_16$id2 <- seq_len(nrow(fit_PAL_16))

print(R2_16_log_exp)

R2_16_log_exp <-(round(R2_16_log_exp, 2))

L_r2x16_log_exp <- ((max(biomass_Tha))+(100))
L_r2y16_log_exp <- ((mean(fit_y))+((mean(fit_y))*0.02))

RM_r2x16_logy <- round(MODEL_index_ord$Mfreq_RMSE_lmLogy[1], 2)

fit_Bio_log_y_exp_PAL <- merge(fit_PAL_16, fit_PAL_18, all=TRUE)

PAL_Pol_RogYi <- tidy(y_16)
write.csv(PAL_Pol_RogYi , "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/Predic/PAL_Pol_RogYi.csv")


rm(fit_y, biomass_Tha, fit, y_16, fit_PAL_16, fit_PAL_18)

write.csv(fit_Bio_log_y_exp_PAL , "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/Predic/fit_Bio_log_y_exp_PAL.csv")

print(RM_r2x16_logy)

print(fit_Bio_log_y_exp_PAL)





########### IDENT

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_tb_total")
All_atrib_18 <- read.csv("Mfreq.csv", header=TRUE, sep=",")


fit_y <- NULL
R2_18_ident <- NULL


setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_MULT_BIO")
MODEL_index_ord <- read.csv("STA_IDENT_MULT_18_END.csv", header=TRUE, sep=",")
MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X == 1) , ]
z <- as.formula(paste(MODEL_index_ord$model))


y_18 <- glm(formula=z, data = All_atrib_18,
            family= gaussian(link="identity"))
fit_y1 <-c(fitted.values(y_18))
fit_y2 <- ifelse(fit_y1 > 600, 600, fit_y1)
fit_y <- ifelse(fit_y2 < 0, 0, fit_y2)
R2_18_ident <-  c(cor(All_atrib_18$biomass_Tha,fit_y)^2)
biomass_Tha<- All_atrib_18$biomass_Tha
fit <- cbind(biomass_Tha, fit_y)
fit_PAL_18<- as.data.frame(fit)
fit_PAL_18$id <- (nrow(fit_PAL_18))
fit_PAL_18$id2 <- seq_len(nrow(fit_PAL_18))

R2_18_ident <-(round(R2_18_ident, 2))

L_r2x18_ident <- ((max(biomass_Tha))-(100))
L_r2y18_ident <- ((max(fit_y))-250)



print(L_r2x18_ident)
print(L_r2y18_ident)

RM_r2x18_ident <- round(MODEL_index_ord$RMSE_LOOCV_SC[1], 2)

rm(fit_y, biomass_Tha, fit, y_18)

print(RM_r2x18_ident)



setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_MULT/16_mult_tb_total")
All_atrib_16 <- read.csv("Mfreq.csv", header=TRUE, sep=",")

fit_y <- NULL
R2_16_ident <- NULL

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_MULT_BIO")
MODEL_index_ord <- read.csv("STA_IDENT_MULT_16_END.csv", header=TRUE, sep=",")
MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X == 2) , ]
z <- as.formula(paste(MODEL_index_ord$model))


y_16 <- glm(formula=z, data =All_atrib_16,
            family= gaussian(link="identity"))
fit_y1 <-c(fitted.values(y_16))
fit_y2 <- ifelse(fit_y1 > 600, 600, fit_y1)
fit_y <- ifelse(fit_y2 < 0, 0, fit_y2)
R2_16_ident <-  c(cor(All_atrib_16$biomass_Tha,fit_y)^2)
biomass_Tha<- All_atrib_16$biomass_Tha
fit <- cbind(biomass_Tha, fit_y)
fit_PAL_16<- as.data.frame(fit)
fit_PAL_16$id <- (nrow(fit_PAL_16))
fit_PAL_16$id2 <- seq_len(nrow(fit_PAL_16))

R2_16_ident <-(round(R2_16_ident, 2))
L_r2x16_ident <- ((min(biomass_Tha)))
L_r2y16_ident <- ((mean(fit_y))+((mean(fit_y))*0.02))

RM_r2x16_ident <- round(MODEL_index_ord$RMSE_LOOCV_SC[1], 2)

fit_Bio_ident_PAL <- merge(fit_PAL_16, fit_PAL_18, all=TRUE)
rm(fit_y, biomass_Tha, fit, y_16, fit_PAL_16, fit_PAL_18 )

write.csv(fit_Bio_ident_PAL , "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/Predic/fit_Bio_ident_PAL.csv")

print(RM_r2x16_ident)


########### LOG


fit_y <- NULL
R2_18_log <- NULL

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_MULT/18_mult_tb_total")
All_atrib_18 <- read.csv("Mfreq.csv", header=TRUE, sep=",")

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_MULT_BIO")

MODEL_index_ord <- read.csv("STA_LOG_MULT_18_END.csv", header=TRUE, sep=",")
MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X == 1) , ]
z <- as.formula(paste(MODEL_index_ord$model))

y_18 <- glm(formula=z, data = All_atrib_18,
            family= gaussian(link="log"))
fit_y1 <-c(fitted.values(y_18))
fit_y2 <- ifelse(fit_y1 > 600, 600, fit_y1)
fit_y <- ifelse(fit_y2 < 0, 0, fit_y2)
R2_18_log <-  c(cor(All_atrib_18$biomass_Tha,fit_y)^2)
biomass_Tha<- All_atrib_18$biomass_Tha
fit <- cbind(biomass_Tha, fit_y)
fit_PAL_18<- as.data.frame(fit)
fit_PAL_18$id <- (nrow(fit_PAL_18))
fit_PAL_18$id2 <- seq_len(nrow(fit_PAL_18))

R2_18_log <-(round(R2_18_log, 2))
L_r2x18_log <- ((max(biomass_Tha))-100)
L_r2y18_log <- ((max(fit_y))-250)
print(L_r2x18_log)
print(L_r2y18_log)


RM_r2x18_log <- round(MODEL_index_ord$RMSE_LOOCV_SC[1], 2)
glimpse(MODEL_index_ord)

rm(fit_y, biomass_Tha, fit, y_18)

print(R2_18_log)


print(RM_r2x18_log)


fit_y <- NULL
R2_16_log <- NULL

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_MULT/16_mult_tb_total")
All_atrib_16 <- read.csv("Mfreq.csv", header=TRUE, sep=",")

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_MULT_BIO")
MODEL_index_ord <- read.csv("STA_LOG_MULT_16_END.csv", header=TRUE, sep=",")
MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X == 3) , ] 
                                    
z <- as.formula(paste(MODEL_index_ord$model))

y_16 <- glm(formula=z, data =All_atrib_16,
            family= gaussian(link="log"))
fit_y1 <-c(fitted.values(y_16))
fit_y2 <- ifelse(fit_y1 > 600, 600, fit_y1)
fit_y <- ifelse(fit_y2 < 0, 0, fit_y2)
R2_16_log <-  c(cor(All_atrib_16$biomass_Tha,fit_y)^2)
print(R2_16_log )

biomass_Tha<- All_atrib_16$biomass_Tha
fit <- cbind(biomass_Tha, fit_y)
fit_PAL_16<- as.data.frame(fit)
fit_PAL_16$id <- (nrow(fit_PAL_16))
fit_PAL_16$id2 <- seq_len(nrow(fit_PAL_16))

R2_16_log <-(round(R2_16_log, 2))
print(R2_16_log)
L_r2x16_log <- ((max(biomass_Tha))+(100))
L_r2y16_log <- ((mean(fit_y))+((mean(fit_y))*0.02))

RM_r2x16_log <- round(MODEL_index_ord$RMSE_LOOCV_SC[1], 2)

fit_Bio_log_PAL <- merge(fit_PAL_16, fit_PAL_18, all=TRUE)

rm(fit_y, biomass_Tha, fit, y_16, fit_PAL_16 )

write.csv(fit_Bio_log_PAL , "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/Predic/fit_Bio_log_PAL.csv")


fit_l <-  merge(fit_Bio_log_PAL, fit_Bio_ident_PAL, all=TRUE)

fit_lim <-  merge(fit_l, fit_Bio_log_y_exp_PAL, all=TRUE)

print(fit_lim)

fit_lim <- fit_lim[-4]
fit_lim <- fit_lim[-3]
aa<-unique(fit_lim$biomass_Tha)
bb<- unique(fit_lim$fit_y)
cc <- c(aa,bb)

print(RM_r2x16_log)
### Valor minimo arredondando 0.5

min_g1<-min(cc)
min_g2<-floor(min_g1)
min_g3<-min_g2+0.5
min_g <- ifelse(min_g1>=min_g3, min_g3,min_g2)

min_g <-0
### Valor minimo arredondando 0.5
max_g1<-max(cc)
max_g2<-ceiling(max_g1)
max_g3<-max_g2-0.5
max_g <- ifelse(max_g1>=max_g3, max_g2,max_g3)

max_g <- 650



rm(fit_l, fit_lim, aa, bb, cc)



############# Grfico 


myColors <- c('red3', 'black')
names(myColors) <- levels(fit_Bio_log_y_exp_PAL$id)
point_color <- scale_colour_manual(name = "Number of sample (AGB)",values = myColors)

shape1<- c(8, 16)
names(shape1)<-levels(fit_Bio_log_y_exp_PAL$id)
point_sape <- scale_shape_manual("Number of sample (AGB)",values = shape1) 

setwd('C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_MULT_bio/Predic')

print(fit_Bio_log_y_exp_PAL)

biomass_Tha


a <- ggplot(data = fit_Bio_log_y_exp_PAL,aes(fit_y,biomass_Tha)) 
b <- a + geom_point(aes(colour = factor(id), shape=factor(id)), size = 1, stroke = 1)
plot(b)
c <- b + geom_smooth(aes(colour = factor(id)), method = "glm", size=1)
d <- c + point_sape + point_color
f_log_y_exp<-d+theme(axis.text.x = element_text(angle = 50,hjust=1, vjust=1.2,color="black", size = 6),
                 axis.title.x = element_text(size=7, hjust=0.5, vjust=0),
                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.2,color="black", size = 6),
                 axis.title.y = element_text(size=7, hjust=0.5, vjust=0),
                 panel.background = element_blank(),
                 panel.grid.major = element_line(colour =  "grey95"), 
                 panel.grid.minor = element_blank(), 
                 axis.line.x=element_line(),
                 axis.line.y=element_line(),
                 legend.position= c(0, 1),  # troca a posio da legenda
                 legend.background = element_rect(fill = "white", colour = "black", size = 0.5),
                 legend.key = element_rect(fill = "white", colour="black", size=NULL),
                 legend.key.size = unit(0.4, "cm"),
                 legend.text = element_text(size = 6, colour = "black", angle = 0),
                 legend.justification = c(0, 1),  # Trocar a posio da legenda
                 legend.title= element_text(size=6, hjust=0.5, vjust=1.5)) +
  xlab (expression(paste("Predicted AGB [t/ha] = E(logYi)/ AGB =",e^{(logYi)}))) +
  ylab(label = "AGB [t/ha]")+
  scale_x_continuous(breaks = seq(min_g, max_g, 50),  limits = c(min_g, max_g))+
  scale_y_continuous(breaks = seq(min_g, max_g, 50),  limits = c(min_g, max_g))+
  coord_fixed(ratio = 1)+
  annotate("text",x= L_r2x16_log_exp, y=L_r2y16_log_exp , label = paste("(16) R=",R2_16_log_exp), size=2)+
  annotate("text",x= L_r2x18_log_exp, y=L_r2y18_log_exp , label = paste("(18) R=",R2_18_log_exp), size=2)+
  ggtitle(paste("RMSEcv(18) =",RM_r2x18_logy," RMSEcv(16) =",RM_r2x16_logy)) + 
  theme(plot.title = element_text(size=7,hjust = 0.5))
  
print( L_r2y18_log_exp)
  
  
plot(f_log_y_exp)



ggsave(filename = "Pred_Bio_log_y_exp_PALF.png", units = "cm", width = 7, height = 7, dpi = 150)


rm(a, b, c, d)


a <- ggplot(data = fit_Bio_ident_PAL,aes(fit_y,biomass_Tha)) 
b <- a + geom_point(aes(colour = factor(id), shape=factor(id)), size = 1, stroke = 1)
c <- b + geom_smooth(aes(colour = factor(id)), method = "glm", size=1)
d <- c + point_sape + point_color
f_ident<-d+theme(axis.text.x = element_text(angle = 50,hjust=1, vjust=1.2,color="black", size = 6),
           axis.title.x = element_text(size=7, hjust=0.5, vjust=0),
           axis.text.y = element_text(angle = 0,hjust=1, vjust=0.2,color="black", size = 6),
           axis.title.y = element_text(size=7, hjust=0.5, vjust=0),
           panel.background = element_blank(),
           panel.grid.major = element_line(colour =  "grey95"), 
           panel.grid.minor = element_blank(), 
           axis.line.x=element_line(),
           axis.line.y=element_line(),
           legend.position= c(0, 1),  # troca a posio da legenda
           legend.background = element_rect(fill = "white", colour = "black", size = 0.5),
           legend.key = element_rect(fill = "white", colour="black", size=NULL),
           legend.key.size = unit(0.4, "cm"),
           legend.text = element_text(size = 6, colour = "black", angle = 0),
           legend.justification = c(0, 1),  # Trocar a posio da legenda
           legend.title= element_text(size=6, hjust=0.5, vjust=1.5)) +
  xlab (label = "Predicted AGB [t/ha] E(Yi)" ) +
  ylab (label = "AGB [t/ha]")+
  scale_x_continuous(breaks = seq(min_g, max_g, 50),  limits = c(min_g, max_g))+
  scale_y_continuous(breaks = seq(min_g, max_g, 50),  limits = c(min_g, max_g))+
  coord_fixed(ratio = 1)+
  annotate("text", x = L_r2x16_ident, y=L_r2y16_ident , label = paste("(16) R=",R2_16_ident), size=2)+
  annotate("text", x = L_r2x18_ident, y=L_r2y18_ident, label = paste("(18) R=",R2_18_ident), size=2)+
  ggtitle(paste("RMSEcv(18) =",RM_r2x18_ident," RMSEcv(16) =",RM_r2x16_ident)) + 
  theme(plot.title = element_text(size=7,hjust = 0.5))


plot(f_ident)

ggsave(filename = "Pred_Bio_ident_PALF.png", units = "cm", width = 7, height = 7, dpi = 150)


rm(a, b, c, d, L_r2x16_ident, L_r2x18_ident, L_r2y16_ident, L_r2y18_ident)


a <- ggplot(data = fit_Bio_log_PAL,aes(fit_y,biomass_Tha)) 
b <- a + geom_point(aes(colour = factor(id), shape=factor(id)), size = 1, stroke = 1)
c <- b + geom_smooth(aes(colour = factor(id)), method = "glm", size=1)
d <- c + point_sape + point_color
f_log <-d+theme(axis.text.x = element_text(angle = 50,hjust=1, vjust=1.2,color="black", size = 6),
           axis.title.x = element_text(size=7, hjust=0.5, vjust=0),
           axis.text.y = element_text(angle = 0,hjust=1, vjust=0.2,color="black", size = 6),
           axis.title.y = element_text(size=7, hjust=0.5, vjust=0),
           panel.background = element_blank(),
           panel.grid.major = element_line(colour =  "grey95"), 
           panel.grid.minor = element_blank(), 
           axis.line.x=element_line(),
           axis.line.y=element_line(),
           legend.position= c(0, 1),  # troca a posio da legenda
           legend.background = element_rect(fill = "white", colour = "black", size = 0.5),
           legend.key = element_rect(fill = "white", colour="black", size=NULL),
           legend.key.size = unit(0.4, "cm"),
           legend.text = element_text(size = 6, colour = "black", angle = 0),
           legend.justification = c(0, 1),  # Trocar a posio da legenda
           legend.title= element_text(size=6, hjust=0.5, vjust=1.5)) +
  xlab (label = "Predicted AGB [t/ha] lnE(Yi)" ) +
  ylab (label = "AGB [t/ha]")+
  scale_x_continuous(breaks = seq(min_g, max_g, 50),  limits = c(min_g, max_g))+
  scale_y_continuous(breaks = seq(min_g, max_g, 50),  limits = c(min_g, max_g))+
  coord_fixed(ratio = 1)+
  annotate("text", x = L_r2x16_log, y=L_r2y16_log , label = paste("(16) R=",R2_16_log), size=2)+
  annotate("text", x = L_r2x18_log, y=L_r2y18_log, label = paste("(18) R=",R2_18_log), size=2)+
  ggtitle(paste("RMSEcv(18) =",RM_r2x18_log," RMSEcv(16) =",RM_r2x16_log)) + 
  theme(plot.title = element_text(size=7,hjust = 0.5))


plot(f_log)


ggsave(filename = "Pred_Bio_log_PALF.png", units = "cm", width = 7, height = 7, dpi = 300)


rm(a, b, c, d)


T_Bio_PAL <- grid.arrange(f_ident, f_log , ncol=2)
ggsave(filename = "T_Bio_PALF.png", plot=T_Bio_PAL, units = "cm", width = 21, height = 7, dpi = 300)
 


