install.packages("reshape2")
install.packages("ggplot2")
install.packages("plyr")
install.packages("scales")
install.packages("foreign")
install.packages("car")
install.packages("DAAG")
install.packages("MASS")
install.packages("leaps")
install.packages("car")
install.packages("bootStepAIC")
install.packages("forecast")
install.packages("glmulti")
install.packages("rJava")
install.packages("ISLR")
install.packages("boot")
install.packages("dplyr")
install.packages("broom")


library(leaps)
library(reshape2) 
library(ggplot2)
library(plyr)
library(scales)
library(foreign)
library(car)
library(randomForest)
library(DAAG)
library(MASS)
library(bootStepAIC)
library(leaps)
library(forecast)
library(glmulti)
library(rJava)
library(ISLR)
library(boot)
library(dplyr)
library(broom)

options(digits=6)

options(digits=6)


setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/18_pts"
dir.create("1Bio_18_Pol_L_2_AIC")



setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC")

mainDir <- "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC"
dir.create("18_best_model")
dir.create("18_join")
dir.create("18_join_3")
dir.create("18_join_3_results")
dir.create("18_join_mult_results")
dir.create("18_join_tz_results")
dir.create("RESLT_FULL_18_POL_L")
dir.create("RESULTS")

#

### Pre-processamento dos dados ### 

#

# Ajustando o diretorio de trabalho para trabalhar com a planilha dos individuos.

#

setwd("C:/3_CURUAI/0_BEST_MODEL")

p_ind <- read.csv("planilha_individuos.csv", header=TRUE, sep=";")

#

# Convertendo todos os angulos para radianos

#

p_ind$ang_topo_rad <- (p_ind$ang_topo*3.14)/180

p_ind$ang_fuste_rad <- (p_ind$ang_fuste*3.14)/180

#

#Removendo os pontos de arbutos os que cairam fora da area de estudo. Os pontos sao 13, 14, 15, 16, 23, 24, 25; removendo tambem os pontos de ANINGA e os pontos de especies que nao foram identificadas.

#

p_ind_sub <- subset(p_ind [!p_ind$ponto == 13 & !p_ind$ponto == 14 & !p_ind$ponto == 15 & !p_ind$ponto == 16 & !p_ind$ponto == 23 & !p_ind$ponto == 24 & !p_ind$ponto == 25 & !p_ind$sp == "MB" & !p_ind$sp == "XXX" & !p_ind$sp == "", ])

#

#calculando altura total, de fuste, de copa e altura de inundacao

#

p_ind_sub$h_total <- p_ind_sub$d_solo_clin + ((tan(p_ind_sub$ang_topo_rad)*p_ind_sub$d_tronco))

p_ind_sub$h_fuste <- p_ind_sub$d_solo_clin + ((tan(p_ind_sub$ang_fuste_rad)*p_ind_sub$d_tronco))

p_ind_sub$h_copa <- p_ind_sub$h_total - p_ind_sub$h_fuste

p_ind_sub$h_inund <- p_ind_sub$m_agua + p_ind_sub$d_solo_laser

#alturas_erradas <- which(is.na(p_ind_sub$h_total))

#p_ind_sub <- p_ind_sub[-alturas_erradas,]

#

# calculando area basal

# primeiro calculo o raio da arvore, depois a area basal em m2/ha (divido por 0.0625)

#

p_ind_sub$raio <- (p_ind_sub$dap / 2) / 100  #dividi por 100 para mudar as unidades - de centimetros para metros.

p_ind_sub$area_basal <- (3.14 * (p_ind_sub$raio^2))/0.0625 # Lembrar que a area eh pi*raio^2. Dividi por 0.0625 para ter a area basal em m2/ha

#

#calculando a altura de lorey. h_lorey = (h_total * area_basal) / area_basal_parcela. Essa altura sera calculada por partes: primeiro eu vou calcular a parte de cima da equacao e, apos o summarize, vou calcular a parte de baixo.

#

p_ind_sub$h_lorey_cima = p_ind_sub$h_total * p_ind_sub$area_basal

#

# Calculando a densidade de madeira

#

p_ind_sub$wd <- p_ind_sub$sp

levels(p_ind_sub$wd) <- levels(p_ind_sub$sp)

p_ind_sub$wd <- factor(p_ind_sub$wd)

levels(p_ind_sub$wd) <- c(0.29, #AD Alchornea discolor
                          0.76, #AE Albertia edulis
                          0.50, #AJ Astrocaryum jauari (Fonte: Astrocaryum murumuru - http://db.worldagroforestry.org/)
                          0.77, #AL Acacia loretensis (Fonte: media de todas as Acacia sp. - http://db.worldagroforestry.org/)
                          0.74, #AN Acosmium nitens
                          0.76, #Andira sp. (Fonte: media de todas as Andira sp. - http://db.worldagroforestry.org/)
                          0.71, #BC Bothriospora corymbosa
                          0.64, #BG Banara guianensis
                          0.60, #BJ Byrsonima japurensis
                          0.74, #BO Buchenavia oxycarpa
                          0.87, #CA Crudia amazonica
                          0.46, #CB Crataeva benthamii
                          0.74, #CC Campsiandra comosa
                          0.37, #CH Cordia hirta (Fonte: Cordia nodosa - Manual)
                          0.74, #CL Cassia leiandra (Fonte: media de todas as Cassia sp. - http://db.worldagroforestry.org/)
                          0.70, #CM Caliptrantis multiflora
                          0.60, #CP Caraipa punctulata (Fonte: http://db.worldagroforestry.org/)
                          0.61, #CR Casearia arborea (Fonte: Casearia aculeata - Manual)
                          0.69, #DD Duroia duckei
                          0.69, #DM Dimorphandra macrostachya (Fonte: http://db.worldagroforestry.org/)
                          0.79, #EA Eschweilera albiflora
                          0.64, #ED Etaballia dubia
                          0.77, #EI Eugenia inundata (Fonte: media de todas as Eugenia sp. - http://db.worldagroforestry.org/)
                          0.38, #FG Ficus guianensis (Fonte: Ficus anthelmintica - Manual)
                          0.66, #GG Guarea guidonea
                          0.69, #HA Heisteria acuminata (Fonte: media de todas Heisteria sp. - http://db.worldagroforestry.org/)
                          0.47, #HC Hydrochorea corymbosa (Fonte: http://db.worldagroforestry.org/)
                          0.61, #IO Inga obidensis (Fonte: Inga pilosula - Manual)
                          0.61, #IP Inga pilosula
                          0.71, #LA Licania apetala
                          0.43, #LC Luehea cymulosa
                          0.46, #MA Macrolobium acaciifolium
                          0.79, #MC Mouriri acutiflora
                          0.71, #MG Maytenus guianensis (Fonte: media de todos Maytenus - http://db.worldagroforestry.org/)
                          0.56, #MN Mabea nitida
                          0.70, #MR Matayba arborescens (Fonte: http://db.worldagroforestry.org/)
                          0.66, #OM Ormosia macrocalyx (Fonte: http://db.worldagroforestry.org/)
                          0.25, #PM Pseudobombax munguba
                          0.39, #PO Paramachaerium ormosiodes
                          0.43, #PR Pterocarpus rhori (Fonte: Pterocarpus amazonum - Manual)
                          0.90, #PT Piranhea trifoliolata
                          0.86, #QR Quiina rhytidopis (Fonte: media de todas as Quiinas - http://db.worldagroforestry.org/)
                          0.76, #SF Sloanea floribunda
                          0.35, #SH Cecropia hololeuca (Fonte: Cecropia latiloba e Cecropia membranacea - Manual)
                          0.40, #SM Simaba multiflora
                          0.77, #SP Symmeria paniculata
                          0.76, #TB Tabebuia barbata
                          0.83, #TC Talisia cupularis (Fonte: media de todas as Talisia - http://db.worldagroforestry.org/)
                          0.84, #TD Terminalia dichotoma
                          0.57, #TS Triplaris surinamensis
                          0.55, #VC Vitex cymosa
                          0.66, #VG Vatairea guianensis
                          0.68, #ZC Zygia cataractae (Fonte: media de todas as Zygia - http://db.worldagroforestry.org/)
                          0.75, #ZL Zygia latifolia (Fonte: http://db.worldagroforestry.org/)
                          0.68) #ZR Zygia ramiflora (Fonte: media de todas as Zygia - http://db.worldagroforestry.org/)

#

# sumarizando tudo, para calcular outros atributos

#d_ind = densidade de individuos. Estou utilizando a funcao "max()" por que ai indiretamente eu estou selecionando o numero total de individuos. Dai eu divido por 0.0625 e transformo em densidade de inviduos por uma area igual a um ha. Ou seja, a grandeza d_ind = n_ind/ha.

#h_lorey = anteriormente eu tinha calculado a h_lorey_cima. Ainda faltava dividir esse valor pela area basal media da parcela. Agora que summarizamos tudo, temos o valor de area basal media. Entao a coluna h_lorey sera criada. 

#

p_ind_sub$wd <- as.numeric(paste(p_ind_sub$wd))

p_ind_sub$ind <- as.numeric(p_ind_sub$ind)

p_ind_sub$biomass1 <- 0.06 * p_ind_sub$wd * p_ind_sub$h_total * pi * ((p_ind_sub$dap/2)^2)
p_ind_sub$biomass2 <- 0.112 * (p_ind_sub$wd * p_ind_sub$h_total * (p_ind_sub$dap^2))^0.916
p_ind_sub$biomass3 <- 0.0509 * p_ind_sub$wd * p_ind_sub$h_total * (p_ind_sub$dap^2)

p_ind_sub$biomass_kg <- (p_ind_sub$biomass1 + p_ind_sub$biomass2 + p_ind_sub$biomass3)/3

#Passando kg para Tonelada( Ou seja divide o valor em kg da biomassa por 1000)

p_ind_sub$biomass_T <- p_ind_sub$biomass_kg/1000

write.csv(p_ind_sub,"p_ind_sub.csv")


# Nesta metodologia, se soma todos os valores da biomassa dos individuos, lembrando que a unidade final  (kg)
# Ento vou trocar o valor "mean no summarise, por sum)

p_ind_sub_summ <- ddply(p_ind_sub, .(ponto), summarise, 
                        n_ind = length(unique(ind)),
                        dap = mean(dap, na.rm=TRUE),              
                        h_inund = mean(h_inund, na.rm=TRUE), 
                        h_total = mean(h_total, na.rm=TRUE), 
                        h_fuste = mean(h_fuste, na.rm=TRUE), 
                        h_copa = mean(h_copa, na.rm=TRUE), 
                        area_basal = sum(area_basal, na.rm=TRUE),
                        biomass_T = sum(biomass_T,na.rm=TRUE),
                        h_lorey_media = sum(h_lorey_cima, na.rm=TRUE))

p_ind_sub_summ$h_lorey <- p_ind_sub_summ$h_lorey_media/p_ind_sub_summ$area_basal

p_ind_sub_summ$d_ind <- p_ind_sub_summ$n_ind/0.0625


# O fator de escala e utilizado para passar as parcelas para T por ha "
# referncia: 
#Carreiras, J. M. B., Vasconcelos, M. J., & Lucas, R. M. (2012). 
#Remote Sensing of Environment Understanding the relationship between aboveground biomass and ALOS PALSAR data in the forests 
#of Guinea-Bissau ( West Africa ). Remote Sensing of Environment, 121, 426-442. http://doi.org/10.1016/j.rse.2012.02.012
# PG 442

# Sf= 10000/Anp  Where SF is the scaling factor, and Anp is the nested plot area (m2)
# AGB: soma das arvores em uma parcela*sf

sf <- 10000/625
print(sf)

p_ind_sub_summ$biomass_Tha <- p_ind_sub_summ$biomass_T*sf

#inserindo os dados de LAI

#

setwd("C:/3_CURUAI/0_BEST_MODEL/01_dados/LAI")

lai <- read.csv("lai.csv", header=TRUE, sep=";")

lai_sub <- subset(lai [!lai$ponto == 13 & !lai$ponto == 14 & !lai$ponto == 15 & !lai$ponto == 16 & !lai$ponto == 23 & !lai$ponto == 24 & !lai$ponto == 25, ])

#

#juntando as planilhas p_ind_sub_summ e a planilha lai_sub

p_ind_sub_final <- cbind(p_ind_sub_summ,lai_sub[,2])

names(p_ind_sub_final) <- c(names(p_ind_sub_summ),"lai")

p_ind_sub_final <- p_ind_sub_final[,-2] #Removendo a coluna do numero de individuos

p_ind_sub_final <- p_ind_sub_final[,-9] #Removendo a coluna da parte de cima da altura de lorey

#

# Unidades das variaveis de campo:

# dap - centimetros
# n_ind - contagem simples
# todas as alturas - metros
# area basal - m2 / ha
# d_ind - numero de individuos / ha
# LAI - nao tem unidade

rm(lai,lai_sub,p_ind,p_ind_sub,p_ind_sub_summ)

# Para rodar sem problemas vou trocar a biomassaTha pela BiomassaT

p_ind_sub_final <- subset(p_ind_sub_final, select=c(1,2,3,4,5,6,7,11,8,9,10,12))

p_ind_sub_final <- cbind(p_ind_sub_final[1], p_ind_sub_final[-1])


write.csv(p_ind_sub_final, "C:/3_CURUAI/0_BEST_MODEL/18_pts/p_ind_sub_final.csv")

#

# Anlise exploratria das variveis dependentes

#

# # Histograma DAP
# 
# hist(p_ind_sub_final$dap, 
#      breaks = 10,
#      main = "Histograma DAP",
#      xlab = "DAP (cm)",
#      ylab = "Frequncia",
#      col = "light gray")
# 
# # Histograma Altura
# 
# hist(p_ind_sub_final$h_total, 
#      breaks = 10,
#      main = "Histograma Altura",
#      xlab = " Biomass (m)",
#      ylab = "Frequncia",
#      col = "light gray")
# 
# # Histograma LAI
# 
# hist(p_ind_sub_final$lai, 
#      breaks = 10,
#      main = "Histograma LAI",
#      xlab = "LAI",
#      ylab = "Frequncia",
#      col = "light gray")
# 
# # Histograma Biomassa
# 
# hist(p_ind_sub_final$biomass_Tha, 
#      breaks = 10,
#      main = "Histograma Biomassa",
#      xlab = "Biomassa (Mg/ha)",
#      ylab = "Frequncia",
#      col = "light gray")
# 
# #

#Ajustando o diretorio de trabalho para trabalhar com a planilha das imagens.

#


setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/valores_das_imagens")


#PAL_c <- read.csv("PAL_LW_C2.csv")
#alos <- read.csv("PALSAR_FDB.csv")
#tsx <- read.csv("TSX_HH.csv")



# Alos palsar full

PAL_c <-read.csv("POL_LW_C5.csv")
PAL_cp <-read.csv("POL_LW_CP.csv")
PAL_fd <-read.csv("POL_LW_FD.csv")
PAL_tz <-read.csv("POL_LW_TZ.csv")
PAL_vz<-read.csv("POL_LW_VZ.csv")
PAL_ya<-read.csv("POL_LW_YAMA.csv")

# (s<-summary (as.factor(PAL_c$ROI_Name)))
#

#sumarisando as tabelas das imagens

#
PAL_c <- PAL_c%>%
  mutate(hvmhh = ((c22)-(c11)))%>%
  mutate(hvmvv = ((c22)-(c33)))%>%
  mutate(hhmvv = ((c11)-(c33)))%>%
  mutate(DP = ((c22)/((c11)+(c33))))
#




PAL_c_summ <- ddply(PAL_c, .(ROI_Name), summarise, 
                    PAL_hh = mean(c11),
                    PAL_hv = mean(c22),
                    PAL_vv = mean(c33),
                    PAL_hv_hh = mean(PAL_hv_hh),
                    PAL_vv_hh = mean(PAL_vv_hh),
                    PAL_hv_vv = mean(PAL_hv_vv),
                    PAL_SPAN = mean(PAL_SPAN),
                    PAL_RVI = mean(PAL_RVI),
                    PAL_BMI = mean(PAL_BMI),
                    PAL_hvmhh = mean(hvmhh),
                    PAL_hvmvv = mean(hvmvv),
                    PAL_hhmvv = mean(hhmvv),
                    DP = mean(DP)) 



PAL_cp_summ <- ddply(PAL_cp, .(ROI_Name), summarise, 
                     cp_alpha = mean(cp_alpha),
                     cp_ani = mean(cp_ani),
                     cp_entro = mean(cp_entro))

PAL_fd_summ <- ddply(PAL_fd, .(ROI_Name), summarise, 
                     fd_db = mean(fd_db),
                     fd_odd = mean(fd_odd),
                     fd_vol = mean(fd_vol))

PAL_tz_summ <- ddply(PAL_tz, .(ROI_Name), summarise, 
                     tz_alphas = mean(tz_alphas),
                     tz_alphas1 = mean(tz_alphas1),
                     tz_alphas2= mean(tz_alphas2),
                     tz_alphas3 = mean(tz_alphas3),
                     tz_phis = mean(tz_phis),
                     tz_phis1 = mean(tz_phis1),
                     tz_phis2 = mean(tz_phis2),
                     tz_phis3 = mean(tz_phis3),
                     tz_psis = mean(tz_psis),
                     tz_psis1 = mean(tz_psis1),
                     tz_psis2 = mean(tz_psis2),
                     tz_psis3 = mean(tz_psis3),
                     tz_taum = mean(tz_taum),
                     tz_taum1 = mean(tz_taum1),
                     tz_taum2 = mean(tz_taum2),
                     tz_taum3 = mean(tz_taum3))

PAL_vz_summ <- ddply(PAL_vz, .(ROI_Name), summarise, 
                     vz_db = mean(vz_db),
                     vz_odd = mean(vz_odd),
                     vz_vol = mean(vz_vol))

PAL_ya_summ <- ddply(PAL_ya, .(ROI_Name), summarise, 
                     ya_db = mean(ya_db),
                     ya_odd = mean(ya_odd),
                     ya_vol = mean(ya_vol))




#removendo objetos que nao serao mais usados

#

rm(PAL_c,PAL_cp,PAL_fd,PAL_tz,PAL_vz,PAL_ya)

#

# Ajustando os modelos

# Metodologia: para cada modelo vou fazer o teste de correlacao entre as variaveis independentes e investigar a colinearidade entre as variaveis independentes, eliminando aquelas que possuem forte correlacao entre si sempre que possivel. Depois investigo o scatterplot e vejo se a relacao eh linear e se nao for eu tento lineariza-la (usando a funcao dB). Depois ajusto o modelo e faco sua validacao, comparando os diferentes AIC, Ajd R2 e RMSE.

# Quando o grupo de imagens tiver mais que 10 variaveis independentes para eu escolher (por exemplo matriz C ou Touzi) eu vou usar o pacote leaps() para fazer uma pre-selecao dos dados.

#

# Antes de tudo devo criar uma funcao para calcular as variaveis em dB

dB <- function (x){
  options(digits=10)
  10*log10(x)
}

#

####################################
#
# Segunda variavel dependente: Biomassa (toneladas/ha)
#
####################################

#



#
# 
# ####################################
# #
# # Biomass x ALOS FULL
# #
# ####################################
# 

#
# 
# # Criando o df basico (lembrar que p_ind_sub_final[11] = bio)
# 
# #


dfPAL_id <- data.frame(p_ind_sub_final[8], PAL_c_summ) # p_ind_sub_final[11] = bio


dfPAL_id$PAL_hh_db <- dB(dfPAL_id$PAL_hh)
dfPAL_id$PAL_hh <- NULL
dfPAL_id$PAL_hv_db <- dB(dfPAL_id$PAL_hv)
dfPAL_id$PAL_hv <- NULL
dfPAL_id$PAL_vv_db <- dB(dfPAL_id$PAL_vv)
dfPAL_id$PAL_vv <- NULL
dfPAL_id$PAL_hv_hh_db <- (dfPAL_id$PAL_hv_hh)
dfPAL_id$PAL_hv_hh <- NULL
dfPAL_id$PAL_vv_hh_db <- (dfPAL_id$PAL_vv_hh)
dfPAL_id$PAL_vv_hh <- NULL
dfPAL_id$PAL_hv_vv_db <- (dfPAL_id$PAL_hv_vv)
dfPAL_id$PAL_hv_vv <- NULL
dfPAL_id$PAL_SPAN_db <- (dfPAL_id$PAL_SPAN)
dfPAL_id$PAL_SPAN <- NULL
dfPAL_id$PAL_RVI_db <- (dfPAL_id$PAL_RVI)
dfPAL_id$PAL_RVI <- NULL
dfPAL_id$PAL_BMI_db <- (dfPAL_id$PAL_BMI)
dfPAL_id$PAL_BMI <- NULL
dfPAL_id$PAL_hvmhh_db <- (dfPAL_id$PAL_hvmhh)
dfPAL_id$PAL_hvmhh <- NULL
dfPAL_id$PAL_hvmvv_db <- (dfPAL_id$PAL_hvmvv)
dfPAL_id$PAL_hvmvv <- NULL
dfPAL_id$PAL_hhmvv_db <- (dfPAL_id$PAL_hhmvv)
dfPAL_id$PAL_hhmvv <- NULL
dfPAL_id$DP_db <- dB(dfPAL_id$DP)
dfPAL_id$DP <- NULL

write.csv(dfPAL_id, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join/dfPAL_id.csv")

dfPAL <-dfPAL_id [-2]
write.csv(dfPAL, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_mult_results/dfPAL.csv")

print(cor(dfPAL))
write.csv(cor(dfPAL),"C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_mult_results/cor_alos_bio.csv")
scatterplotMatrix(dfPAL, diagonal="histogram", smooth=FALSE)


print(dfPAL)# 
# 
# #
# 
# 
# #
# ####################################
# #
# # MODELOS
# #
# ####################################
# 
# #
# 
# 
# #
# 

Comb <- 2^((ncol(dfPAL))-1)
print(Comb)


df <- dfPAL


setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_mult_results")


#n <- c("gaussian(link=identity)", "gaussian(link=log)", "Gamma (link=log)")

# ####################################
# #
# # MODELOS GLM MULT LINK = IDENTITY
# #
# ###########################################TROCAR(L-R)#################################################################
# 

# 

POL_R<- glmulti((biomass_Tha) ~ .,  data = df, 
                 level = 1,               # No interaction considered
                 method = "h",            # Exhaustive approach
                 crit = "aicc",            # AIC as criteria
                 confsetsize = Comb,         # Keep all model n^2 
                 plotty = F, report = F,  # plot or interim reports
                 fitfunction = "glm",
                 family=gaussian(link="identity")
)     # lm function

POL_R@objects
POL_RBest <- summary(POL_R@objects[[1]])# selecr best model 
print(POL_RBest)
POL_R_aic_limt <- weightable(POL_R)
POL_R_aic_limt2 <- POL_R_aic_limt[POL_R_aic_limt$aicc <= min(POL_R_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R_aic_limt2

write.csv(POL_R_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R_aic_limt2.csv")

L <- nrow(POL_R_aic_limt2)

DF_R2_RMSE_cv <- NULL

Model_fitted_y <- NULL



for (i in 1:L){
  z <- as.formula(paste(POL_R_aic_limt2$model[i]))
  y <- glm(formula=z, data = df,
            family= gaussian("identity")
  )
sumary_y <- summary(y)
fitted_y <-c(fitted.values(y))
R2 <-  c(cor(df$biomass_Tha,fitted.values(y))^2)
LOOCV <- cv.glm(df, y, K = nrow(df))
RMSE_cv<- (LOOCV$delta[1])^0.5
name <- paste0("y",i)
namesumary_y <- paste0("sumary_y",i)
namefitted_y <- paste0("fitted_y", i)
nameR2 <- paste0("R2",i)
nameLOOCV <- paste0("LOOCV",i)
nameRMSE_cv <- paste0("RMSE_cv", i)
assign(name, y)
assign(namesumary_y, sumary_y)
assign(namefitted_y,fitted_y)
assign(nameLOOCV, LOOCV)
R2_RMSE_cv<- data.frame(R2,RMSE_cv)
DF_R2_RMSE_cv <- rbind(DF_R2_RMSE_cv, R2_RMSE_cv)
Model_fitted_y <- cbind(Model_fitted_y, fitted_y)
}



#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_R_index <- merge( POL_R_aic_limt2, DF_R2_RMSE_cv, by=0, all=TRUE)
print(POL_R_index)

write.csv(POL_R_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_index.csv")


##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)

POL_R_index_ord <-arrange(POL_R_index, RMSE_cv)
colnames(POL_R_index_ord)[1] <- "Model_index_y"
print(POL_R_index_ord)

write.csv(POL_R_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_y <- as.formula(paste(POL_R_index_ord$model[1]))
Est_y_RMSE_cvt<- glm(formula=Est_y, data = df,
                     family= gaussian(link="identity"))


Est_y_RMSE_cv <- tidy(Est_y_RMSE_cvt)


Est_y_RMSE_cv <- Est_y_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_y_RMSE_cv)

write.csv(Est_y_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_y_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_y) <- paste("y", 1:L, sep = "")
Model_fitted_y <- merge(df$biomass_Tha, Model_fitted_y, by=0, all=TRUE)
colnames(Model_fitted_y)[2] <- "biomass_Tha"


write.csv(Model_fitted_y, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_y.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
#  
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesy <- names(Model_fitted_y)[3:ncol(Model_fitted_y)]
# print(colNamesy)
# 
# 
# for (s in colNamesy){
#   print(POL_R_predic <- ggplot(Model_fitted_y,  aes_string("biomass_Tha", s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method= "glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_R_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }
# 
# 
#    
   
# ######################################################################################
# #
# # MODELOS GLM MULT LINK = LOG
# #
# ######################################################################################



POL_R_log <- glmulti((biomass_Tha) ~ .,  data = df, 
                     level = 1,               # No interaction considered
                     method = "h",            # Exhaustive approach
                     crit = "aicc",            # AIC as criteria
                     confsetsize = Comb,         # Keep all model n^2 
                     plotty = F, report = F,  # plot or interim reports
                     fitfunction = "glm",
                     family = gaussian(link="log")
)     

POL_R_log@objects
POL_R_logBest <- summary(POL_R_log@objects[[1]])# selecr best model
print(POL_R_logBest) 
POL_R_log_aic_limt <- weightable(POL_R_log)
POL_R_log_aic_limt2 <- POL_R_log_aic_limt[POL_R_log_aic_limt$aicc <= min(POL_R_log_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R_log_aic_limt2
write.csv(POL_R_log_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R_log_aic_limt2.csv")


L <- nrow(POL_R_log_aic_limt2)

DF_R2L_RMSEL_cv <- NULL

Model_fitted_yL <- NULL



for (i in 1:L){
  zL <- as.formula(paste(POL_R_log_aic_limt2$model[i]))
  yL <- glm(formula=zL, data = df,
            family= gaussian(link="log")
  )
  sumary_yL <- summary(yL)
  fitted_yL <-c(fitted.values(yL))
  R2L <-  c(cor(df$biomass_Tha,fitted.values(yL))^2)
  LOOCVL <- cv.glm(df, yL, K = nrow(df))
  RMSEL_cv<- (LOOCVL$delta[1])^0.5
  nameL <- paste0("yL",i)
  namesumary_yL <- paste0("sumary_yL",i)
  namefitted_yL <- paste0("fitted_yL", i)
  nameR2L <- paste0("R2L",i)
  nameLOOCVL <- paste0("LOOCVL",i)
  nameRMSEL_cv <- paste0("RMSEL_cv", i)
  assign(nameL, yL)
  assign(namesumary_yL, sumary_yL)
  assign(namefitted_yL,fitted_yL)
  assign(nameLOOCVL, LOOCVL)
  R2L_RMSEL_cv<- data.frame(R2L,RMSEL_cv)
  DF_R2L_RMSEL_cv <- rbind(DF_R2L_RMSEL_cv, R2L_RMSEL_cv)
  Model_fitted_yL <- cbind(Model_fitted_yL, fitted_yL)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_R_L_index <- merge( POL_R_log_aic_limt2, DF_R2L_RMSEL_cv, by=0, all=TRUE)
print(POL_R_L_index)

write.csv(POL_R_L_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_L_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEL_cv (descrescente ordem)

POL_R_L_index_ord <-arrange(POL_R_L_index, RMSEL_cv)
colnames(POL_R_L_index_ord)[1] <- "Model_index_yL"
print(POL_R_L_index_ord)

write.csv(POL_R_L_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_L_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_yL <- as.formula(paste(POL_R_L_index_ord$model[1]))
Est_yL_RMSE_cvt<- glm(formula=Est_yL, data = df,
                      family= gaussian(link="log"))


Est_yL_RMSE_cv <- tidy(Est_yL_RMSE_cvt)


Est_yL_RMSE_cv <- Est_yL_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_yL_RMSE_cv)

write.csv(Est_yL_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_yL_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_yL) <- paste("yL", 1:L, sep = "")
Model_fitted_yL <- merge(df$biomass_Tha, Model_fitted_yL, by=0, all=TRUE)
colnames(Model_fitted_yL)[2] <- "biomass_Tha"

print(Model_fitted_yL)

write.csv(Model_fitted_yL, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_yL.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_log_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R_log@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_log_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R_log@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_log_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R_log@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyL <- names(Model_fitted_yL)[3:ncol(Model_fitted_yL)]
# print(colNamesyL)
# 
# 
# for (s in colNamesyL){
#   print(POL_R_log_predic <- ggplot(Model_fitted_yL,  aes_string(Model_fitted_yL$biomass_Tha, s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method="glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_R_log_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }



# ######################################################################################
# #
# # MODELOS GLM MULT LINK = GAMA (LINK=LOG)
# #
# ######################################################################################
# 



POL_R_gama <- glmulti((biomass_Tha) ~ 1 + PAL_hv_db + PAL_SPAN_db,  data = df, 
                        level = 1,               # No interaction considered
                        method = "h",            # Exhaustive approach
                        crit = "aicc",            # AIC as criteria
                        confsetsize = Comb,         # Keep all model n^2 
                        plotty = F, report = F,  # plot or interim reports
                        fitfunction = "glm",
                        family = Gamma(link= "log")
)     

POL_R_gama@objects
POL_R_gamaBest <- summary(POL_R_gama@objects[[1]])# selecr best model
print(POL_R_gamaBest) 
POL_R_gama_aic_limt <- weightable(POL_R_gama)
POL_R_gama_aic_limt2 <- POL_R_gama_aic_limt[POL_R_gama_aic_limt$aicc <= min(POL_R_gama_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R_gama_aic_limt2

write.csv(POL_R_gama_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R_gama_aic_limt2.csv")

L <- nrow(POL_R_gama_aic_limt2)

DF_R2g_RMSEg_cv <- NULL

Model_fitted_yg <- NULL



for (i in 1:L){
  zg <- as.formula(paste(POL_R_gama_aic_limt2$model[i]))
  yg <- glm(formula=zg, data = df,
            family= Gamma(link="log")
  )
  sumary_yg <- summary(yg)
  fitted_yg <-c(fitted.values(yg))
  R2g <-  c(cor(df$biomass_Tha,fitted.values(yg))^2)
  LOOCVg <- cv.glm(df, yg, K = nrow(df))
  RMSEg_cv<- (LOOCVg$delta[1])^0.5
  nameg <- paste0("yg",i)
  namesumary_yg <- paste0("sumary_yg",i)
  namefitted_yg <- paste0("fitted_yg", i)
  nameR2g <- paste0("R2g",i)
  nameLOOCVg <- paste0("LOOCVg",i)
  nameRMSEg_cv <- paste0("RMSEg_cv", i)
  assign(nameg, yg)
  assign(namesumary_yg, sumary_yg)
  assign(namefitted_yg,fitted_yg)
  assign(nameLOOCVg, LOOCVg)
  R2g_RMSEg_cv<- data.frame(R2g,RMSEg_cv)
  DF_R2g_RMSEg_cv <- rbind(DF_R2g_RMSEg_cv, R2g_RMSEg_cv)
  Model_fitted_yg <- cbind(Model_fitted_yg, fitted_yg)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_R_g_index <- merge( POL_R_gama_aic_limt2, DF_R2g_RMSEg_cv, by=0, all=TRUE)
print(POL_R_g_index)

write.csv(POL_R_g_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_g_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEg_cv (descrescente ordem)

POL_R_g_index_ord <-arrange(POL_R_g_index, RMSEg_cv)
colnames(POL_R_g_index_ord)[1] <- "Model_index_YG"
print(POL_R_g_index_ord)

write.csv(POL_R_g_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_g_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_yg <- as.formula(paste(POL_R_g_index_ord$model[1]))
Est_yg_RMSE_cvt<- glm(formula=Est_yg, data = df,
          family= Gamma(link="log"))


Est_yg_RMSE_cv <- tidy(Est_yg_RMSE_cvt)


Est_yg_RMSE_cv <- Est_yg_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))
  


print(Est_yg_RMSE_cv)

write.csv(Est_yg_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_yg_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_yg) <- paste("YG", 1:L, sep = "")
Model_fitted_yg <- merge(df$biomass_Tha, Model_fitted_yg, by=0, all=TRUE)
colnames(Model_fitted_yg)[2] <- "biomass_Tha"

print(Model_fitted_yg)

write.csv(Model_fitted_yg, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_yg.csv")



# #####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)
# 
# names = (1:L)
# for (p in 1:L){
# mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_gama_resid_", names[p], ".tiff", sep = ""))
# tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
# mytitle = paste("Model", names[p])
# par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
# plot((POL_R_gama@objects[[p]]), main = mytitle)
# dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
# mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_gama_resid2_", names[p], ".tiff", sep = ""))
# tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
# mytitle = paste("Residuals", names[p])
# plot(residuals(POL_R_gama@objects[[p]]), main = mytitle, ylab="Residual") 
# dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
# mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_gama_resid_stanad_", names[p], ".tiff", sep = ""))
# tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
# mytitle = paste("Residuals standard", names[p])
# plot(residuals_standard <-  rstandard(POL_R_gama@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
# dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyg <- names(Model_fitted_yg)[3:ncol(Model_fitted_yg)]
# print(colNamesyg)
# 
# 
# for (s in colNamesyg){
# print(POL_R_Gama_predic <- ggplot(Model_fitted_yg,  aes_string(Model_fitted_yg$biomass_Tha, s)) +
#   geom_point(shape=16, size=1) +
#   geom_smooth(method= "glm", size=0.5) +
#   theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#         axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#         axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#         axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#         panel.background = element_blank(),
#         panel.grid.major = element_line(colour =  "grey80"), 
#         panel.grid.minor = element_blank(), 
#         axis.line.x=element_line(),
#         axis.line.y=element_line()) +
#   xlab (label = "AGB") +
#   ylab (label = "fitted.valuesed AGB")+
#     scale_x_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)) +
#     scale_y_continuous(breaks = round(seq(min(0), max(df$biomass_Tha), by = 50),1)))
# 
# ggsave(filename=paste("POL_R_Gama_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }




# ######################################################################################
# #
# # MODELOS LM LOG(Y)
# #
# ######################################################################################
# 




POL_R_lmLogy <- glmulti((log(biomass_Tha)) ~ .,  data = df, 
                        level = 1,               # No interaction considered
                        method = "h",            # Exhaustive approach
                        crit = "aicc",            # AIC as criteria
                        confsetsize = Comb,         # Keep all model n^2 
                        plotty = F, report = F,  # plot or interim reports
                        fitfunction = "lm"
                        
)     

POL_R_lmLogy@objects
POL_R_lmLogyBest <- summary(POL_R_lmLogy@objects[[1]])# selecr best model
print(POL_R_lmLogyBest) 
POL_R_lmLogy_aic_limt <- weightable(POL_R_lmLogy)
POL_R_lmLogy_aic_limt2 <- POL_R_lmLogy_aic_limt[POL_R_lmLogy_aic_limt$aicc <= min(POL_R_lmLogy_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R_lmLogy_aic_limt2
write.csv(POL_R_lmLogy_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R_lmLogy_aic_limt2.csv")
POL_R_lmLogy_aic_limt2

write.csv(POL_R_lmLogy_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R_lmLogy_aic_limt2.csv")

POL_R_lmLogyBest
L <- nrow(POL_R_lmLogy_aic_limt2)



m = nrow(POL_R_lmLogy_aic_limt2)
print(m)
RMSE_lmLogy <- numeric(m)  # GUARDA OS rmseLLCV PARA N MDOELOS SELECIONADOS 


# PASSANDO PARA TABLE 

dfPOL<-tbl_df(dfPAL)
n = nrow(dfPOL)
print(n)
em <-numeric(n)    # GUARDA OS ERROS PARA N OBSERVAES


for(j in 1:m) {
  for(k in 1:n){
    lmcv<- dfPOL[-k, ]
    lmf <- as.formula(paste(POL_R_lmLogy_aic_limt2$model[j]))
    lm <- lm(formula=lmf, data = lmcv)
    lmes <- fitted.values(lm, dfPOL[k, ])
    lmexp<-exp(lmes)
    em[k] <- (dfPOL[k, 1] - lmexp)
    RMSE_lmLogy[j] <- (mean(as.numeric(em)^2))^0.5
  } 
}

print(RMSE_lmLogy)


Model_fitted_lmLogy <- NULL

for (h in 1:L){
  zlmLogy <- as.formula(paste(POL_R_lmLogy_aic_limt2$model[h]))
  lmLogy <- lm(formula=zlmLogy, data = df)
  fitted_lmLogy <- fitted.values(lmLogy)
  namefitted_lmLogy <- paste0("fitted_lmLogy", h)
  assign(namefitted_lmLogy,fitted_lmLogy)
  Model_fitted_lmLogy <- cbind(Model_fitted_lmLogy, fitted_lmLogy)
}

print(fitted_lmLogy)
print(Model_fitted_lmLogy)

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_lmLogy) <- paste("lmLogy", 1:L, sep = "")
Model_fitted_lmLogy <- merge(log(df$biomass_Tha), Model_fitted_lmLogy, by=0, all=TRUE)
colnames(Model_fitted_lmLogy)[2] <- "biomass_Tha"

print(Model_fitted_lmLogy)

write.csv(Model_fitted_lmLogy, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_lmLogy.csv")



# # Calcular R^2 na escala 
# 
# lmR <-numeric(m)
# 
# for(r in 1:m) {
#   lmf <- as.formula(paste(POL_R_lmLogy_aic_limt2$model[r]))
#   lm <- lm(formula=lmf, data = df)
#   lmR1<- fitted.values(lm)
#   lmR2<- exp(lmR1)
#   lmR[r] <-  cor(df$biomass_Tha,lmR2)^2
# }
# 
# lmR
# 



# Extrair o R^2 na escala logaritimica 
lmR <- numeric(m)

for(d in 1:m) {
  lmf2 <- as.formula(paste(POL_R_lmLogy_aic_limt2$model[d]))
  lm2 <- lm(formula=lmf2, data = df)
  lmR[d]<- summary.lm(lm2)$r.squared 
}

print(lmR)

#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

DF_R2_lmLogy_RMSEL_cv<- data.frame(lmR,RMSE_lmLogy)

POL_R_lmLogy_index <- merge(POL_R_lmLogy_aic_limt2, DF_R2_lmLogy_RMSEL_cv, by=0, all=TRUE)
print(POL_R_lmLogy_index)

write.csv(POL_R_lmLogy_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_lmLogy_index.csv")



##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)


POL_R_lmLogy_index_ord <-arrange(POL_R_lmLogy_index, RMSE_lmLogy)
colnames(POL_R_lmLogy_index_ord)[1] <- "Model_index_lmLogy"
print(POL_R_lmLogy_index_ord)


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_lmLogy <- as.formula(paste(POL_R_lmLogy_index_ord$model[1]))
Est_lmLogy_RMSE_cvt<- lm(formula=Est_lmLogy, data = df)


Est_lmLogy_RMSE_cv <- tidy(Est_lmLogy_RMSE_cvt)


Est_lmLogy_RMSE_cv <- Est_lmLogy_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

print(Est_lmLogy_RMSE_cv)

write.csv(Est_lmLogy_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_lmLogy_RMSE_cv.csv")


#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_lmLogy_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R_lmLogy@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# 
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_lmLogy_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R_lmLogy@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# 
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_lmLogy_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R_lmLogy@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# 
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNameslmLogy <- names(Model_fitted_lmLogy)[3:ncol(Model_fitted_lmLogy)]
# print(colNameslmLogy)
# 
# 
# # Add as caracteris in ggplot
# 
# FUN <- function(dat, x, y) {
#   ggplot(dat, aes_string(x = x, y = y)) +
#     geom_point(shape=16, size=1) 
#   
#   
# }
# 
# for (F in colNameslmLogy){
#   POL_R_logy_predic<- FUN(Model_fitted_lmLogy, 'biomass_Tha', F)+
#     geom_smooth(method = "lm") +
#     theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#           axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#           axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#           axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#           panel.background = element_blank(),
#           panel.grid.major = element_line(colour =  "grey80"),
#           panel.grid.minor = element_blank(),
#           axis.line.x=element_line(),
#           axis.line.y=element_line()) +
#     xlab (label = "AGB") +
#     ylab (label = "fitted.valuesed AGB")
#   
#   
#   print(POL_R_logy_predic)
#   ggsave(filename=paste("POL_R_logy_predic",F,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }



rm(list= ls()[!(ls() %in% c('df','Comb', 'POL_Rt', 'POL_R_id', 
                            'POL_R_index_ord', 'Est_y_RMSE_cv', 
                            'POL_R_L_index_ord', 'Est_yL_RMSE_cv',
                            'POL_R_g_index_ord', 'Est_yg_RMSE_cv',
                            'POL_R_lmLogy_index_ord','Est_lmLogy_RMSE_cv','FUN',
                            'PAL_cp_summ', 
                            'PAL_cp_summ', 
                            'PAL_fd_summ', 
                            'PAL_tz_summ', 
                            'PAL_vz_summ', 
                            'PAL_ya_summ', 'p_ind_sub_final'))]) 




# ######################################################################################
# #
# # Organizando os resultados best model de cada mtodo
# #
# ######################################################################################
# 


# Criando um data frame com os resultados 
Result_POL_L_18_B <- NULL

# Padronizando o nome das colunas

Best_18_GLM_GAUSS_INDENT <-  POL_R_index_ord %>%
  rename(Model_index = Model_index_y)%>%
  mutate("Model/Distr/Link" = "GLM/GAUSSIAN/IDENTFIC")%>%
  slice(1) 
  
Best_18_GLM_GAUSS_LOG <- POL_R_L_index_ord%>%
  rename(R2 = R2L)%>%
  rename(Model_index = Model_index_yL)%>%
  rename(RMSE_cv = RMSEL_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "GLM/GAUSSIAN/LOG")

Best_18_GLM_GAMMA_LOG <- POL_R_g_index_ord%>%
  rename(R2 = R2g)%>% 
  rename(Model_index = Model_index_YG)%>%
  rename(RMSE_cv = RMSEg_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "GLM/GAMMA/LOG")

Best_18_LM_LOGy <- POL_R_lmLogy_index_ord%>%
  rename(R2 = lmR)%>%
  rename(Model_index = Model_index_lmLogy)%>%
  rename(RMSE_cv = RMSE_lmLogy)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "LM/log(y)")


# Juntando as tabelas com os melhores modelos 

Result_POL_L_18_B <- rbind(Best_18_GLM_GAUSS_INDENT, Best_18_GLM_GAUSS_LOG, Best_18_LM_LOGy)

# Reordenando pelo RMSE_cv e trocando a ordem da coluna com os tipos de modelos

Result_POL_L_18_B <-arrange(Result_POL_L_18_B, RMSE_cv)

#Removendo a coluna peso 

Result_POL_L_18_B <- subset(Result_POL_L_18_B, select=-weights)


# Function moveme
moveMe <- function(data, tomove, where = "last", ba = NULL) {
  temp <- setdiff(names(data), tomove)
  x <- switch(
    where,
    first = data[c(tomove, temp)],
    last = data[c(temp, tomove)],
    before = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)-1))]
    },
    after = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)))]
    })
  x
}
  
Result_POL_L_18_B<-moveMe(Result_POL_L_18_B, c("Model/Distr/Link"), "first")

Result_POL_L_18_B

write.csv(Result_POL_L_18_B, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/RESULTS/Result_POL_L_18_B.csv")


# ##################################################################################################################################
# ######
# # MODELOS cp fd vz ya
# ######
# #######################################################################################################################


####################################
#
# Juntando as variveis cp fd vz ya
#
####################################
# 
# 

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/valores_das_imagens")


dfPALcp <- data.frame(p_ind_sub_final[8], PAL_cp_summ) # p_ind_sub_final[11] = bio
write.csv(dfPALcp, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_3/dfPALcp.csv")

dfPALfd <- data.frame(p_ind_sub_final[8], PAL_fd_summ) # p_ind_sub_final[11] = bio
write.csv(dfPALfd, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_3/dfPALfd.csv")

dfPALvz <- data.frame(p_ind_sub_final[8], PAL_vz_summ) # p_ind_sub_final[11] = bio
write.csv(dfPALvz, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_3/dfPALvz.csv")

dfPALya <- data.frame(p_ind_sub_final[8], PAL_ya_summ) # p_ind_sub_final[11] = bio
write.csv(dfPALya, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_3/dfPALya.csv")



multmerge = function(mypath){
  filenames=list.files(path=mypath, full.names=TRUE)
  datalist = lapply(filenames, function(x){read.csv(file=x,header=T)})
  Reduce(function(x,y) {merge(x,y)}, datalist)}

df3_id = multmerge("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_3")
write.csv(df3_id, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_3_results/df3_id.csv")
write.csv(df3_id, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join/df3_id.csv")



df3_id <- arrange(df3_id, X)
df3 <-df3_id [-1]
df3 <- df3 [-2]
write.csv(df3, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_3_results/df3.csv")



print(cor(df3))
write.csv(cor(df3),"C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_3_results/cor_df3.csv")
scatterplotMatrix(df3, diagonal="histogram", smooth=FALSE)


print(df3)

# # SALVADO OS RESULTADOS EM 18_join_3_results
# 
setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_3_results")

Comb <- 2^((ncol(df3))-1)
print(Comb)


df3_f<- df3


#n <- c("gaussian(link=identity)", "gaussian(link=log)", "Gamma (link=log)")

# ######################################################################################
# #
# # MODELOS GLM MULT LINK = IDENTITY
# #
# ######################################################################################
# 

POL_R3 <- glmulti((biomass_Tha) ~ .,  data =df3_f, 
                  level = 1,               # No interaction considered
                  method = "h",            # Exhaustive approach
                  crit = "aicc",            # AIC as criteria
                  confsetsize = Comb,         # Keep all model n^2 
                  plotty = F, report = F,  # plot or interim reports
                  fitfunction = "glm",
                  family=gaussian(link="identity")
)     # lm function

#POL_R3@objects
POL_R3Best <- summary(POL_R3@objects[[1]])# selecr best model 
print(POL_R3Best)
POL_R3_aic_limt <- weightable(POL_R3)
POL_R3_aic_limt2 <- POL_R3_aic_limt[POL_R3_aic_limt$aicc <= min(POL_R3_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R3_aic_limt2

write.csv(POL_R3_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R3_aic_limt2.csv")


L <- nrow(POL_R3_aic_limt2)

DF_POL_L3_R2_RMSE_cv <- NULL

Model_fitted_POL_L3_y <- NULL



for (i in 1:L){
  z <- as.formula(paste(POL_R3_aic_limt2$model[i]))
  y <- glm(formula=z, data =df3_f,
           family= gaussian("identity")
  )
  sumary_y <- summary(y)
  fitted_y <-c(fitted.values(y))
  R2 <-  c(cor(df3_f$biomass_Tha,fitted.values(y))^2)
  LOOCV <- cv.glm(df3_f, y, K = nrow(df3_f))
  RMSE_cv<- (LOOCV$delta[1])^0.5
  name <- paste0("y",i)
  namesumary_y <- paste0("sumary_y",i)
  namefitted_y <- paste0("fitted_y", i)
  nameR2 <- paste0("R2",i)
  nameLOOCV <- paste0("LOOCV",i)
  nameRMSE_cv <- paste0("RMSE_cv", i)
  assign(name, y)
  assign(namesumary_y, sumary_y)
  assign(namefitted_y,fitted_y)
  assign(nameLOOCV, LOOCV)
  R2_RMSE_cv<- data.frame(R2,RMSE_cv)
  DF_POL_L3_R2_RMSE_cv <- rbind(DF_POL_L3_R2_RMSE_cv, R2_RMSE_cv)
  Model_fitted_POL_L3_y <- cbind(Model_fitted_POL_L3_y, fitted_y)
}



#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_R3_index <- merge( POL_R3_aic_limt2, DF_POL_L3_R2_RMSE_cv, by=0, all=TRUE)
print(POL_R3_index)

write.csv(POL_R3_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R3_index.csv")


##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)

POL_R3_index_ord <-arrange(POL_R3_index, RMSE_cv)
colnames(POL_R3_index_ord)[1] <- "Model_index_y"
print(POL_R3_index_ord)

write.csv(POL_R3_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R3_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L3 <- as.formula(paste(POL_R3_index_ord$model[1]))
Est_POL_L3_RMSE_cvt<- glm(formula=Est_POL_L3, data =df3_f,
                          family= gaussian(link="identity"))


Est_POL_L3_RMSE_cv <- tidy(Est_POL_L3_RMSE_cvt)


Est_POL_L3_RMSE_cv <- Est_POL_L3_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_POL_L3_RMSE_cv)

write.csv(Est_POL_L3_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_POL_L3_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L3_y) <- paste("y", 1:L, sep = "")
Model_fitted_POL_L3_y <- merge(df3_f$biomass_Tha, Model_fitted_POL_L3_y, by=0, all=TRUE)
colnames(Model_fitted_POL_L3_y)[2] <- "biomass_Tha"

print(Model_fitted_POL_L3_y)

write.csv(Model_fitted_POL_L3_y, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_POL_L3_y.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R3@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R3@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R3@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesy <- names(Model_fitted_POL_L3_y)[3:ncol(Model_fitted_POL_L3_y)]
# print(colNamesy)
# 
# 
# for (s in colNamesy){
#   print(POL_R3_predic <- ggplot(Model_fitted_POL_L3_y,  aes_string("biomass_Tha", s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method= "glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_R3_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }


# rm(list= ls()[!(ls() %in% c('df3_f','Comb', 'POL_R3t', 'POL_R3_id', 
#                             'POL_R3_index_ord', 'Est_POL_L3_RMSE_cv'))])



# ######################################################################################
# #
# # MODELOS GLM MULT LINK = LOG
# #
# ######################################################################################



POL_R3_log <- glmulti((biomass_Tha) ~ .,  data =df3_f, 
                      level = 1,               # No interaction considered
                      method = "h",            # Exhaustive approach
                      crit = "aicc",            # AIC as criteria
                      confsetsize = Comb,         # Keep all model n^2 
                      plotty = F, report = F,  # plot or interim reports
                      fitfunction = "glm",
                      family = gaussian(link="log")
)     

#POL_R3_log@objects
POL_R3_logBest <- summary(POL_R3_log@objects[[1]])# selecr best model
print(POL_R3_logBest) 
POL_R3_log_aic_limt <- weightable(POL_R3_log)
POL_R3_log_aic_limt2 <- POL_R3_log_aic_limt[POL_R3_log_aic_limt$aicc <= min(POL_R3_log_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R3_log_aic_limt2

write.csv(POL_R3_log_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R3_log_aic_limt2.csv")

L <- nrow(POL_R3_log_aic_limt2)

DF_POL_L3_R2L_RMSEL_cv <- NULL


Model_fitted_POL_L3_yL <- NULL



for (i in 1:L){
  zL <- as.formula(paste(POL_R3_log_aic_limt2$model[i]))
  yL <- glm(formula=zL, data =df3_f,
            family= gaussian(link="log")
  )
  sumary_yL <- summary(yL)
  fitted_yL <-c(fitted.values(yL))
  R2L <-  c(cor(df3_f$biomass_Tha,fitted.values(yL))^2)
  LOOCVL <- cv.glm(df3_f, yL, K = nrow(df3_f))
  RMSEL_cv<- (LOOCVL$delta[1])^0.5
  nameL <- paste0("yL",i)
  namesumary_yL <- paste0("sumary_yL",i)
  namefitted_yL <- paste0("fitted_yL", i)
  nameR2L <- paste0("R2L",i)
  nameLOOCVL <- paste0("LOOCVL",i)
  nameRMSEL_cv <- paste0("RMSEL_cv", i)
  assign(nameL, yL)
  assign(namesumary_yL, sumary_yL)
  assign(namefitted_yL,fitted_yL)
  assign(nameLOOCVL, LOOCVL)
  R2L_RMSEL_cv<- data.frame(R2L,RMSEL_cv)
  DF_POL_L3_R2L_RMSEL_cv <- rbind(DF_POL_L3_R2L_RMSEL_cv, R2L_RMSEL_cv)
  Model_fitted_POL_L3_yL <- cbind(Model_fitted_POL_L3_yL, fitted_yL)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_R3_L_index <- merge( POL_R3_log_aic_limt2, DF_POL_L3_R2L_RMSEL_cv, by=0, all=TRUE)
print(POL_R3_L_index)

write.csv(POL_R3_L_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R3_L_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEL_cv (descrescente ordem)

POL_R3_L_index_ord <-arrange(POL_R3_L_index, RMSEL_cv)
colnames(POL_R3_L_index_ord)[1] <- "Model_index_yL"
print(POL_R3_L_index_ord)

write.csv(POL_R3_L_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R3_L_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L3L <- as.formula(paste(POL_R3_L_index_ord$model[1]))
Est_POL_L3L_RMSE_cvt<- glm(formula=Est_POL_L3L, data =df3_f,
                           family= gaussian(link="log"))


Est_POL_L3L_RMSE_cv <- tidy(Est_POL_L3L_RMSE_cvt)


Est_POL_L3L_RMSE_cv <- Est_POL_L3L_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_POL_L3L_RMSE_cv)

write.csv(Est_POL_L3L_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_POL_L3L_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L3_yL) <- paste("yL", 1:L, sep = "")
Model_fitted_POL_L3_yL <- merge(df3_f$biomass_Tha, Model_fitted_POL_L3_yL, by=0, all=TRUE)
colnames(Model_fitted_POL_L3_yL)[2] <- "biomass_Tha"

print(Model_fitted_POL_L3_yL)

write.csv(Model_fitted_POL_L3_yL, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_POL_L3_yL.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_log_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R3_log@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_log_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R3_log@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_log_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R3_log@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyL <- names(Model_fitted_POL_L3_yL)[3:ncol(Model_fitted_POL_L3_yL)]
# print(colNamesyL)
# 
# 
# for (s in colNamesyL){
#   print(POL_R3_log_predic <- ggplot(Model_fitted_POL_L3_yL,  aes_string(Model_fitted_POL_L3_yL$biomass_Tha, s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method="glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_R3_log_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }

# rm(list= ls()[!(ls() %in% c('df3_f','Comb', 'POL_R3t', 'POL_R3_id', 
#                             'POL_R3_index_ord', 'Est_POL_L3_RMSE_cv', 
#                             'POL_R3_L_index_ord', 'Est_POL_L3L_RMSE_cv'))])





# ######################################################################################
# #
# # MODELOS GLM MULT LINK = GAMA (LINK=LOG)
# #
# ######################################################################################
# 



POL_R3_gama <- glmulti((biomass_Tha) ~ 1  + ya_db + ya_odd, data =df3_f, 
                       level = 1,               # No interaction considered
                       method = "h",            # Exhaustive approach
                       crit = "aicc",            # AIC as criteria
                       confsetsize = Comb,         # Keep all model n^2 
                       plotty = F, report = F,  # plot or interim reports
                       fitfunction = "glm",
                       family = Gamma(link= "log")
)     

#POL_R3_gama@objects
POL_R3_gamaBest <- summary(POL_R3_gama@objects[[1]])# selecr best model
print(POL_R3_gamaBest) 
POL_R3_gama_aic_limt <- weightable(POL_R3_gama)
POL_R3_gama_aic_limt2 <- POL_R3_gama_aic_limt[POL_R3_gama_aic_limt$aicc <= min(POL_R3_gama_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R3_gama_aic_limt2

write.csv(POL_R3_gama_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R3_gama_aic_limt2.csv")

L <- nrow(POL_R3_gama_aic_limt2)

DF_POL_L3_R2g_RMSEg_cv <- NULL

Model_fitted_POL_L3_yg <- NULL



for (i in 1:L){
  zg <- as.formula(paste(POL_R3_gama_aic_limt2$model[i]))
  yg <- glm(formula=zg, data =df3_f,
            family= Gamma(link="log")
  )
  sumary_yg <- summary(yg)
  fitted_yg <-c(fitted.values(yg))
  R2g <-  c(cor(df3_f$biomass_Tha,fitted.values(yg))^2)
  LOOCVg <- cv.glm(df3_f, yg, K = nrow(df3_f))
  RMSEg_cv<- (LOOCVg$delta[1])^0.5
  nameg <- paste0("yg",i)
  namesumary_yg <- paste0("sumary_yg",i)
  namefitted_yg <- paste0("fitted_yg", i)
  nameR2g <- paste0("R2g",i)
  nameLOOCVg <- paste0("LOOCVg",i)
  nameRMSEg_cv <- paste0("RMSEg_cv", i)
  assign(nameg, yg)
  assign(namesumary_yg, sumary_yg)
  assign(namefitted_yg,fitted_yg)
  assign(nameLOOCVg, LOOCVg)
  R2g_RMSEg_cv<- data.frame(R2g,RMSEg_cv)
  DF_POL_L3_R2g_RMSEg_cv <- rbind(DF_POL_L3_R2g_RMSEg_cv, R2g_RMSEg_cv)
  Model_fitted_POL_L3_yg <- cbind(Model_fitted_POL_L3_yg, fitted_yg)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_R3_g_index <- merge( POL_R3_gama_aic_limt2, DF_POL_L3_R2g_RMSEg_cv, by=0, all=TRUE)
print(POL_R3_g_index)

write.csv(POL_R3_g_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R3_g_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEg_cv (descrescente ordem)

POL_R3_g_index_ord <-arrange(POL_R3_g_index, RMSEg_cv)
colnames(POL_R3_g_index_ord)[1] <- "Model_index_YG"
print(POL_R3_g_index_ord)

write.csv(POL_R3_g_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R3_g_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L3g <- as.formula(paste(POL_R3_g_index_ord$model[1]))
Est_POL_L3g_RMSE_cvt<- glm(formula=Est_POL_L3g, data =df3_f,
                           family= Gamma(link="log"))


Est_POL_L3g_RMSE_cv <- tidy(Est_POL_L3g_RMSE_cvt)


Est_POL_L3g_RMSE_cv <- Est_POL_L3g_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_POL_L3g_RMSE_cv)

write.csv(Est_POL_L3g_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_POL_L3g_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L3_yg) <- paste("YG", 1:L, sep = "")
Model_fitted_POL_L3_yg <- merge(df3_f$biomass_Tha, Model_fitted_POL_L3_yg, by=0, all=TRUE)
colnames(Model_fitted_POL_L3_yg)[2] <- "biomass_Tha"

print(Model_fitted_POL_L3_yg)

write.csv(Model_fitted_POL_L3_yg, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_POL_L3_yg.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_gama_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R3_gama@objects[[p]]), main = mytitle)
#   dev.off()
# }

#####  plot Residual

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_gama_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R3_gama@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_gama_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R3_gama@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyg <- names(Model_fitted_POL_L3_yg)[3:ncol(Model_fitted_POL_L3_yg)]
# print(colNamesyg)
# 
# 
# for (s in colNamesyg){
#   print(POL_R3_Gama_predic <- ggplot(Model_fitted_POL_L3_yg,  aes_string(Model_fitted_POL_L3_yg$biomass_Tha, s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method= "glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_R3_Gama_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }
# 

#### Removendo tabelas que no seram mais usadas


# rm(list= ls()[!(ls() %in% c('df3_f','Comb', 'POL_R3t', 'POL_R3_id', 
#                             'POL_R3_index_ord', 'Est_POL_L3_RMSE_cv', 
#                             'POL_R3_L_index_ord', 'Est_POL_L3L_RMSE_cv',
#                             'POL_R3_g_index_ord', 'Est_POL_L3g_RMSE_cv'))]) 
# 


# ######################################################################################
# #
# # MODELOS LM LOG(Y)
# #
# ######################################################################################
# 




POL_R3_lmLogy <- glmulti((log(biomass_Tha)) ~ .,  data =df3_f, 
                         level = 1,               # No interaction considered
                         method = "h",            # Exhaustive approach
                         crit = "aicc",            # AIC as criteria
                         confsetsize = Comb,         # Keep all model n^2 
                         plotty = F, report = F,  # plot or interim reports
                         fitfunction = "lm"
                         
)     

POL_R3_lmLogy@objects
POL_R3_lmLogyBest <- summary(POL_R3_lmLogy@objects[[1]])# selecr best model
print(POL_R3_lmLogyBest) 
POL_R3_lmLogy_aic_limt <- weightable(POL_R3_lmLogy)
POL_R3_lmLogy_aic_limt2 <- POL_R3_lmLogy_aic_limt[POL_R3_lmLogy_aic_limt$aicc <= min(POL_R3_lmLogy_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R3_lmLogy_aic_limt2
write.csv(POL_R3_lmLogy_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R3_lmLogy_aic_limt2.csv")
POL_R3_lmLogy_aic_limt2

POL_R3_lmLogyBest
L <- nrow(POL_R3_lmLogy_aic_limt2)



m = nrow(POL_R3_lmLogy_aic_limt2)
print(m)
POL_R3_RMSE_lmLogy <- numeric(m)  # GUARDA OS rmseLLCV PARA N MDOELOS SELECIONADOS 


# PASSANDO PARA TABLE 

dfPOL<-tbl_df(df3_f)
n = nrow(df3_f)
print(n)
em <-numeric(n)    # GUARDA OS ERROS PARA N OBSERVAES


for(j in 1:m) {
  for(k in 1:n){
    lmcv<- dfPOL[-k, ]
    lmf <- as.formula(paste(POL_R3_lmLogy_aic_limt2$model[j]))
    lm <- lm(formula=lmf, data = lmcv)
    lmes <- fitted.values(lm, dfPOL[k, ])
    lmexp<-exp(lmes)
    em[k] <- (dfPOL[k, 1] - lmexp)
    POL_R3_RMSE_lmLogy[j] <- (mean(as.numeric(em)^2))^0.5
  } 
}

print(POL_R3_RMSE_lmLogy)


Model_fitted_POL_L3_lmLogy <- NULL

for (h in 1:L){
  zlmLogy <- as.formula(paste(POL_R3_lmLogy_aic_limt2$model[h]))
  lmLogy <- lm(formula=zlmLogy, data =df3_f)
  fitted_lmLogy <- fitted.values(lmLogy)
  namefitted_lmLogy <- paste0("fitted_lmLogy", h)
  assign(namefitted_lmLogy,fitted_lmLogy)
  Model_fitted_POL_L3_lmLogy <- cbind(Model_fitted_POL_L3_lmLogy, fitted_lmLogy)
}

print(fitted_lmLogy)
print(Model_fitted_POL_L3_lmLogy)

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L3_lmLogy) <- paste("lmLogy", 1:L, sep = "")
Model_fitted_POL_L3_lmLogy <- merge(log(df3_f$biomass_Tha), Model_fitted_POL_L3_lmLogy, by=0, all=TRUE)
colnames(Model_fitted_POL_L3_lmLogy)[2] <- "biomass_Tha"

print(Model_fitted_POL_L3_lmLogy)

write.csv(Model_fitted_POL_L3_lmLogy, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_POL_L3_lmLogy.csv")



# # Calcular R^2 na escala 
# 
# lmR_POL_L3 <-numeric(m)
# 
# for(r in 1:m) {
#   lmf <- as.formula(paste(POL_R3_lmLogy_aic_limt2$model[r]))
#   lm <- lm(formula=lmf, data =df3_f)
#   lmR_POL_L31<- fitted.values(lm)
#   lmR_POL_L32<- exp(lmR_POL_L31)
#   lmR_POL_L3[r] <-  cor(df3_f$biomass_Tha,lmR_POL_L32)^2
# }
# 
# lmR_POL_L3
# 



# Extrair o R^2 na escala logaritimica 
lmR_POL_L3 <- numeric(m)

for(d in 1:m) {
  lmf2 <- as.formula(paste(POL_R3_lmLogy_aic_limt2$model[d]))
  lm2 <- lm(formula=lmf2, data =df3_f)
  lmR_POL_L3[d]<- summary.lm(lm2)$r.squared 
}

print(lmR_POL_L3)

#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

DF_POL_L3_R2_lmLogy_RMSEL_cv<- data.frame(lmR_POL_L3,POL_R3_RMSE_lmLogy)

POL_R3_lmLogy_index <- merge(POL_R3_lmLogy_aic_limt2, DF_POL_L3_R2_lmLogy_RMSEL_cv, by=0, all=TRUE)
print(POL_R3_lmLogy_index)

write.csv(POL_R3_lmLogy_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R3_lmLogy_index.csv")



##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)


POL_R3_lmLogy_index_ord <-arrange(POL_R3_lmLogy_index, POL_R3_RMSE_lmLogy)
colnames(POL_R3_lmLogy_index_ord)[1] <- "Model_index_lmLogy"
print(POL_R3_lmLogy_index_ord)


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L3_lmLogy <- as.formula(paste(POL_R3_lmLogy_index_ord$model[1]))
Est_POL_L3_lmLogy_RMSE_cvt<- lm(formula=Est_POL_L3_lmLogy, data =df3_f)


Est_POL_L3_lmLogy_RMSE_cv <- tidy(Est_POL_L3_lmLogy_RMSE_cvt)


Est_POL_L3_lmLogy_RMSE_cv <- Est_POL_L3_lmLogy_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

print(Est_POL_L3_lmLogy_RMSE_cv)

write.csv(Est_POL_L3_lmLogy_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_POL_L3_lmLogy_RMSE_cv.csv")


#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_lmLogy_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R3_lmLogy@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_lmLogy_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R3_lmLogy@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R3_lmLogy_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R3_lmLogy@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# 
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNameslmLogy <- names(Model_fitted_POL_L3_lmLogy)[3:ncol(Model_fitted_POL_L3_lmLogy)]
# print(colNameslmLogy)
# 
# 
# # Add as caracteris in ggplot
# 
# FUN <- function(dat, x, y) {
#   ggplot(dat, aes_string(x = x, y = y)) +
#     geom_point(shape=16, size=1) 
#   
#   
# }
# 
# for (F in colNameslmLogy){
#   POL_R3_logy_predic<- FUN(Model_fitted_POL_L3_lmLogy, 'biomass_Tha', F)+
#     geom_smooth(method = "lm") +
#     theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#           axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#           axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#           axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#           panel.background = element_blank(),
#           panel.grid.major = element_line(colour =  "grey80"),
#           panel.grid.minor = element_blank(),
#           axis.line.x=element_line(),
#           axis.line.y=element_line()) +
#     xlab (label = "AGB") +
#     ylab (label = "fitted.valuesed AGB")
#   
#   
#   print(POL_R3_logy_predic)
#   ggsave(filename=paste("POL_R3_logy_predic",F,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }
# 





# ######################################################################################
# #
# # Organizando os resultados best model de cada mtodo
# #
# ######################################################################################
# 


# Criando um data frame com os resultados 
Result_POL_L3_18_B <- NULL

# Padronizando o nome das colunas

Best_18_GLM_GAUSS_INDENT <-  POL_R3_index_ord %>%
  rename(Model_index = Model_index_y)%>%
  mutate("Model/Distr/Link" = "GLM/GAUSSIAN/IDENTFIC")%>%
  slice(1) 

Best_18_GLM_GAUSS_LOG <- POL_R3_L_index_ord%>%
  rename(R2 = R2L)%>%
  rename(Model_index = Model_index_yL)%>%
  rename(RMSE_cv = RMSEL_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "GLM/GAUSSIAN/LOG")

Best_18_GLM_GAMMA_LOG <- POL_R3_g_index_ord%>%
  rename(R2 = R2g)%>% 
  rename(Model_index = Model_index_YG)%>%
  rename(RMSE_cv = RMSEg_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "GLM/GAMMA/LOG")

Best_18_LM_LOGy <- POL_R3_lmLogy_index_ord%>%
  rename(R2 = lmR_POL_L3)%>%
  rename(Model_index = Model_index_lmLogy)%>%
  rename(RMSE_cv = POL_R3_RMSE_lmLogy)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "LM/log(y)")


# Juntando as tabelas com os melhores modelos 

Result_POL_L3_18_B <- rbind(Best_18_GLM_GAUSS_INDENT, Best_18_GLM_GAUSS_LOG,  Best_18_LM_LOGy)

# Reordenando pelo RMSE_cv e trocando a ordem da coluna com os tipos de modelos

Result_POL_L3_18_B <-arrange(Result_POL_L3_18_B, RMSE_cv)

#Removendo a coluna peso 

Result_POL_L3_18_B <- subset(Result_POL_L3_18_B, select=-weights)


# Function moveme
moveMe <- function(data, tomove, where = "last", ba = NULL) {
  temp <- setdiff(names(data), tomove)
  x <- switch(
    where,
    first = data[c(tomove, temp)],
    last = data[c(temp, tomove)],
    before = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)-1))]
    },
    after = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)))]
    })
  x
}

Result_POL_L3_18_B<-moveMe(Result_POL_L3_18_B, c("Model/Distr/Link"), "first")

Result_POL_L3_18_B

write.csv(Result_POL_L3_18_B, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/RESULTS/Result_POL_L3_18_B.csv")







# ##################################################################################################################################
# ######
# # MODELOS tz
# ######
# #######################################################################################################################


dfPALtz_id <- data.frame(p_ind_sub_final[8], PAL_tz_summ ) # p_ind_sub_final[11] = bio
write.csv(dfPALtz_id, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_tz_results/dfPALtz_id.csv")
write.csv(dfPALtz_id, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join/dfPALtz_id.csv")



dfPALtz <- dfPALtz_id [-2]
write.csv(dfPALtz, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_tz_results/dfPALtz.csv")


print(cor(dfPALtz))
write.csv(cor(dfPALtz),"C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_tz_results/cor_dfPALtz.csv")
scatterplotMatrix(dfPALtz, diagonal="histogram", smooth=FALSE)

print(dfPALtz)


######################## Salvando na Pasta 18_join_tz_results



setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join_tz_results")

Comb <- 2^((ncol(dfPALtz))-1)
print(Comb)



dftz<- dfPALtz




#n <- c("gaussian(link=identity)", "gaussian(link=log)", "Gamma (link=log)")



# ######################################################################################
# #
# # MODELOS GLM MULT LINK = IDENTITY
# #
# ######################################################################################
# 

POL_R_tz <- glmulti((biomass_Tha) ~ .,  data =dftz, 
                    level = 1,               # No interaction considered
                    method = "h",            # Exhaustive approach
                    crit = "aicc",            # AIC as criteria
                    confsetsize = Comb,         # Keep all model n^2 
                    plotty = F, report = F,  # plot or interim reports
                    fitfunction = "glm",
                    family=gaussian(link="identity")
)     # lm function

#POL_R_tz@objects
POL_R_tzBest <- summary(POL_R_tz@objects[[1]])# selecr best model 
print(POL_R_tzBest)
POL_R_tz_aic_limt <- weightable(POL_R_tz)
POL_R_tz_aic_limt2 <- POL_R_tz_aic_limt[POL_R_tz_aic_limt$aicc <= min(POL_R_tz_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R_tz_aic_limt2

write.csv(POL_R_tz_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R_tz_aic_limt2.csv")


L <- nrow(POL_R_tz_aic_limt2)

DF_POL_L_tz_R2_RMSE_cv <- NULL

Model_fitted_POL_L_tz_y <- NULL



for (i in 1:L){
  z <- as.formula(paste(POL_R_tz_aic_limt2$model[i]))
  y <- glm(formula=z, data =dftz,
           family= gaussian("identity")
  )
  sumary_y <- summary(y)
  fitted_y <-c(fitted.values(y))
  R2 <-  c(cor(dftz$biomass_Tha,fitted.values(y))^2)
  LOOCV <- cv.glm(dftz, y, K = nrow(dftz))
  RMSE_cv<- (LOOCV$delta[1])^0.5
  name <- paste0("y",i)
  namesumary_y <- paste0("sumary_y",i)
  namefitted_y <- paste0("fitted_y", i)
  nameR2 <- paste0("R2",i)
  nameLOOCV <- paste0("LOOCV",i)
  nameRMSE_cv <- paste0("RMSE_cv", i)
  assign(name, y)
  assign(namesumary_y, sumary_y)
  assign(namefitted_y,fitted_y)
  assign(nameLOOCV, LOOCV)
  R2_RMSE_cv<- data.frame(R2,RMSE_cv)
  DF_POL_L_tz_R2_RMSE_cv <- rbind(DF_POL_L_tz_R2_RMSE_cv, R2_RMSE_cv)
  Model_fitted_POL_L_tz_y <- cbind(Model_fitted_POL_L_tz_y, fitted_y)
}



#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_R_tz_index <- merge( POL_R_tz_aic_limt2, DF_POL_L_tz_R2_RMSE_cv, by=0, all=TRUE)
print(POL_R_tz_index)

write.csv(POL_R_tz_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_tz_index.csv")


##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)

POL_R_tz_index_ord <-arrange(POL_R_tz_index, RMSE_cv)
colnames(POL_R_tz_index_ord)[1] <- "Model_index_y"
print(POL_R_tz_index_ord)

write.csv(POL_R_tz_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_tz_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L_tz <- as.formula(paste(POL_R_tz_index_ord$model[1]))
Est_POL_L_tz_RMSE_cvt<- glm(formula=Est_POL_L_tz, data =dftz,
                            family= gaussian(link="identity"))


Est_POL_L_tz_RMSE_cv <- tidy(Est_POL_L_tz_RMSE_cvt)


Est_POL_L_tz_RMSE_cv <- Est_POL_L_tz_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_POL_L_tz_RMSE_cv)

write.csv(Est_POL_L_tz_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_POL_L_tz_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L_tz_y) <- paste("y", 1:L, sep = "")
Model_fitted_POL_L_tz_y <- merge(dftz$biomass_Tha, Model_fitted_POL_L_tz_y, by=0, all=TRUE)
colnames(Model_fitted_POL_L_tz_y)[2] <- "biomass_Tha"

print(Model_fitted_POL_L_tz_y)

write.csv(Model_fitted_POL_L_tz_y, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_POL_L_tz_y.csv")



# #####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R_tz@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R_tz@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R_tz@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesy <- names(Model_fitted_POL_L_tz_y)[3:ncol(Model_fitted_POL_L_tz_y)]
# print(colNamesy)
# 
# 
# for (s in colNamesy){
#   print(POL_R_tz_predic <- ggplot(Model_fitted_POL_L_tz_y,  aes_string("biomass_Tha", s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method= "glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(dftz$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(dftz$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_R_tz_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }


# rm(list= ls()[!(ls() %in% c('dftz','Comb', 'POL_R_tzt', 'POL_R_tz_id', 
#                             'POL_R_tz_index_ord', 'Est_POL_L_tz_RMSE_cv'))])



# ######################################################################################
# #
# # MODELOS GLM MULT LINK = LOG
# #
# ######################################################################################



POL_R_tz_log <- glmulti((biomass_Tha) ~ .,  data =dftz, 
                        level = 1,               # No interaction considered
                        method = "h",            # Exhaustive approach
                        crit = "aicc",            # AIC as criteria
                        confsetsize = Comb,         # Keep all model n^2 
                        plotty = F, report = F,  # plot or interim reports
                        fitfunction = "glm",
                        family = gaussian(link="log")
)     

#POL_R_tz_log@objects
POL_R_tz_logBest <- summary(POL_R_tz_log@objects[[1]])# selecr best model
print(POL_R_tz_logBest) 
POL_R_tz_log_aic_limt <- weightable(POL_R_tz_log)
POL_R_tz_log_aic_limt2 <- POL_R_tz_log_aic_limt[POL_R_tz_log_aic_limt$aicc <= min(POL_R_tz_log_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R_tz_log_aic_limt2

write.csv(POL_R_tz_log_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R_tz_log_aic_limt2.csv")

L <- nrow(POL_R_tz_log_aic_limt2)

DF_POL_L_tz_R2L_RMSEL_cv <- NULL


Model_fitted_POL_L_tz_yL <- NULL



for (i in 1:L){
  zL <- as.formula(paste(POL_R_tz_log_aic_limt2$model[i]))
  yL <- glm(formula=zL, data =dftz,
            family= gaussian(link="log")
  )
  sumary_yL <- summary(yL)
  fitted_yL <-c(fitted.values(yL))
  R2L <-  c(cor(dftz$biomass_Tha,fitted.values(yL))^2)
  LOOCVL <- cv.glm(dftz, yL, K = nrow(dftz))
  RMSEL_cv<- (LOOCVL$delta[1])^0.5
  nameL <- paste0("yL",i)
  namesumary_yL <- paste0("sumary_yL",i)
  namefitted_yL <- paste0("fitted_yL", i)
  nameR2L <- paste0("R2L",i)
  nameLOOCVL <- paste0("LOOCVL",i)
  nameRMSEL_cv <- paste0("RMSEL_cv", i)
  assign(nameL, yL)
  assign(namesumary_yL, sumary_yL)
  assign(namefitted_yL,fitted_yL)
  assign(nameLOOCVL, LOOCVL)
  R2L_RMSEL_cv<- data.frame(R2L,RMSEL_cv)
  DF_POL_L_tz_R2L_RMSEL_cv <- rbind(DF_POL_L_tz_R2L_RMSEL_cv, R2L_RMSEL_cv)
  Model_fitted_POL_L_tz_yL <- cbind(Model_fitted_POL_L_tz_yL, fitted_yL)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_R_tz_L_index <- merge( POL_R_tz_log_aic_limt2, DF_POL_L_tz_R2L_RMSEL_cv, by=0, all=TRUE)
print(POL_R_tz_L_index)

write.csv(POL_R_tz_L_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_tz_L_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEL_cv (descrescente ordem)

POL_R_tz_L_index_ord <-arrange(POL_R_tz_L_index, RMSEL_cv)
colnames(POL_R_tz_L_index_ord)[1] <- "Model_index_yL"
print(POL_R_tz_L_index_ord)

write.csv(POL_R_tz_L_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_tz_L_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L_tzL <- as.formula(paste(POL_R_tz_L_index_ord$model[1]))
Est_POL_L_tzL_RMSE_cvt<- glm(formula=Est_POL_L_tzL, data =dftz,
                             family= gaussian(link="log"))


Est_POL_L_tzL_RMSE_cv <- tidy(Est_POL_L_tzL_RMSE_cvt)


Est_POL_L_tzL_RMSE_cv <- Est_POL_L_tzL_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_POL_L_tzL_RMSE_cv)

write.csv(Est_POL_L_tzL_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_POL_L_tzL_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L_tz_yL) <- paste("yL", 1:L, sep = "")
Model_fitted_POL_L_tz_yL <- merge(dftz$biomass_Tha, Model_fitted_POL_L_tz_yL, by=0, all=TRUE)
colnames(Model_fitted_POL_L_tz_yL)[2] <- "biomass_Tha"

print(Model_fitted_POL_L_tz_yL)

write.csv(Model_fitted_POL_L_tz_yL, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_POL_L_tz_yL.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_log_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R_tz_log@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_log_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R_tz_log@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_log_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R_tz_log@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyL <- names(Model_fitted_POL_L_tz_yL)[3:ncol(Model_fitted_POL_L_tz_yL)]
# print(colNamesyL)
# 
# 
# for (s in colNamesyL){
#   print(POL_R_tz_log_predic <- ggplot(Model_fitted_POL_L_tz_yL,  aes_string(Model_fitted_POL_L_tz_yL$biomass_Tha, s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method="glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(dftz$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(dftz$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_R_tz_log_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }
# 
# # rm(list= ls()[!(ls() %in% c('dftz','Comb', 'POL_R_tzt', 'POL_R_tz_id', 
# #                             'POL_R_tz_index_ord', 'Est_POL_L_tz_RMSE_cv', 
# #                             'POL_R_tz_L_index_ord', 'Est_POL_L_tzL_RMSE_cv'))])





# ######################################################################################
# #
# # MODELOS GLM MULT LINK = GAMA (LINK=LOG)
# #
# ######################################################################################
# 



POL_R_tz_gama <- glmulti((biomass_Tha) ~ 1  + tz_alphas3 + tz_phis3, data =dftz, 
                         level = 1,               # No interaction considered
                         method = "h",            # Exhaustive approach
                         crit = "aicc",            # AIC as criteria
                         confsetsize = Comb,         # Keep all model n^2 
                         plotty = F, report = F,  # plot or interim reports
                         fitfunction = "glm",
                         family = Gamma(link= "log")
)     

#POL_R_tz_gama@objects
POL_R_tz_gamaBest <- summary(POL_R_tz_gama@objects[[1]])# selecr best model
print(POL_R_tz_gamaBest) 
POL_R_tz_gama_aic_limt <- weightable(POL_R_tz_gama)
POL_R_tz_gama_aic_limt2 <- POL_R_tz_gama_aic_limt[POL_R_tz_gama_aic_limt$aicc <= min(POL_R_tz_gama_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R_tz_gama_aic_limt2
write.csv(POL_R_tz_gama_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R_tz_gama_aic_limt2.csv")



L <- nrow(POL_R_tz_gama_aic_limt2)

DF_POL_L_tz_R2g_RMSEg_cv <- NULL

Model_fitted_POL_L_tz_yg <- NULL



for (i in 1:L){
  zg <- as.formula(paste(POL_R_tz_gama_aic_limt2$model[i]))
  yg <- glm(formula=zg, data =dftz,
            family= Gamma(link="log")
  )
  sumary_yg <- summary(yg)
  fitted_yg <-c(fitted.values(yg))
  R2g <-  c(cor(dftz$biomass_Tha,fitted.values(yg))^2)
  LOOCVg <- cv.glm(dftz, yg, K = nrow(dftz))
  RMSEg_cv<- (LOOCVg$delta[1])^0.5
  nameg <- paste0("yg",i)
  namesumary_yg <- paste0("sumary_yg",i)
  namefitted_yg <- paste0("fitted_yg", i)
  nameR2g <- paste0("R2g",i)
  nameLOOCVg <- paste0("LOOCVg",i)
  nameRMSEg_cv <- paste0("RMSEg_cv", i)
  assign(nameg, yg)
  assign(namesumary_yg, sumary_yg)
  assign(namefitted_yg,fitted_yg)
  assign(nameLOOCVg, LOOCVg)
  R2g_RMSEg_cv<- data.frame(R2g,RMSEg_cv)
  DF_POL_L_tz_R2g_RMSEg_cv <- rbind(DF_POL_L_tz_R2g_RMSEg_cv, R2g_RMSEg_cv)
  Model_fitted_POL_L_tz_yg <- cbind(Model_fitted_POL_L_tz_yg, fitted_yg)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_R_tz_g_index <- merge( POL_R_tz_gama_aic_limt2, DF_POL_L_tz_R2g_RMSEg_cv, by=0, all=TRUE)
print(POL_R_tz_g_index)

write.csv(POL_R_tz_g_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_tz_g_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEg_cv (descrescente ordem)

POL_R_tz_g_index_ord <-arrange(POL_R_tz_g_index, RMSEg_cv)
colnames(POL_R_tz_g_index_ord)[1] <- "Model_index_YG"
print(POL_R_tz_g_index_ord)

write.csv(POL_R_tz_g_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_tz_g_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L_tzg <- as.formula(paste(POL_R_tz_g_index_ord$model[1]))
Est_POL_L_tzg_RMSE_cvt<- glm(formula=Est_POL_L_tzg, data =dftz,
                             family= Gamma(link="log"))


Est_POL_L_tzg_RMSE_cv <- tidy(Est_POL_L_tzg_RMSE_cvt)


Est_POL_L_tzg_RMSE_cv <- Est_POL_L_tzg_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_POL_L_tzg_RMSE_cv)

write.csv(Est_POL_L_tzg_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_POL_L_tzg_RMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L_tz_yg) <- paste("YG", 1:L, sep = "")
Model_fitted_POL_L_tz_yg <- merge(dftz$biomass_Tha, Model_fitted_POL_L_tz_yg, by=0, all=TRUE)
colnames(Model_fitted_POL_L_tz_yg)[2] <- "biomass_Tha"

print(Model_fitted_POL_L_tz_yg)

write.csv(Model_fitted_POL_L_tz_yg, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_POL_L_tz_yg.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_gama_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R_tz_gama@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_gama_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R_tz_gama@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_gama_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R_tz_gama@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyg <- names(Model_fitted_POL_L_tz_yg)[3:ncol(Model_fitted_POL_L_tz_yg)]
# print(colNamesyg)
# 
# 
# for (s in colNamesyg){
#   print(POL_R_tz_Gama_predic <- ggplot(Model_fitted_POL_L_tz_yg,  aes_string(Model_fitted_POL_L_tz_yg$biomass_Tha, s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method= "glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(dftz$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(dftz$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_R_tz_Gama_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }


#### Removendo tabelas que no seram mais usadas


# rm(list= ls()[!(ls() %in% c('dftz','Comb', 'POL_R_tzt', 'POL_R_tz_id', 
#                             'POL_R_tz_index_ord', 'Est_POL_L_tz_RMSE_cv', 
#                             'POL_R_tz_L_index_ord', 'Est_POL_L_tzL_RMSE_cv',
#                             'POL_R_tz_g_index_ord', 'Est_POL_L_tzg_RMSE_cv'))]) 
# 


# ######################################################################################
# #
# # MODELOS LM LOG(Y)
# #
# ######################################################################################
# 




POL_R_tz_lmLogy <- glmulti((log(biomass_Tha)) ~ .,  data =dftz, 
                           level = 1,               # No interaction considered
                           method = "h",            # Exhaustive approach
                           crit = "aicc",            # AIC as criteria
                           confsetsize = Comb,         # Keep all model n^2 
                           plotty = F, report = F,  # plot or interim reports
                           fitfunction = "lm"
                           
)     

POL_R_tz_lmLogy@objects
POL_R_tz_lmLogyBest <- summary(POL_R_tz_lmLogy@objects[[1]])# selecr best model
print(POL_R_tz_lmLogyBest) 
POL_R_tz_lmLogy_aic_limt <- weightable(POL_R_tz_lmLogy)
POL_R_tz_lmLogy_aic_limt2 <- POL_R_tz_lmLogy_aic_limt[POL_R_tz_lmLogy_aic_limt$aicc <= min(POL_R_tz_lmLogy_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_R_tz_lmLogy_aic_limt2
write.csv(POL_R_tz_lmLogy_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/16_pts/Bio_16_POL_L/POL_R_tz_lmLogy_aic_limt2.csv")
POL_R_tz_lmLogy_aic_limt2

POL_R_tz_lmLogyBest
L <- nrow(POL_R_tz_lmLogy_aic_limt2)



m = nrow(POL_R_tz_lmLogy_aic_limt2)
print(m)
POL_R_tz_RMSE_lmLogy <- numeric(m)  # GUARDA OS rmseLLCV PARA N MDOELOS SELECIONADOS 


# PASSANDO PARA TABLE 

dfPOL<-tbl_df(dftz)
n = nrow(dftz)
print(n)
em <-numeric(n)    # GUARDA OS ERROS PARA N OBSERVAES


for(j in 1:m) {
  for(k in 1:n){
    lmcv<- dfPOL[-k, ]
    lmf <- as.formula(paste(POL_R_tz_lmLogy_aic_limt2$model[j]))
    lm <- lm(formula=lmf, data = lmcv)
    lmes <- fitted.values(lm, dfPOL[k, ])
    lmexp<-exp(lmes)
    em[k] <- (dfPOL[k, 1] - lmexp)
    POL_R_tz_RMSE_lmLogy[j] <- (mean(as.numeric(em)^2))^0.5
  } 
}

print(POL_R_tz_RMSE_lmLogy)


Model_fitted_POL_L_tz_lmLogy <- NULL

for (h in 1:L){
  zlmLogy <- as.formula(paste(POL_R_tz_lmLogy_aic_limt2$model[h]))
  lmLogy <- lm(formula=zlmLogy, data =dftz)
  fitted_lmLogy <- fitted.values(lmLogy)
  namefitted_lmLogy <- paste0("fitted_lmLogy", h)
  assign(namefitted_lmLogy,fitted_lmLogy)
  Model_fitted_POL_L_tz_lmLogy <- cbind(Model_fitted_POL_L_tz_lmLogy, fitted_lmLogy)
}

print(fitted_lmLogy)
print(Model_fitted_POL_L_tz_lmLogy)

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L_tz_lmLogy) <- paste("lmLogy", 1:L, sep = "")
Model_fitted_POL_L_tz_lmLogy <- merge(log(dftz$biomass_Tha), Model_fitted_POL_L_tz_lmLogy, by=0, all=TRUE)
colnames(Model_fitted_POL_L_tz_lmLogy)[2] <- "biomass_Tha"

print(Model_fitted_POL_L_tz_lmLogy)

write.csv(Model_fitted_POL_L_tz_lmLogy, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Model_fitted_POL_L_tz_lmLogy.csv")



# # Calcular R^2 na escala 
# 
# lmR_POL_L_tz <-numeric(m)
# 
# for(r in 1:m) {
#   lmf <- as.formula(paste(POL_R_tz_lmLogy_aic_limt2$model[r]))
#   lm <- lm(formula=lmf, data =dftz)
#   lmR_POL_L_tz1<- fitted.values(lm)
#   lmR_POL_L_tz2<- exp(lmR_POL_L_tz1)
#   lmR_POL_L_tz[r] <-  cor(dftz$biomass_Tha,lmR_POL_L_tz2)^2
# }
# 
# lmR_POL_L_tz
# 



# Extrair o R^2 na escala logaritimica 
lmR_POL_L_tz <- numeric(m)

for(d in 1:m) {
  lmf2 <- as.formula(paste(POL_R_tz_lmLogy_aic_limt2$model[d]))
  lm2 <- lm(formula=lmf2, data =dftz)
  lmR_POL_L_tz[d]<- summary.lm(lm2)$r.squared 
}

print(lmR_POL_L_tz)

#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

DF_POL_L_tz_R2_lmLogy_RMSEL_cv<- data.frame(lmR_POL_L_tz,POL_R_tz_RMSE_lmLogy)

POL_R_tz_lmLogy_index <- merge(POL_R_tz_lmLogy_aic_limt2, DF_POL_L_tz_R2_lmLogy_RMSEL_cv, by=0, all=TRUE)
print(POL_R_tz_lmLogy_index)

write.csv(POL_R_tz_lmLogy_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/POL_R_tz_lmLogy_index.csv")



##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)


POL_R_tz_lmLogy_index_ord <-arrange(POL_R_tz_lmLogy_index, POL_R_tz_RMSE_lmLogy)
colnames(POL_R_tz_lmLogy_index_ord)[1] <- "Model_index_lmLogy"
print(POL_R_tz_lmLogy_index_ord)


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L_tz_lmLogy <- as.formula(paste(POL_R_tz_lmLogy_index_ord$model[1]))
Est_POL_L_tz_lmLogy_RMSE_cvt<- lm(formula=Est_POL_L_tz_lmLogy, data =dftz)


Est_POL_L_tz_lmLogy_RMSE_cv <- tidy(Est_POL_L_tz_lmLogy_RMSE_cvt)


Est_POL_L_tz_lmLogy_RMSE_cv <- Est_POL_L_tz_lmLogy_RMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

print(Est_POL_L_tz_lmLogy_RMSE_cv)

write.csv(Est_POL_L_tz_lmLogy_RMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/Est_POL_L_tz_lmLogy_RMSE_cv.csv")


#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_lmLogy_resid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_R_tz_lmLogy@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_lmLogy_resid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_R_tz_lmLogy@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC",paste("POL_R_tz_lmLogy_resid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_R_tz_lmLogy@objects[[p]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# 
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNameslmLogy <- names(Model_fitted_POL_L_tz_lmLogy)[3:ncol(Model_fitted_POL_L_tz_lmLogy)]
# print(colNameslmLogy)
# 
# 
# # Add as caracteris in ggplot
# 
# FUN <- function(dat, x, y) {
#   ggplot(dat, aes_string(x = x, y = y)) +
#     geom_point(shape=16, size=1) 
#   
#   
# }
# 
# for (F in colNameslmLogy){
#   POL_R_tz_logy_predic<- FUN(Model_fitted_POL_L_tz_lmLogy, 'biomass_Tha', F)+
#     geom_smooth(method = "lm") +
#     theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#           axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#           axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#           axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#           panel.background = element_blank(),
#           panel.grid.major = element_line(colour =  "grey80"),
#           panel.grid.minor = element_blank(),
#           axis.line.x=element_line(),
#           axis.line.y=element_line()) +
#     xlab (label = "AGB") +
#     ylab (label = "fitted.valuesed AGB")
#   
#   
#   print(POL_R_tz_logy_predic)
#   ggsave(filename=paste("POL_R_tz_logy_predic",F,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }



# ######################################################################################
# #
# # Organizando os resultados best model de cada mtodo
# #
# ######################################################################################
# 


# Criando um data frame com os resultados 
Result_POL_L_tz_18_B <- NULL

# Padronizando o nome das colunas

Best_18_GLM_GAUSS_INDENT <-  POL_R_tz_index_ord %>%
  rename(Model_index = Model_index_y)%>%
  mutate("Model/Distr/Link" = "GLM/GAUSSIAN/IDENTFIC")%>%
  slice(1) 

Best_18_GLM_GAUSS_LOG <- POL_R_tz_L_index_ord%>%
  rename(R2 = R2L)%>%
  rename(Model_index = Model_index_yL)%>%
  rename(RMSE_cv = RMSEL_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "GLM/GAUSSIAN/LOG")

Best_18_GLM_GAMMA_LOG <- POL_R_tz_g_index_ord%>%
  rename(R2 = R2g)%>% 
  rename(Model_index = Model_index_YG)%>%
  rename(RMSE_cv = RMSEg_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "GLM/GAMMA/LOG")

Best_18_LM_LOGy <- POL_R_tz_lmLogy_index_ord%>%
  rename(R2 = lmR_POL_L_tz)%>%
  rename(Model_index = Model_index_lmLogy)%>%
  rename(RMSE_cv = POL_R_tz_RMSE_lmLogy)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "LM/log(y)")


# Juntando as tabelas com os melhores modelos 

Result_POL_L_tz_18_B <- rbind(Best_18_GLM_GAUSS_INDENT, Best_18_GLM_GAUSS_LOG, Best_18_LM_LOGy)

# Reordenando pelo RMSE_cv e trocando a ordem da coluna com os tipos de modelos

Result_POL_L_tz_18_B <-arrange(Result_POL_L_tz_18_B, RMSE_cv)

#Removendo a coluna peso 

Result_POL_L_tz_18_B <- subset(Result_POL_L_tz_18_B, select=-weights)


# Function moveme
moveMe <- function(data, tomove, where = "last", ba = NULL) {
  temp <- setdiff(names(data), tomove)
  x <- switch(
    where,
    first = data[c(tomove, temp)],
    last = data[c(temp, tomove)],
    before = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)-1))]
    },
    after = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)))]
    })
  x
}

Result_POL_L_tz_18_B<-moveMe(Result_POL_L_tz_18_B, c("Model/Distr/Link"), "first")

Result_POL_L_tz_18_B

write.csv(Result_POL_L_tz_18_B, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/RESULTS/Result_POL_L_tz_18_B.csv")



rm(list= ls()[!(ls() %in% c('df','Comb', 'POL_Rt', 'POL_R_id', 
                            'POL_R_index_ord', 'Est_y_RMSE_cv', 
                            'POL_R_L_index_ord', 'Est_yL_RMSE_cv',
                            'POL_R_g_index_ord', 'Est_yg_RMSE_cv',
                            'POL_R_lmLogy_index_ord','Est_lmLogy_RMSE_cv','FUN',
                            'PAL_cp_summ', 
                            'PAL_cp_summ', 
                            'PAL_fd_summ', 
                            'PAL_tz_summ', 
                            'PAL_vz_summ', 
                            'PAL_ya_summ', 'p_ind_sub_final',
                            'df3_f','Comb', 'POL_R3t', 'POL_R3_id',
                            'POL_R3_index_ord', 'Est_POL_L3_RMSE_cv',
                            'POL_R3_L_index_ord', 'Est_POL_L3L_RMSE_cv',
                            'POL_R3_g_index_ord', 'Est_POL_L3g_RMSE_cv',
                            'POL_R3_lmLogy_index_ord','Est_POL_L3_lmLogy_RMSE_cv','FUN',
                            'dftz','Comb', 'POL_R_tzt', 'POL_R_tz_id',
                            'POL_R_tz_index_ord', 'Est_POL_L_tz_RMSE_cv',
                            'POL_R_tz_L_index_ord', 'Est_POL_L_tzL_RMSE_cv',
                            'POL_R_tz_g_index_ord', 'Est_POL_L_tzg_RMSE_cv',
                            'POL_R_tz_lmLogy_index_ord','Est_POL_L_tz_lmLogy_RMSE_cv',
                            'Result_POL_L3_18_B','Result_POL_L_tz_18_B','Result_POL_L_18_B'))]) 



# ##################################################################################################################################
# ######
# # Juntado todos os resultados
# ######
# #######################################################################################################################


Result_POL_L_18_F <- Result_POL_L_18_B%>%
mutate(Group = "Bands")

Result_POL_L3_18_F <- Result_POL_L3_18_B%>% 
  mutate(Group = "cp/fd/vz/ya")

Result_POL_L_tz_18_F <- Result_POL_L_tz_18_B%>% 
  mutate(Group = "Touzi")




Result_POL_L_FIM <- rbind(Result_POL_L_18_F, Result_POL_L3_18_F,Result_POL_L_tz_18_F)

# Reordenando pelo RMSE_cv e trocando a ordem da coluna com os tipos de modelos


write.csv(Result_POL_L_FIM, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/RESULTS/Result_POL_L_FIM.csv")

print(Result_POL_L_FIM)



# ##################################################################################################################################
# ######
# # gerando modelos com os melhores resultados de cada grupo 
# ######
# #######################################################################################################################





Beste_POL_L<-Result_POL_L_FIM[c(1,4,7),]

print(Beste_POL_L)

write.csv(Beste_POL_L, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/RESULTS/Beste_POL_L.csv")


Atrib_POL_L<-select(Beste_POL_L, model)

print(Atrib_POL_L)