
# install.packages("reshape2")
# install.packages("ggplot2")
# install.packages("plyr")
# install.packages("scales")
# install.packages("foreign")
# install.packages("car")
# install.packages("DAAG")
# install.packages("MASS")
# install.packages("leaps")
# install.packages("car")
# install.packages("bootStepAIC")
# install.packages("forecast")
# install.packages("glmulti")
# install.packages("rJava")
# install.packages("ISLR")
# install.packages("boot")
# install.packages("dplyr")
# install.packages("broom")
# install.packages("tidyr")


library(leaps)
library(reshape2) 
library(ggplot2)
library(plyr)
library(scales)
library(foreign)
library(car)
library(randomForest)
library(DAAG)
library(MASS)
library(bootStepAIC)
library(leaps)
library(forecast)
library(glmulti)
library(rJava)
library(ISLR)
library(boot)
library(dplyr)
library(broom)
library(tidyr)
library(splitstackshape)

options(digits=6)

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/RESULTS")

Beste_POL_L <- read.csv("Result_POL_L_FIM.csv", header=TRUE, sep=",")

glimpse(Beste_POL_L)

Beste_POL_L = Beste_POL_L[!Beste_POL_L$Model.Distr.Link == "LM/log(y)",] ###### c
print(Beste_POL_L)

Atrib_POL_L <-select(Beste_POL_L, model)

print(Atrib_POL_L)

Atrib_POL_L$model<-gsub("(biomass_Tha) ~ 1 +","",Atrib_POL_L$model, fixed=TRUE)
Atrib_POL_L$model<-gsub("(biomass_Tha) ~ 1","",Atrib_POL_L$model, fixed=TRUE)
Atrib_POL_L$model<-gsub("(log(biomass_Tha)) ~ 1 +","",Atrib_POL_L$model, fixed=TRUE)
Atrib_POL_L$model<-gsub("(log(biomass_Tha)) ~ 1","",Atrib_POL_L$model, fixed=TRUE)
Atrib_POL_L$model<-gsub("log","",Atrib_POL_L$model, fixed=TRUE)



print(Atrib_POL_L)

Atrib_POL_L2<- t(tbl_df(Atrib_POL_L))
print(Atrib_POL_L2)

Atrib_POL_L2 <- Atrib_POL_L2[,!apply(Atrib_POL_L2, 2, function(x) all(gsub(" ", "", x)=="", na.rm=TRUE))]

Atrib_POL_L2<- t(tbl_df(Atrib_POL_L2))
coll_names <- colnames(Atrib_POL_L2, do.NULL = FALSE, prefix = "col")

colnames(Atrib_POL_L2) <- coll_names

Atrib_POL_L3 <- as.data.frame(Atrib_POL_L2)

Atrib_POL_L4 <- Atrib_POL_L3%>% 
  unite(model, 1:ncol(Atrib_POL_L3), sep = "+", remove = TRUE)


Atrib_POL_L4 <- cSplit(as.data.table(Atrib_POL_L4), "model", "+")
Atrib_POL_L4<- t(tbl_df(Atrib_POL_L4))
Atrib_POL_L4<- unique(Atrib_POL_L4)
Atrib_POL_L4<- t(tbl_df(Atrib_POL_L4))
coll_names <- colnames(Atrib_POL_L4, do.NULL = FALSE, prefix = "col")

colnames(Atrib_POL_L4) <- coll_names
Atrib_POL_L4 <- as.data.frame(Atrib_POL_L4)


#Numero de atributos 
n_comb <- ncol(Atrib_POL_L4)
print(n_comb)

Atrib_POL_L4 <- Atrib_POL_L4%>% 
  unite(model, 1:ncol(Atrib_POL_L4), sep = "+", remove = TRUE)



Atrib_POL_L4$model <- sub("^", "(biomass_Tha) ~ ", Atrib_POL_L4$model) 


# Juntando todas as tabelas

multmerge = function(mypath){
  filenames=list.files(path=mypath, full.names=TRUE)
  datalist = lapply(filenames, function(x){read.csv(file=x,header=T)})
  Reduce(function(x,y) {merge(x,y)}, datalist)}


All_atrib = multmerge("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_join")

All_atrib <- arrange(All_atrib, X)
All_atrib1<-All_atrib[-1]
All_atrib1<-All_atrib1[-2]
All_atrib1<-All_atrib1[-2]

write.csv(All_atrib1, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/All_atrib1.csv")

# No segundo nivel no coloca -1 pois no esta na tabela a variavel dependente
# No segundo nivel no coloca -1 pois no esta na tabela a variavel dependente
Comb <- 2^(n_comb)
print(Comb)



df3_f<-All_atrib1

Select <- as.formula(paste(Atrib_POL_L4$model[1]))
print(Select)
# ######################################################################################
# #
# # MODELOS GLM MULT LINK = IDENTITY
# #
# ######################################################################################
# 

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model")


POL_L3 <- glmulti(Select,   data = df3_f, 
                  level = 1,               # No interaction considered
                  method = "h",            # Exhaustive approach
                  crit = "aicc",            # AIC as criteria
                  confsetsize = Comb,         # Keep all model n^2 
                  plotty = F, report = F,  # plot or interim reports
                  fitfunction = "glm",
                  
                  family=gaussian(link="identity")
                 
)     # lm function

#POL_L3@objects
POL_L3Best <- summary(POL_L3@objects[[1]])# selecr best model 
print(POL_L3Best)
POL_L3_aic_limt <- weightable(POL_L3)
POL_L3_aic_limt2 <- POL_L3_aic_limt[POL_L3_aic_limt$aicc <= min(POL_L3_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_L3_aic_limt2
write.csv(POL_L3_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_aic_limt2.csv")

#Peso das variveis+model avarege

POL_L3@objects
POL_L3_peso<- coef.glmulti(POL_L3)
write.csv(POL_L3_peso, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_peso.csv")
print(POL_L3_peso)

tiff(filename ="C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_peso_plot.tiff",width = 15, height = 15, units = 'cm', res = 300)
plot(POL_L3, type="s")
dev.off()




#Croos valdation all model


L <- nrow(POL_L3_aic_limt2)

DF_POL_L3_L2_LMSE_cv <- NULL

Model_fitted_POL_L3_y <- NULL



for (i in 1:L){
  z <- as.formula(paste(POL_L3_aic_limt2$model[i]))
  y <- glm(formula=z, data =df3_f,
           family= gaussian("identity")
  )
  sumary_y <- summary(y)
  fitted_y <-c(fitted.values(y))
  R2 <-  c(cor(df3_f$biomass_Tha,fitted.values(y))^2)
  LOOCV <- cv.glm(df3_f, y, K = nrow(df3_f))
  RMSE_cv<- (LOOCV$delta[1])^0.5
  name <- paste0("y",i)
  namesumary_y <- paste0("sumary_y",i)
  namefitted_y <- paste0("fitted_y", i)
  nameR2 <- paste0("R2",i)
  nameLOOCV <- paste0("LOOCV",i)
  nameRMSE_cv <- paste0("RMSE_cv", i)
  assign(name, y)
  assign(namesumary_y, sumary_y)
  assign(namefitted_y,fitted_y)
  assign(nameLOOCV, LOOCV)
  R2_LMSE_cv<- data.frame(R2,RMSE_cv)
  DF_POL_L3_L2_LMSE_cv <- rbind(DF_POL_L3_L2_LMSE_cv, R2_LMSE_cv)
  Model_fitted_POL_L3_y <- cbind(Model_fitted_POL_L3_y, fitted_y)
}

lmp <- function (modelobject) {
  if (class(modelobject) != "lm") stop("Not an object of class 'lm' ")
  f <- summary(modelobject)$fstatistic
  if (is.null(f)==TRUE) {p<-0} else {p <- pf(f[1],f[2],f[3],lower.tail=F)}
  attributes(p) <- NULL
  return(p)
}


# o p-valor teste F

p.value <- numeric(L)


for(d in 1:L) {
  lmf2 <- as.formula(paste(POL_L3_aic_limt2$model[d]))
  lm2 <- lm(formula=lmf2, data = df3_f)
  p.value[d]<- lmp(lm2)
}

print(p.value)

p.value <-data.frame(p.value) 
print(p.value)

#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_L3_index <- merge( POL_L3_aic_limt2, DF_POL_L3_L2_LMSE_cv, by=0, all=TRUE)
print(POL_L3_index)

POL_L3_index <- merge(POL_L3_index, p.value, by=0, all=TRUE)
print(POL_L3_index)

POL_L3_index <- POL_L3_index[-1]

POL_L3_index <- POL_L3_index%>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

print(POL_L3_index)

write.csv(POL_L3_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_index.csv")


##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)

POL_L3_index_ord <-arrange(POL_L3_index, RMSE_cv)
colnames(POL_L3_index_ord)[1] <- "Model_index_y"
print(POL_L3_index_ord)

write.csv(POL_L3_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L3 <- as.formula(paste(POL_L3_index_ord$model[1]))
Est_POL_L3_LMSE_cvt<- glm(formula=Est_POL_L3, data =df3_f,
                          family= gaussian(link="identity"))


Est_POL_L3_LMSE_cv <- tidy(Est_POL_L3_LMSE_cvt)


Est_POL_L3_LMSE_cv <- Est_POL_L3_LMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_POL_L3_LMSE_cv)

write.csv(Est_POL_L3_LMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/Est_POL_L3_LMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L3_y) <- paste("y", 1:L, sep = "")
Model_fitted_POL_L3_y <- merge(df3_f$biomass_Tha, Model_fitted_POL_L3_y, by=0, all=TRUE)
colnames(Model_fitted_POL_L3_y)[2] <- "biomass_Tha"

print(Model_fitted_POL_L3_y)

write.csv(Model_fitted_POL_L3_y, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/Model_fitted_POL_L3_y.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_Lesid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_L3@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_Lesid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_L3@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_Lesid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_L3@objects[[1]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesy <- names(Model_fitted_POL_L3_y)[3:ncol(Model_fitted_POL_L3_y)]
# print(colNamesy)
# 
# 
# for (s in colNamesy){
#   print(POL_L3_predic <- ggplot(Model_fitted_POL_L3_y,  aes_string("biomass_Tha", s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method= "glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_L3_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }


# rm(list= ls()[!(ls() %in% c('df3_f','Comb', 'POL_L3t', 'POL_L3_id', 
#                             'POL_L3_index_ord', 'Est_POL_L3_LMSE_cv'))])



# ######################################################################################
# #
# # MODELOS GLM MULT LINK = LOG
# #
# ######################################################################################



POL_L3_log <- glmulti(Select,   data = df3_f, 
                      level = 1,               # No interaction considered
                      method = "h",            # Exhaustive approach
                      crit = "aicc",            # AIC as criteria
                      confsetsize = 10,         # Keep all model n^2 
                      plotty = F, report = F,  # plot or interim reports
                      fitfunction = "glm",
                      
                      family = gaussian(link="log")
                      
)     

#POL_L3_log@objects
POL_L3_logBest <- summary(POL_L3_log@objects[[1]])# selecr best model
print(POL_L3_logBest) 
POL_L3_log_aic_limt <- weightable(POL_L3_log)
POL_L3_log_aic_limt2 <- POL_L3_log_aic_limt[POL_L3_log_aic_limt$aicc <= min(POL_L3_log_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_L3_log_aic_limt2
write.csv(POL_L3_log_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_log_aic_limt2.csv")

#Peso das variveis+model avarege

POL_L3_log@objects
POL_L3_log_peso<- coef.glmulti(POL_L3_log)
write.csv(POL_L3_log_peso, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_log_peso.csv")
print(POL_L3_log)

tiff(filename ="C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_log_peso_plot.tiff",width = 15, height = 15, units = 'cm', res = 300)
plot(POL_L3_log, type="s")
dev.off()




L <- nrow(POL_L3_log_aic_limt2)

DF_POL_L3_L2L_LMSEL_cv <- NULL


Model_fitted_POL_L3_yL <- NULL



for (i in 1:L){
  zL <- as.formula(paste(POL_L3_log_aic_limt2$model[i]))
  yL <- glm(formula=zL, data =df3_f,
            family= gaussian(link="log")
  )
  sumary_yL <- summary(yL)
  fitted_yL <-c(fitted.values(yL))
  R2L <-  c(cor(df3_f$biomass_Tha,fitted.values(yL))^2)
  LOOCVL <- cv.glm(df3_f, yL, K = nrow(df3_f))
  RMSEL_cv<- (LOOCVL$delta[1])^0.5
  nameL <- paste0("yL",i)
  namesumary_yL <- paste0("sumary_yL",i)
  namefitted_yL <- paste0("fitted_yL", i)
  nameR2L <- paste0("R2L",i)
  nameLOOCVL <- paste0("LOOCVL",i)
  nameRMSEL_cv <- paste0("RMSEL_cv", i)
  assign(nameL, yL)
  assign(namesumary_yL, sumary_yL)
  assign(namefitted_yL,fitted_yL)
  assign(nameLOOCVL, LOOCVL)
  R2L_LMSEL_cv<- data.frame(R2L,RMSEL_cv)
  DF_POL_L3_L2L_LMSEL_cv <- rbind(DF_POL_L3_L2L_LMSEL_cv, R2L_LMSEL_cv)
  Model_fitted_POL_L3_yL <- cbind(Model_fitted_POL_L3_yL, fitted_yL)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_L3_L_index <- merge( POL_L3_log_aic_limt2, DF_POL_L3_L2L_LMSEL_cv, by=0, all=TRUE)
print(POL_L3_L_index)


Red <- glm(formula=(biomass_Tha) ~ 1, data = df3_f,
           family= gaussian(link="log"))

p.value <- numeric(L)
for (i in 1:L){
  tL <- as.formula(paste(POL_L3_log_aic_limt2$model[i]))
  tLf <- glm(formula=tL, data = df3_f,
             family= gaussian(link="log"))
  tLf <-anova(Red,tLf, test="F")
  p.value[i] <- tLf[2,6]
}

print(p.value)
p.value<- data.frame(p.value)
POL_L3_L_index <- merge(POL_L3_L_index, p.value, by=0, all=TRUE)
print(POL_L3_L_index)
POL_L3_L_index <- POL_L3_L_index[-1]

POL_L3_L_index <- POL_L3_L_index %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

print(POL_L3_L_index)


write.csv(POL_L3_L_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_L_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEL_cv (descrescente ordem)

POL_L3_L_index_ord <-arrange(POL_L3_L_index, RMSEL_cv)
colnames(POL_L3_L_index_ord)[1] <- "Model_index_yL"
print(POL_L3_L_index_ord)

write.csv(POL_L3_L_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_L_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L3L <- as.formula(paste(POL_L3_L_index_ord$model[1]))
Est_POL_L3L_LMSE_cvt<- glm(formula=Est_POL_L3L, data =df3_f,
                           family= gaussian(link="log"))


Est_POL_L3L_LMSE_cv <- tidy(Est_POL_L3L_LMSE_cvt)


Est_POL_L3L_LMSE_cv <- Est_POL_L3L_LMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_POL_L3L_LMSE_cv)

write.csv(Est_POL_L3L_LMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/Est_POL_L3L_LMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L3_yL) <- paste("yL", 1:L, sep = "")
Model_fitted_POL_L3_yL <- merge(df3_f$biomass_Tha, Model_fitted_POL_L3_yL, by=0, all=TRUE)
colnames(Model_fitted_POL_L3_yL)[2] <- "biomass_Tha"

print(Model_fitted_POL_L3_yL)

write.csv(Model_fitted_POL_L3_yL, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/Model_fitted_POL_L3_yL.csv")



# #####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_log_Lesid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_L3_log@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_log_Lesid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_L3_log@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_log_Lesid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_L3_log@objects[[1]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyL <- names(Model_fitted_POL_L3_yL)[3:ncol(Model_fitted_POL_L3_yL)]
# print(colNamesyL)
# 
# 
# for (s in colNamesyL){
#   print(POL_L3_log_predic <- ggplot(Model_fitted_POL_L3_yL,  aes_string(Model_fitted_POL_L3_yL$biomass_Tha, s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method="glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_L3_log_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }

 # rm(list= ls()[!(ls() %in% c('df3_f','Comb', 'POL_L3t', 'POL_L3_id',
 #                             'POL_L3_index_ord', 'Est_POL_L3_LMSE_cv',
 #                             'POL_L3_L_index_ord', 'Est_POL_L3L_LMSE_cv'))])
 # 




# ######################################################################################
# #
# # MODELOS GLM MULT LINK = GAMA (LINK=LOG)
# #
# ######################################################################################
# 



POL_L3_gama <- glmulti((biomass_Tha) ~ PAL_hh_db + PAL_hv_db + PAL_vv_db,  data = df3_f,   
                       level = 1,               # No interaction considered
                       method = "h",            # Exhaustive approach
                       crit = "aicc",            # AIC as criteria
                       confsetsize = Comb,         # Keep all model n^2 
                       plotty = F, report = F,  # plot or interim reports
                       fitfunction = "glm",
                       
                       family = gaussian(link="log")
)     

POL_L3_gama@objects
POL_L3_gamaBest <- summary(POL_L3_gama@objects[[1]])# selecr best model
print(POL_L3_gamaBest) 
POL_L3_gama_aic_limt <- weightable(POL_L3_gama)
POL_L3_gama_aic_limt2 <- POL_L3_gama_aic_limt[POL_L3_gama_aic_limt$aicc <= min(POL_L3_gama_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_L3_gama_aic_limt2
write.csv(POL_L3_gama_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_gama_aic_limt2.csv")


#Peso das variveis+model avarege
POL_L3_gama@objects
POL_L3_gama_peso<- coef.glmulti(POL_L3_gama)
write.csv(POL_L3_gama_peso, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_gama_peso.csv")
print(POL_L3_gama)

tiff(filename ="C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_gama_peso_plot.tiff",width = 15, height = 15, units = 'cm', res = 300)
plot(POL_L3_gama, type="s")
dev.off()


L <- nrow(POL_L3_gama_aic_limt2)

DF_POL_L3_L2g_LMSEg_cv <- NULL

Model_fitted_POL_L3_yg <- NULL



for (i in 1:L){
  zg <- as.formula(paste(POL_L3_gama_aic_limt2$model[i]))
  yg <- glm(formula=zg, data =df3_f,
            family= Gamma(link="log")
  )
  sumary_yg <- summary(yg)
  fitted_yg <-c(fitted.values(yg))
  R2g <-  c(cor(df3_f$biomass_Tha,fitted.values(yg))^2)
  LOOCVg <- cv.glm(df3_f, yg, K = nrow(df3_f))
  RMSEg_cv<- (LOOCVg$delta[1])^0.5
  nameg <- paste0("yg",i)
  namesumary_yg <- paste0("sumary_yg",i)
  namefitted_yg <- paste0("fitted_yg", i)
  nameR2g <- paste0("R2g",i)
  nameLOOCVg <- paste0("LOOCVg",i)
  nameRMSEg_cv <- paste0("RMSEg_cv", i)
  assign(nameg, yg)
  assign(namesumary_yg, sumary_yg)
  assign(namefitted_yg,fitted_yg)
  assign(nameLOOCVg, LOOCVg)
  R2g_LMSEg_cv<- data.frame(R2g,RMSEg_cv)
  DF_POL_L3_L2g_LMSEg_cv <- rbind(DF_POL_L3_L2g_LMSEg_cv, R2g_LMSEg_cv)
  Model_fitted_POL_L3_yg <- cbind(Model_fitted_POL_L3_yg, fitted_yg)
}




#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

POL_L3_g_index <- merge( POL_L3_gama_aic_limt2, DF_POL_L3_L2g_LMSEg_cv, by=0, all=TRUE)
print(POL_L3_g_index)

write.csv(POL_L3_g_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_g_index.csv")


##### Reordenando a tabelas index pelo valor do RMSEg_cv (descrescente ordem)

POL_L3_g_index_ord <-arrange(POL_L3_g_index, RMSEg_cv)
colnames(POL_L3_g_index_ord)[1] <- "Model_index_YG"
print(POL_L3_g_index_ord)

write.csv(POL_L3_g_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_g_index_ord.csv")


##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L3g <- as.formula(paste(POL_L3_g_index_ord$model[1]))
Est_POL_L3g_LMSE_cvt<- glm(formula=Est_POL_L3g, data =df3_f,
                           family= Gamma(link="log"))


Est_POL_L3g_LMSE_cv <- tidy(Est_POL_L3g_LMSE_cvt)


Est_POL_L3g_LMSE_cv <- Est_POL_L3g_LMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))



print(Est_POL_L3g_LMSE_cv)

write.csv(Est_POL_L3g_LMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/Est_POL_L3g_LMSE_cv.csv")

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L3_yg) <- paste("YG", 1:L, sep = "")
Model_fitted_POL_L3_yg <- merge(df3_f$biomass_Tha, Model_fitted_POL_L3_yg, by=0, all=TRUE)
colnames(Model_fitted_POL_L3_yg)[2] <- "biomass_Tha"

print(Model_fitted_POL_L3_yg)

write.csv(Model_fitted_POL_L3_yg, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/Model_fitted_POL_L3_yg.csv")



#####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)

# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_gama_Lesid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_L3_gama@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_gama_Lesid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_L3_gama@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_gama_Lesid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_L3_gama@objects[[1]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNamesyg <- names(Model_fitted_POL_L3_yg)[3:ncol(Model_fitted_POL_L3_yg)]
# print(colNamesyg)
# 
# 
# for (s in colNamesyg){
#   print(POL_L3_Gama_predic <- ggplot(Model_fitted_POL_L3_yg,  aes_string(Model_fitted_POL_L3_yg$biomass_Tha, s)) +
#           geom_point(shape=16, size=1) +
#           geom_smooth(method= "glm", size=0.5) +
#           theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#                 axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#                 axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#                 axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#                 panel.background = element_blank(),
#                 panel.grid.major = element_line(colour =  "grey80"), 
#                 panel.grid.minor = element_blank(), 
#                 axis.line.x=element_line(),
#                 axis.line.y=element_line()) +
#           xlab (label = "AGB") +
#           ylab (label = "fitted.valuesed AGB")+
#           scale_x_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)) +
#           scale_y_continuous(breaks = round(seq(min(0), max(df3_f$biomass_Tha), by = 50),1)))
#   
#   ggsave(filename=paste("POL_L3_Gama_predic",s,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }


#### Removendo tabelas que no seram mais usadas


 # rm(list= ls()[!(ls() %in% c('df3_f','Comb', 'POL_L3t', 'POL_L3_id', 
 #                             'POL_L3_index_ord', 'Est_POL_L3_LMSE_cv', 
 #                             'POL_L3_L_index_ord', 'Est_POL_L3L_LMSE_cv',
 #                             'POL_L3_g_index_ord', 'Est_POL_L3g_LMSE_cv'))]) 



# ######################################################################################
# #
# # MODELOS LM LOG(Y)
# #
# ######################################################################################
# 

df3_log <- df3_f%>%
  mutate(biomass_Tha = log(biomass_Tha))


POL_L3_lmLogy <- glmulti(Select,   data = df3_log, 
                         level = 1,               # No interaction considered
                         method = "h",            # Exhaustive approach
                         crit = "aicc",            # AIC as criteria
                         confsetsize = Comb,         # Keep all model n^2 
                         plotty = F, report = F,  # plot or interim reports
                         
                         family=gaussian(link="identity")
                         
)     

POL_L3_lmLogy@objects
POL_L3_lmLogyBest <- summary(POL_L3_lmLogy@objects[[1]])# selecr best model
print(POL_L3_lmLogyBest) 
POL_L3_lmLogy_aic_limt <- weightable(POL_L3_lmLogy)
POL_L3_lmLogy_aic_limt2 <- POL_L3_lmLogy_aic_limt[POL_L3_lmLogy_aic_limt$aicc <= min(POL_L3_lmLogy_aic_limt$aicc) + 2,] # selecionar os modelos limites pelo aicc
POL_L3_lmLogy_aic_limt2
write.csv(POL_L3_lmLogy_aic_limt2, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_lmLogy_aic_limt2.csv")
#Peso das variveis+model avarege

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model")

POL_L3_lmLogy_aic_limt2 <- read.csv("POL_L3_lmLogy_aic_limt2.csv", header=TRUE, sep=",")


POL_L3_lmLogy@objects
POL_L3_lmLogy_peso<- coef.glmulti(POL_L3_lmLogy)
write.csv(POL_L3_lmLogy_peso, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_lmLogy_peso.csv")
print(POL_L3_lmLogy)

tiff(filename ="C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_log_peso_plot.tiff",width = 15, height = 15, units = 'cm', res = 300)
plot(POL_L3_lmLogy, type="s")
dev.off()


L <- nrow(POL_L3_lmLogy_aic_limt2)



m = nrow(POL_L3_lmLogy_aic_limt2)
print(m)
POL_L3_LMSE_lmLogy <- numeric(m)  # GUARDA OS rmseLLCV PARA N MDOELOS SELECIONADOS 


# PASSANDO PARA TABLE 

dfPOL<-tbl_df(df3_log)
n = nrow(df3_log)
print(n)
em <-numeric(n)    # GUARDA OS ERROS PARA N OBSERVAES


for(j in 1:m) {
  for(k in 1:n){
    lmcv<- dfPOL[-k, ]
    lmf <- as.formula(paste(POL_L3_lmLogy_aic_limt2$model[j]))
    lm <- lm(formula=lmf, data = lmcv)
    lmes <- fitted.values(lm, dfPOL[k, ])
    lmexp<-exp(lmes)
    em[k] <- (exp(dfPOL[k, 1]) - lmexp)
    POL_L3_LMSE_lmLogy[j] <- (mean(as.numeric(em)^2))^0.5
  } 
}

print(POL_L3_LMSE_lmLogy)


Model_fitted_POL_L3_lmLogy <- NULL

for (h in 1:L){
  zlmLogy <- as.formula(paste(POL_L3_lmLogy_aic_limt2$model[h]))
  lmLogy <- lm(formula=zlmLogy, data =df3_log)
  fitted_lmLogy <- fitted.values(lmLogy)
  namefitted_lmLogy <- paste0("fitted_lmLogy", h)
  assign(namefitted_lmLogy,fitted_lmLogy)
  Model_fitted_POL_L3_lmLogy <- cbind(Model_fitted_POL_L3_lmLogy, fitted_lmLogy)
}

print(fitted_lmLogy)
print(Model_fitted_POL_L3_lmLogy)

#####  Tabela com os valores dos modelos selecionados

colnames(Model_fitted_POL_L3_lmLogy) <- paste("lmLogy", 1:L, sep = "")
Model_fitted_POL_L3_lmLogy <- merge(log(df3_f$biomass_Tha), Model_fitted_POL_L3_lmLogy, by=0, all=TRUE)
colnames(Model_fitted_POL_L3_lmLogy)[2] <- "biomass_Tha"

print(Model_fitted_POL_L3_lmLogy)

write.csv(Model_fitted_POL_L3_lmLogy, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/Model_fitted_POL_L3_lmLogy.csv")



# # Calcular R^2 na escala 
# 
# lmR_POL_L3 <-numeric(m)
# 
# for(r in 1:m) {
#   lmf <- as.formula(paste(POL_L3_lmLogy_aic_limt2$model[r]))
#   lm <- lm(formula=lmf, data =df3_f)
#   lmR_POL_L31<- fitted.values(lm)
#   lmR_POL_L32<- exp(lmR_POL_L31)
#   lmR_POL_L3[r] <-  cor(df3_f$biomass_Tha,lmR_POL_L32)^2
# }
# 
# lmR_POL_L3
# 

lmp <- function (modelobject) {
  if (class(modelobject) != "lm") stop("Not an object of class 'lm' ")
  f <- summary(modelobject)$fstatistic
  if (is.null(f)==TRUE) {p<-0} else {p <- pf(f[1],f[2],f[3],lower.tail=F)}
  attributes(p) <- NULL
  return(p)
}

# Extrair o R^2 na escala logaritimica 
lmR_POL_L3 <- numeric(m)
p.value <- numeric(m)

for(d in 1:m) {
  lmf2 <- as.formula(paste(POL_L3_lmLogy_aic_limt2$model[d]))
  lm2 <- lm(formula=lmf2, data =df3_log)
  lmR_POL_L3[d]<- summary.lm(lm2)$r.squared
  p.value[d]<- lmp(lm2)
}

print(lmR_POL_L3)
print(p.value)

#####  juntando tabelas com o R^2 e o RMSE_CV na tabela com os modelos selecionads

DF_POL_L3_L2_lmLogy_LMSEL_cv<- data.frame(lmR_POL_L3,POL_L3_LMSE_lmLogy, p.value)

POL_L3_lmLogy_index <- merge(POL_L3_lmLogy_aic_limt2, DF_POL_L3_L2_lmLogy_LMSEL_cv, by=0, all=TRUE)
print(POL_L3_lmLogy_index)

POL_L3_lmLogy_index <- POL_L3_lmLogy_index %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

write.csv(POL_L3_lmLogy_index, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_lmLogy_index.csv")



##### Reordenando a tabelas index pelo valor do RMSE_cv (descrescente ordem)


POL_L3_lmLogy_index_ord <-arrange(POL_L3_lmLogy_index, POL_L3_LMSE_lmLogy)
colnames(POL_L3_lmLogy_index_ord)[1] <- "Model_index_lmLogy"
print(POL_L3_lmLogy_index_ord)

write.csv(POL_L3_lmLogy_index_ord, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/POL_L3_lmLogy_index_ord.csv")

##### Selecionado o melhor (menor RMSE_cv) e extraindo a estatistica e salvando em uma tabela 


Est_POL_L3_lmLogy <- as.formula(paste(POL_L3_lmLogy_index_ord$model[1]))
Est_POL_L3_lmLogy_LMSE_cvt<- lm(formula=Est_POL_L3_lmLogy, data =df3_log)


Est_POL_L3_lmLogy_LMSE_cv <- tidy(Est_POL_L3_lmLogy_LMSE_cvt)


Est_POL_L3_lmLogy_LMSE_cv <- Est_POL_L3_lmLogy_LMSE_cv %>%
  mutate(Result_level_5 = ifelse(p.value < 0.05, "significant ", "non-significant"))

print(Est_POL_L3_lmLogy_LMSE_cv)

write.csv(Est_POL_L3_lmLogy_LMSE_cv, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model/Est_POL_L3_lmLogy_LMSE_cv.csv")


# #####  Comando que gera os plots (Residuals vc Fited, Normal qq, scale - locaritmo, residual x Leverage)
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_lmLogy_Lesid_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Model", names[p])
#   par(mfrow=c(2,2)) # Change the panel layout to 2 x 2
#   plot((POL_L3_lmLogy@objects[[p]]), main = mytitle)
#   dev.off()
# }
# 
# 
# #####  plot Residual
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_lmLogy_Lesid2_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300) 
#   mytitle = paste("Residuals", names[p])
#   plot(residuals(POL_L3_lmLogy@objects[[p]]), main = mytitle, ylab="Residual") 
#   dev.off()
# }
# 
# 
# ##### plot Residual standart
# 
# names = (1:L)
# for (p in 1:L){
#   mypath <- file.path("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model",paste("POL_L3_lmLogy_Lesid_stanad_", names[p], ".tiff", sep = ""))
#   tiff(file=mypath,width = 15, height = 15, units = 'cm', res = 300)
#   mytitle = paste("Residuals standard", names[p])
#   plot(residuals_standard <-  rstandard(POL_L3_lmLogy@objects[[1]]), main = mytitle, ylab="Residual standard") # plot Residual standartizado 
#   dev.off()
# }
# 
# 
# 
# 
# 
# # Variavel fitted.values x variavel biomass
# 
# colNameslmLogy <- names(Model_fitted_POL_L3_lmLogy)[3:ncol(Model_fitted_POL_L3_lmLogy)]
# print(colNameslmLogy)
# 
# 
# # Add as caracteris in ggplot
# 
# FUN <- function(dat, x, y) {
#   ggplot(dat, aes_string(x = x, y = y)) +
#     geom_point(shape=16, size=1) 
#   
#   
# }
# 
# for (F in colNameslmLogy){
#   POL_L3_logy_predic<- FUN(Model_fitted_POL_L3_lmLogy, 'biomass_Tha', F)+
#     geom_smooth(method = "lm") +
#     theme(axis.text.x = element_text(angle = 0,hjust=0.4, vjust=1,color="black", size = 8),
#           axis.title.x = element_text(size=10, hjust=0.5, vjust=0.1),
#           axis.text.y = element_text(angle = 0,hjust=1, vjust=0.4,color="black", size = 8),
#           axis.title.y = element_text(size=10, hjust=0.5, vjust=1.5),
#           panel.background = element_blank(),
#           panel.grid.major = element_line(colour =  "grey80"),
#           panel.grid.minor = element_blank(),
#           axis.line.x=element_line(),
#           axis.line.y=element_line()) +
#     xlab (label = "AGB") +
#     ylab (label = "fitted.valuesed AGB")
#   
#   
#   print(POL_L3_logy_predic)
#   ggsave(filename=paste("POL_L3_logy_predic",F,".tiff",sep=""), units = "cm", width = 12, height = 9, dpi = 300)
# }
# 





# ######################################################################################
# #
# # Organizando os resultados best model de cada mtodo
# #
# ######################################################################################
# 


# Criando um data frame com os resultados 
Result_POL_best_18_F <- NULL

# Padronizando o nome das colunas

Best_18_GLM_GAUSS_INDENT <-  POL_L3_index_ord %>%
  rename(id = Model_index_y)%>%
  mutate("Model/Distr/Link" = "IDENT")%>%
  slice(1) 

Best_18_GLM_GAUSS_LOG <- POL_L3_L_index_ord%>%
  rename(R2 = R2L)%>%
  rename(id = Model_index_yL)%>%
  rename(RMSE_cv = RMSEL_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "LOG")

Best_18_GLM_GAMMA_LOG <- POL_L3_g_index_ord%>%
  rename(R2 = R2g)%>% 
  rename(id = Model_index_YG)%>%
  rename(RMSE_cv = RMSEg_cv)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "GLM/GAMMA/LOG")

Best_18_LM_LOGy <- POL_L3_lmLogy_index_ord%>%
  rename(R2 = lmR_POL_L3)%>%
  rename(id = Model_index_lmLogy)%>%
  rename(RMSE_cv = POL_L3_LMSE_lmLogy)%>%
  slice(1)%>% 
  mutate("Model/Distr/Link" = "log(AGB)")


# Juntando as tabelas com os melhores modelos 

Result_POL_best_18_F <- rbind(Best_18_GLM_GAUSS_INDENT, Best_18_GLM_GAUSS_LOG)


# Reordenando pelo RMSE_cv e trocando a ordem da coluna com os tipos de modelos
Result_POL_best_18_F <-arrange(Result_POL_best_18_F, RMSE_cv)

#Removendo a coluna peso 

Result_POL_best_18_F <- subset(Result_POL_best_18_F, select=-weights)


# Function moveme
moveMe <- function(data, tomove, where = "last", ba = NULL) {
  temp <- setdiff(names(data), tomove)
  x <- switch(
    where,
    first = data[c(tomove, temp)],
    last = data[c(temp, tomove)],
    before = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)-1))]
    },
    after = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)))]
    })
  x
}

Result_POL_best_18_F<-moveMe(Result_POL_best_18_F, c("Model/Distr/Link"), "first")

Result_POL_best_18_F

write.csv(Result_POL_best_18_F, "C:/3_CURUAI/0_BEST_MODEL/18_pts/1bio_18_Pol_L_2_AIC/RESULTS/Result_POL_best_18_F.csv")


