# install.packages("raster")
# install.packages ("rgdal")
# install.packages("MASS")
# install.packages("sp")
# install.packages("dismo")
# install.packages("XML")
# install.packages("maps")
# install.packages("dplyr")
# install.packages("broom")
# install.packages("tidyr")
# install.packages("data.table")
# install.packages("rasterVis")




library(dismo)
library(XML)
library(maps)
library(raster)
library(rgdal)
library(MASS)
library(sp)
library(dplyr)
library(broom)
library(tidyr)
library(data.table)
library(rasterVis)
library(ggplot2)

## Pasta onde esta a/ ou as imagens *tiff

setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS")

mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS"  ####### c
dir.create("1_PAL_bio")  ####### c


setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio"
dir.create("HIST")
dir.create("Predic")


setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/Imagens_100")

list <- list.files(pattern = glob2rx('*.tif'), full.names=TRUE)
print(list)


PALSAR_FULL_BANDS_R <- stack(list[2])
PALSAR_FULL_BANDS_R2 <- brick(PALSAR_FULL_BANDS_R)


names(PALSAR_FULL_BANDS_R2)


band_names = c('c11',	'c22',	'c33',	'PAL_hv_hh_db',	'PAL_vv_hh_db',	'PAL_hv_vv_db',	
               'PAL_SPAN_db ',	'PAL_RVI_db',	'PAL_BMI_db',	'cp_alpha',	'cp_ani',
               'cp_entro',	'fd_db',	'fd_odd',	'fd_vol',	'tz_alphas',
               'tz_alphas1',	'tz_alphas2',	'tz_alphas3',	'tz_phis',	
               'tz_phis1',	'tz_phis2',	'tz_phis3',	'tz_psis',	'tz_psis1',
               'tz_psis2',	'tz_psis3',	'tz_taum',	'tz_taum1',	'tz_taum2',	
               'tz_taum3',	'vz_db',	'vz_odd',	'vz_vol',	'ya_db',	'ya_odd',
               'ya_vol')

names(PALSAR_FULL_BANDS_R2) <- band_names

writeRaster(x=PALSAR_FULL_BANDS_R2, filename='PALSAR_FULL_BANDS_R2.grd', datatype='FLT8S', overwrite=TRUE)
writeRaster(x=PALSAR_FULL_BANDS_R2, filename='C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/PAL_mapas_bio_ARC/PALSAR_FULL_BANDS_R2.tif', datatype='FLT8S', overwrite=TRUE)

names(PALSAR_FULL_BANDS_R2)


dB <- function (x){
  options(digits=10)
  10*log10(x)
}

PAL_hh_db <- dB(PALSAR_FULL_BANDS_R2[["c11"]])

PAL_hv_db <- dB(PALSAR_FULL_BANDS_R2[["c22"]])

PAL_vv_db <- dB(PALSAR_FULL_BANDS_R2[["c33"]])

PAL_hvmhh_db <- ((PALSAR_FULL_BANDS_R2[["c22"]]) - (PALSAR_FULL_BANDS_R2[["c11"]]))

PAL_hvmvv_db <- ((PALSAR_FULL_BANDS_R2[["c22"]]) - (PALSAR_FULL_BANDS_R2[["c33"]]))

PAL_hhmvv_db <- ((PALSAR_FULL_BANDS_R2[["c11"]])-(PALSAR_FULL_BANDS_R2[["c33"]]))

PAL_DP_db <- dB((PALSAR_FULL_BANDS_R2[["c22"]])/(((PALSAR_FULL_BANDS_R2[["c11"]])+(PALSAR_FULL_BANDS_R2[["c33"]]))))

db_l <- addLayer(PAL_hh_db, PAL_hv_db, PAL_vv_db, PAL_hvmhh_db, PAL_hvmvv_db, PAL_hhmvv_db, PAL_DP_db)
names(db_l)

band_names_db = (c('PAL_hh_db','PAL_hv_db','PAL_vv_db', 'PAL_hvmhh_db', 
                   'PAL_hvmvv_db', 'PAL_hhmvv_db', 'PAL_DP_db'))

names(db_l) <- band_names_db

names(db_l)

# Vc pode tratar as imagens como vetor
sel <- subset(PALSAR_FULL_BANDS_R2, 4:37)
names(sel)

PALSAR_FULL_BANDS_Rdb <- addLayer(db_l, sel)
names(PALSAR_FULL_BANDS_Rdb)


writeRaster(x=PALSAR_FULL_BANDS_Rdb, filename='PALSAR_FULL_BANDS_Rdb.grd', datatype='FLT8S', overwrite=TRUE)

writeRaster(x=PALSAR_FULL_BANDS_Rdb, filename='C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/PAL_mapas_bio_ARC/PALSAR_FULL_BANDS_Rdb.tif', datatype='FLT8S', overwrite=TRUE)





# Criando mascara
masc <- subset(PALSAR_FULL_BANDS_Rdb,1)
masc[masc == 0] <- NA




# FUNO PARA PASSAR IMAGEM PARA DATAFRAME
as.data.table.raster <- function(x, row.names = NULL, optional = FALSE, xy=FALSE, inmem = canProcessInMemory(x, 2), ...) {
  stopifnot(require("data.table"))
  if(inmem) {
    v <- as.data.table(as.data.frame(x, row.names=row.names, optional=optional, xy=xy, ...))
  } else {
    tr <- blockSize(x, n=2)
    l <- lapply(1:tr$n, function(i) 
      as.data.table(as.data.frame(getValues(x, 
                                            row=tr$row[i], 
                                            nrows=tr$nrows[i]), 
                                  row.names=row.names, optional=optional, xy=xy, ...)))
    v <- rbindlist(l)
  }
  coln <- names(x)
  if(xy) coln <- c("x", "y", coln)
  setnames(v, coln)
  v
}

if (!isGeneric("as.data.table")) {
  setGeneric("as.data.table", function(x, ...)
    standardGeneric("as.data.table"))
}  

setMethod('as.data.table', signature(x='data.frame'), data.table::as.data.table)
setMethod('as.data.table', signature(x='Raster'), as.data.table.raster)



########### LOG

setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC")
All_atrib <- read.csv("All_atrib1.csv", header=TRUE, sep=",")


setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model")
MODEL_index_ord <- read.csv("POL_L3_L_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord = MODEL_index_ord[!MODEL_index_ord$p.value > 0.05,]


glimpse(MODEL_index_ord)

L <- nrow(MODEL_index_ord)

## NO ESQUECER DE TROCAR A PASTA DESTA FUNO E O NOME
outlierKD <- function(dt, var) {
  h2 <- paste0('PALP_100_18_LOG_BIO_', s, '.tiff')
  outli <- file.path("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/HIST",h2)
  tiff(file=outli)
  var_name <- eval(substitute(var),eval(dt))
  tot <- sum(!is.na(var_name))
  na1 <- sum(is.na(var_name))
  m1 <- mean(var_name, na.rm = T)
  par(mfrow=c(2, 2), oma=c(0,0,3,0))
  boxplot(var_name, main="With outliers")
  hist(var_name, main="With outliers", xlab=NA, ylab=NA)
  outlier <- boxplot.stats(var_name)$out
  mo <- mean(outlier)
  var_name <- ifelse(var_name %in% outlier, NA, var_name)
  boxplot(var_name, main="Without outliers")
  hist(var_name, main="Without outliers", xlab=NA, ylab=NA)
  title("Outlier Check", outer=TRUE)
  dev.off()
} 


outlier_LIMIAR<- function(dt, var) {
  h2 <- paste0('PALP_100_18_LOG_600_BIO_', s, '.tiff')
  outli <- file.path("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/HIST",h2)
  tiff(file=outli)
  var_name <- eval(substitute(var),eval(dt))
  tot <- sum(!is.na(var_name))
  na1 <- sum(is.na(var_name))
  m1 <- mean(var_name, na.rm = T)
  par(mfrow=c(2, 2), oma=c(0,0,3,0))
  boxplot(var_name, main="With outliers")
  hist(var_name, main="With outliers", xlab=NA, ylab=NA)
  outlier <- boxplot.stats(var_name)$out
  mo <- mean(outlier)
  var_name <- ifelse(var_name %in% outlier, NA, var_name)
  boxplot(var_name, main="Without outliers")
  hist(var_name, main="Without outliers", xlab=NA, ylab=NA)
  title("Outlier Check", outer=TRUE)
  dev.off()
} 

setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio"  ####### c
dir.create("1_PAL_bio_18_760")  ####### c

write.csv(MODEL_index_ord, "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/MODEL_18_log.csv") 

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/1_PAL_bio_18_760')



for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(PALSAR_FULL_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  
  
  ras[ras > 760] <- 760
  
  f <- paste0('PALP_760_LOG_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}



setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio"  ####### c
dir.create("1_PAL_bio_18_600")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/1_PAL_bio_18_600')



for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(PALSAR_FULL_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  gg<-ras
  
  gww<- as.data.table.raster(gg)
  gww = gww[!(is.na(gww$layer)),]
  gww = gww[!gww$layer == 0,]
  outlierKD(gww, layer) 
  
  
  ras[ras > 600] <- 600
  gL<-ras
  
  gL<- as.data.table.raster(gL)
  gL = gL[!(is.na(gL$layer)),]
  gL = gL[!gL$layer == 0,]
  outlier_LIMIAR(gL, layer) 
  f <- paste0('PALP_600_LOG_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}


setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio"  ####### c
dir.create("1_PAL_bio_18_250")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/1_PAL_bio_18_250')

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(PALSAR_FULL_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  
  ras[ras > 250] <- 250
  
  f <- paste0('PALP_250_LOG_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}




################### Functions outliers

is_outlier_min <- function(x) {
  return(x < quantile(x, 0.25) - 1.5 * IQR(x))
}

is_outlier_max <- function(x) {
  return(x > quantile(x, 0.75) + 1.5 * IQR(x))
}



setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio"  ####### c
dir.create("1_PAL_bio_18_out")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/1_PAL_bio_18_out')

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(PALSAR_FULL_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  gg<-ras
  
  gww<- as.data.table.raster(gg)
  gww = gww[!(is.na(gww$layer)),]
  gww = gww[!gww$layer == 0,]
   
  gww2 <- gww %>%
    mutate(outlier_min = ifelse(is_outlier_min(layer), layer, as.numeric(NA)))%>%
    mutate(outlier_max = ifelse(is_outlier_max(layer), layer, as.numeric(NA)))
  
  Max_L1 <- min(gww2$outlier_max,na.rm=TRUE)
  
  print(Max_L1)
  
  Min_L1 <-  max(gww2$outlier_min, na.rm=TRUE)
  print(Min_L1)
  
  Max_L <- ifelse(Max_L1 == -Inf, max(gww$layer),  Max_L1) 
  print(Max_L)
  
  Min_L <- ifelse(Min_L1 == -Inf, min(gww$layer),  Min_L1) 
  print(Min_L)
  
  
  ras[ras > Max_L] <- Max_L
  ras[ras < Min_L] <- Min_L
  
  f <- paste0('PALP_out_LOG_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}





############################################################################################
####################################################IDENT



setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC")
All_atrib <- read.csv("All_atrib1.csv", header=TRUE, sep=",")


setwd("C:/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model")
MODEL_index_ord <- read.csv("POL_L3_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord = MODEL_index_ord[!MODEL_index_ord$p.value > 0.05,]


glimpse(MODEL_index_ord)

L <- nrow(MODEL_index_ord)


## NO ESQUECER DE TROCAR A PASTA DESTA FUNO E O NOME
outlierKD <- function(dt, var) {
  h2 <- paste0('PALP_100_18_IDENT_BIO_', s, '.tiff')
  outli <- file.path("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/HIST",h2)
  tiff(file=outli)
  var_name <- eval(substitute(var),eval(dt))
  tot <- sum(!is.na(var_name))
  na1 <- sum(is.na(var_name))
  m1 <- mean(var_name, na.rm = T)
  par(mfrow=c(2, 2), oma=c(0,0,3,0))
  boxplot(var_name, main="With outliers")
  hist(var_name, main="With outliers", xlab=NA, ylab=NA)
  outlier <- boxplot.stats(var_name)$out
  mo <- mean(outlier)
  var_name <- ifelse(var_name %in% outlier, NA, var_name)
  boxplot(var_name, main="Without outliers")
  hist(var_name, main="Without outliers", xlab=NA, ylab=NA)
  title("Outlier Check", outer=TRUE)
  dev.off()
} 


outlier_LIMIAR<- function(dt, var) {
  h2 <- paste0('PALP_100_18_IDENT_600_BIO_', s, '.tiff')
  outli <- file.path("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/HIST",h2)
  tiff(file=outli)
  var_name <- eval(substitute(var),eval(dt))
  tot <- sum(!is.na(var_name))
  na1 <- sum(is.na(var_name))
  m1 <- mean(var_name, na.rm = T)
  par(mfrow=c(2, 2), oma=c(0,0,3,0))
  boxplot(var_name, main="With outliers")
  hist(var_name, main="With outliers", xlab=NA, ylab=NA)
  outlier <- boxplot.stats(var_name)$out
  mo <- mean(outlier)
  var_name <- ifelse(var_name %in% outlier, NA, var_name)
  boxplot(var_name, main="Without outliers")
  hist(var_name, main="Without outliers", xlab=NA, ylab=NA)
  title("Outlier Check", outer=TRUE)
  dev.off()
} 

setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio"  ####### c
dir.create("1_PAL_bio_18_IDENT_760")  ####### c

write.csv(MODEL_index_ord, "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/MODEL_18_IDENT.csv") 

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/1_PAL_bio_18_IDENT_760')



for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(PALSAR_FULL_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  
  
  ras[ras > 760] <- 760
  
  f <- paste0('PALP_760_IDENT_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}



setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio"  ####### c
dir.create("1_PAL_bio_18_IDENT_600")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/1_PAL_bio_18_IDENT_600')



for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(PALSAR_FULL_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  gg<-ras
  
  gww<- as.data.table.raster(gg)
  gww = gww[!(is.na(gww$layer)),]
  gww = gww[!gww$layer == 0,]
  outlierKD(gww, layer) 
  
  
  ras[ras > 600] <- 600
  gL<-ras
  
  gL<- as.data.table.raster(gL)
  gL = gL[!(is.na(gL$layer)),]
  gL = gL[!gL$layer == 0,]
  outlier_LIMIAR(gL, layer) 
  f <- paste0('PALP_600_IDENT_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}


setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio"  ####### c
dir.create("1_PAL_bio_18_IDENT_250")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/1_PAL_bio_18_IDENT_250')

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(PALSAR_FULL_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  
  ras[ras > 250] <- 250
  
  f <- paste0('PALP_250_IDENT_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}




################### Functions outliers

is_outlier_min <- function(x) {
  return(x < quantile(x, 0.25) - 1.5 * IQR(x))
}

is_outlier_max <- function(x) {
  return(x > quantile(x, 0.75) + 1.5 * IQR(x))
}



setwd("C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio")
mainDir <- "C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio"  ####### c
dir.create("1_PAL_bio_18_IDENT_out")  ####### c

setwd('C:/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1_PAL_bio/1_PAL_bio_18_IDENT_out')

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  
  # Aply the model in the set of imagens
  
  
  ras <- predict(PALSAR_FULL_BANDS_Rdb, y, type='response')
  
  ras <- mask(ras, masc)
  ras[ras < 0] <- 0
  gg<-ras
  
  gww<- as.data.table.raster(gg)
  gww = gww[!(is.na(gww$layer)),]
  gww = gww[!gww$layer == 0,]
  
  gww2 <- gww %>%
    mutate(outlier_min = ifelse(is_outlier_min(layer), layer, as.numeric(NA)))%>%
    mutate(outlier_max = ifelse(is_outlier_max(layer), layer, as.numeric(NA)))
  
  Max_L1 <- min(gww2$outlier_max,na.rm=TRUE)
  
  print(Max_L1)
  
  Min_L1 <-  max(gww2$outlier_min, na.rm=TRUE)
  print(Min_L1)
  
  Max_L <- ifelse(Max_L1 == -Inf, max(gww$layer),  Max_L1) 
  print(Max_L)
  
  Min_L <- ifelse(Min_L1 == -Inf, min(gww$layer),  Min_L1) 
  print(Min_L)
  
  
  ras[ras > Max_L] <- Max_L
  ras[ras < Min_L] <- Min_L
  
  f <- paste0('PALP_out_IDENT_18_BIO_', s, '.tif')
  writeRaster(x=ras, filename= f,format="GTiff", datatype='FLT8S', overwrite=TRUE)
}







