


install.packages("reshape2")
install.packages("ggplot2")
install.packages("plyr")
install.packages("scales")
install.packages("foreign")
install.packages("car")
install.packages("DAAG")
install.packages("MASS")
install.packages("leaps")
install.packages("car")
install.packages("bootStepAIC")
install.packages("forecast")
install.packages("glmulti")
install.packages("rJava")
install.packages("ISLR")
install.packages("boot")
install.packages("dplyr")
install.packages("broom")


library(leaps)
library(reshape2) 
library(ggplot2)
library(plyr)
library(scales)
library(foreign)
library(car)
library(randomForest)
library(DAAG)
library(MASS)
library(bootStepAIC)
library(leaps)
library(forecast)
library(glmulti)
library(rJava)
library(ISLR)
library(boot)
library(dplyr)
library(broom)



# ESE -  (Berninger, A.; Lohberger, S.; Stngel, M.; Siegert, F. Sar-based 
#         estimation of above-ground biomass and its changes in tropical 
#         forests of kalimantan using l- and c-band. Remote Sens. 2018, 10, 831) 

# BIAS -  (Berninger, A.; Lohberger, S.; Stngel, M.; Siegert, F. Sar-based 
#         estimation of above-ground biomass and its changes in tropical 
#         forests of kalimantan using l- and c-band. Remote Sens. 2018, 10, 831) 

# BIAS_m - Evenly (email) MODEL BIAS (NOT (MEAN(AGBESTIMATED))- (MEAN(OBSERVED)))

# SC- CONSIDERING THE threshold AGB and or LAI 

# ER = ERRO RELATIVE %

# ER_SC (Code R)


setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS")

mainDir <- "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS"  ####### c
dir.create("1RMSE_SCALE_BIO")

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO")
dir.create("RMSE_SCALE_PAL_BIO")####### c

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC")
All_atrib <- read.csv("All_atrib1.csv", header=TRUE, sep=",")

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model")
MODEL_index_ord <- read.csv("POL_L3_L_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord = MODEL_index_ord[!MODEL_index_ord$p.value > 0.05,]
# MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X == 3) , ]

MODEL_index_ord <- MODEL_index_ord[!duplicated(MODEL_index_ord$model), ]

# duplicated(TB1$Plot.ID)
# 
# TB1$Plot.ID[duplicated(TB1$Plot.ID)]
# 
# length(unique(TB1$Plot.ID))


glimpse(MODEL_index_ord)

L <- nrow(MODEL_index_ord)

h <- as.numeric(nrow(All_atrib)) #########


ER_F <-numeric(L)
ER_SC_F<-numeric(L)
# ER_RMSE <- numeric(L)
# ER_RMSE_SC <- numeric(L)#############
BIAS <-numeric(L)
BIAS_SC<-numeric(L)
# BIAS_m <- numeric(L)
# BIAS_m_SC <- numeric(L)
R2 <- numeric(L)
R2_SC <- numeric(L)
RMSE_LOOCV <- numeric(L)
RMSE_LOOCV_Bias <- numeric(L)
NSE <- numeric(L)
NSE_SC <- numeric(L)
NSE_LOOCV <- numeric(L)



fit_fim <-NULL

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  LOOCV <- cv.glm(All_atrib, y, K = nrow(All_atrib))
  RMSE_LOOCV[s]<- (LOOCV$delta[1])^0.5
  RMSE_LOOCV_Bias[s]<- (LOOCV$delta[2])^0.5
  fitted_yL <-c(fitted.values(y))
  fit <- cbind(All_atrib$biomass_Tha,fitted_yL)
  namefitted <- paste0("fit", s)
  R2[s] <-  c(cor(All_atrib$biomass_Tha,fitted_yL)^2)
  fitted_yL_1 <- ifelse(fitted_yL > 600, 600, fitted_yL)
  fitted_yL_2 <- ifelse(fitted_yL < 0, 0, fitted_yL_1)
  R2_SC[s] <-  c(cor(All_atrib$biomass_Tha,fitted_yL_2)^2)
  ER <- (fitted_yL)-(All_atrib$biomass_Tha) ########
  ER_F[s] <- (((sum(abs((ER)/All_atrib$biomass_Tha)))/h)*100)########
  # ER_RMSE[s] <- (sqrt(mean((ER/(All_atrib$biomass_Tha))^2)))########
  # BIAS_m[s] <- (sum(ER))/(sum(All_atrib$biomass_Tha))########
  BIAS[s] <- (mean(fitted_yL))-(mean(All_atrib$biomass_Tha))
   ER_SC <- (fitted_yL_2)-(All_atrib$biomass_Tha)########
   ER_SC_F[s] <- (((sum(abs((ER_SC)/All_atrib$biomass_Tha)))/h)*100)
  # ER_RMSE_SC[s] <- (sqrt(mean((ER_SC/(All_atrib$biomass_Tha))^2)))
  # BIAS_m_SC[s] <- (mean(fitted_yL))-(mean(All_atrib$biomass_Tha))
  BIAS_SC[s] <- (mean(fitted_yL_2))-(mean(All_atrib$biomass_Tha))
  NSE[s] <- 1-((sum((ER)^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  NSE_SC[s] <- 1-((sum((ER_SC)^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  NSE_LOOCV[s] <- 1-(((LOOCV$delta[1])*h)/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  fit_fim <- cbind(fit_fim, fit)
}


m = nrow(MODEL_index_ord)
print(m)
RMSE_LOOCV_SC <- numeric(m)
ER_LOOCV_SC <- numeric(m)
# ER_RMSE_LOOCV_SC <-numeric(m) 
NSE_LOOCV_SC <- numeric(m)

dfPOL<-tbl_df(All_atrib)
n = nrow(All_atrib)
em <-numeric(n)    # GUARDA OS ERROS PARA N OBSERVAES
JK <- numeric(n)

for(j in 1:m) {
  for(k in 1:n){
    lmcv<- dfPOL[-k, ]
    lmf <- as.formula(paste(MODEL_index_ord$model[j]))
    y <- glm(formula=lmf, data =lmcv,
              family= gaussian(link="log"))
    lmes <- predict(y, dfPOL[k, ], type='response')
    lmes1 <- ifelse(lmes > 600, 600, lmes)
    lmes2 <- ifelse(lmes1 < 0, 0, lmes1)
    em[k] <- ((dfPOL[k, 2]) - (lmes2))
    RMSE_LOOCV_SC[j] <- (mean((as.numeric(em))^2))^0.5
    JK[k] <- (((dfPOL[k, 2]) - (lmes2))/(dfPOL[k, 2]))
    ER_LOOCV_SC[j] <- ((sum(abs(as.numeric(JK))))/h)*100
    # ER_RMSE_LOOCV_SC[j] <- (mean((as.numeric(JK))^2))^0.5
    NSE_LOOCV_SC[j] <- ((sum((as.numeric(em))^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  } 
}



STA <- data.frame(ER_F,	ER_SC_F, ER_LOOCV_SC,	BIAS,	BIAS_SC, RMSE_LOOCV_Bias, R2,	R2_SC,	
                  RMSE_LOOCV,	RMSE_LOOCV_SC, NSE,	NSE_SC,	NSE_LOOCV,NSE_LOOCV_SC)


STA_END <- STA %>%
  mutate(RELA_RMSE_LOOCV = (RMSE_LOOCV/mean(All_atrib$biomass_Tha))*100)%>%
  mutate(RELA_RMSE_LOOCV_SC = (RMSE_LOOCV_SC/mean(All_atrib$biomass_Tha))*100)%>%
  mutate(model= MODEL_index_ord$model)%>%
  mutate(X = MODEL_index_ord$X)%>%
  mutate(aicc = MODEL_index_ord$aicc)%>%
  mutate(weights  = MODEL_index_ord$weights)%>%
  mutate(p.value  = MODEL_index_ord$p.value)%>%
  mutate(p_level_5  = MODEL_index_ord$Result_level_5)

  # Function moveme
moveMe <- function(data, tomove, where = "last", ba = NULL) {
  temp <- setdiff(names(data), tomove)
  x <- switch(
    where,
    first = data[c(tomove, temp)],
    last = data[c(temp, tomove)],
    before = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)-1))]
    },
    after = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)))]
    })
  x
}

STA_END <-moveMe(STA_END, c("X", "model", "aicc", "R2_SC", "RMSE_LOOCV_SC", "p.value", "p_level_5", 
                            "ER_SC_F", "RELA_RMSE_LOOCV_SC", "BIAS_SC"), "first")


STA_LOG_PAL_18_END <- STA_END

FIT_LOG_PAL_18_END <- as.data.frame(fit_fim)

  
write.csv(FIT_LOG_PAL_18_END, "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_PAL_BIO/FIT_LOG_PAL_18_END.csv")

write.csv(STA_LOG_PAL_18_END, "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_PAL_BIO/STA_LOG_PAL_18_END.csv")


rm(list=setdiff(ls(), "STA_LOG_PAL_18_END"))

##############################################################################################################



setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_Pol_L_2_AIC")
All_atrib <- read.csv("All_atrib1.csv", header=TRUE, sep=",")

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_Pol_L_2_AIC/16_best_model")
MODEL_index_ord <- read.csv("POL_L3_L_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord = MODEL_index_ord[!MODEL_index_ord$p.value > 0.05,]
# MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X == 1) , ]

MODEL_index_ord <- MODEL_index_ord[!duplicated(MODEL_index_ord$model), ]


glimpse(MODEL_index_ord)

L <- nrow(MODEL_index_ord)

h <- as.numeric(nrow(All_atrib)) #########


ER_F <-numeric(L)
ER_SC_F<-numeric(L)
# ER_RMSE <- numeric(L)
# ER_RMSE_SC <- numeric(L)#############
BIAS <-numeric(L)
BIAS_SC<-numeric(L)
# BIAS_m <- numeric(L)
# BIAS_m_SC <- numeric(L)
R2 <- numeric(L)
R2_SC <- numeric(L)
RMSE_LOOCV <- numeric(L)
RMSE_LOOCV_Bias <- numeric(L)
NSE <- numeric(L)
NSE_SC <- numeric(L)
NSE_LOOCV <- numeric(L)



fit_fim <-NULL

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="log"))
  LOOCV <- cv.glm(All_atrib, y, K = nrow(All_atrib))
  RMSE_LOOCV[s]<- (LOOCV$delta[1])^0.5
  RMSE_LOOCV_Bias[s]<- (LOOCV$delta[2])^0.5
  fitted_yL <-c(fitted.values(y))
  fit <- cbind(All_atrib$biomass_Tha,fitted_yL)
  namefitted <- paste0("fit", s)
  R2[s] <-  c(cor(All_atrib$biomass_Tha,fitted_yL)^2)
  fitted_yL_1 <- ifelse(fitted_yL > 600, 600, fitted_yL)
  fitted_yL_2 <- ifelse(fitted_yL < 0, 0, fitted_yL_1)
  R2_SC[s] <-  c(cor(All_atrib$biomass_Tha,fitted_yL_2)^2)
  ER <- (fitted_yL)-(All_atrib$biomass_Tha) ########
  ER_F[s] <- (((sum(abs((ER)/All_atrib$biomass_Tha)))/h)*100)########
  # ER_RMSE[s] <- (sqrt(mean((ER/(All_atrib$biomass_Tha))^2)))########
  # BIAS_m[s] <- (sum(ER))/(sum(All_atrib$biomass_Tha))########
  BIAS[s] <- (mean(fitted_yL))-(mean(All_atrib$biomass_Tha))
  ER_SC <- (fitted_yL_2)-(All_atrib$biomass_Tha)########
  ER_SC_F[s] <- (((sum(abs((ER_SC)/All_atrib$biomass_Tha)))/h)*100)
  # ER_RMSE_SC[s] <- (sqrt(mean((ER_SC/(All_atrib$biomass_Tha))^2)))
  # BIAS_m_SC[s] <- (mean(fitted_yL))-(mean(All_atrib$biomass_Tha))
  BIAS_SC[s] <- (mean(fitted_yL_2))-(mean(All_atrib$biomass_Tha))
  NSE[s] <- 1-((sum((ER)^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  NSE_SC[s] <- 1-((sum((ER_SC)^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  NSE_LOOCV[s] <- 1-(((LOOCV$delta[1])*h)/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  fit_fim <- cbind(fit_fim, fit)
}


m = nrow(MODEL_index_ord)
print(m)
RMSE_LOOCV_SC <- numeric(m)
ER_LOOCV_SC <- numeric(m)
# ER_RMSE_LOOCV_SC <-numeric(m) 
NSE_LOOCV_SC <- numeric(m)

dfPOL<-tbl_df(All_atrib)
n = nrow(All_atrib)
em <-numeric(n)    # GUARDA OS ERROS PARA N OBSERVAES
JK <- numeric(n)

for(j in 1:m) {
  for(k in 1:n){
    lmcv<- dfPOL[-k, ]
    lmf <- as.formula(paste(MODEL_index_ord$model[j]))
    y <- glm(formula=lmf, data =lmcv,
             family= gaussian(link="log"))
    lmes <- predict(y, dfPOL[k, ], type='response')
    lmes1 <- ifelse(lmes > 600, 600, lmes)
    lmes2 <- ifelse(lmes1 < 0, 0, lmes1)
    em[k] <- ((dfPOL[k, 2]) - (lmes2))
    RMSE_LOOCV_SC[j] <- (mean((as.numeric(em))^2))^0.5
    JK[k] <- (((dfPOL[k, 2]) - (lmes2))/(dfPOL[k, 2]))
    ER_LOOCV_SC[j] <- ((sum(abs(as.numeric(JK))))/h)*100
    # ER_RMSE_LOOCV_SC[j] <- (mean((as.numeric(JK))^2))^0.5
    NSE_LOOCV_SC[j] <- ((sum((as.numeric(em))^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  } 
}



STA <- data.frame(ER_F,	ER_SC_F, ER_LOOCV_SC,	BIAS,	BIAS_SC, RMSE_LOOCV_Bias, R2,	R2_SC,	
                  RMSE_LOOCV,	RMSE_LOOCV_SC, NSE,	NSE_SC,	NSE_LOOCV,NSE_LOOCV_SC)


STA_END <- STA %>%
  mutate(RELA_RMSE_LOOCV = (RMSE_LOOCV/mean(All_atrib$biomass_Tha))*100)%>%
  mutate(RELA_RMSE_LOOCV_SC = (RMSE_LOOCV_SC/mean(All_atrib$biomass_Tha))*100)%>%
  mutate(model= MODEL_index_ord$model)%>%
  mutate(X = MODEL_index_ord$X)%>%
  mutate(aicc = MODEL_index_ord$aicc)%>%
  mutate(weights  = MODEL_index_ord$weights)%>%
  mutate(p.value  = MODEL_index_ord$p.value)%>%
  mutate(p_level_5  = MODEL_index_ord$Result_level_5)

# Function moveme
moveMe <- function(data, tomove, where = "last", ba = NULL) {
  temp <- setdiff(names(data), tomove)
  x <- switch(
    where,
    first = data[c(tomove, temp)],
    last = data[c(temp, tomove)],
    before = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)-1))]
    },
    after = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)))]
    })
  x
}

STA_END <-moveMe(STA_END, c("X", "model", "aicc", "R2_SC", "RMSE_LOOCV_SC", "p.value", "p_level_5", 
                            "ER_SC_F", "RELA_RMSE_LOOCV_SC", "BIAS_SC"), "first")




STA_LOG_PAL_16_END <- STA_END

FIT_LOG_PAL_16_END <- as.data.frame(fit_fim)

write.csv(FIT_LOG_PAL_16_END, "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_PAL_BIO/FIT_LOG_PAL_16_END.csv")

write.csv(STA_LOG_PAL_16_END, "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_PAL_BIO/STA_LOG_PAL_16_END.csv")

rm(list= ls()[!(ls() %in% c('STA_LOG_PAL_18_END','STA_LOG_PAL_16_END'))])



##############################ident######################################################################################



setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC")
All_atrib <- read.csv("All_atrib1.csv", header=TRUE, sep=",")


setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/18_pts/1Bio_18_Pol_L_2_AIC/18_best_model")
MODEL_index_ord <- read.csv("POL_L3_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord = MODEL_index_ord[!MODEL_index_ord$p.value > 0.05,]
# MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X == 1) , ]

MODEL_index_ord <- MODEL_index_ord[!duplicated(MODEL_index_ord$model), ]

glimpse(MODEL_index_ord)

L <- nrow(MODEL_index_ord)

h <- as.numeric(nrow(All_atrib)) #########


ER_F <-numeric(L)
ER_SC_F<-numeric(L)
# ER_RMSE <- numeric(L)
# ER_RMSE_SC <- numeric(L)#############
BIAS <-numeric(L)
BIAS_SC<-numeric(L)
# BIAS_m <- numeric(L)
# BIAS_m_SC <- numeric(L)
R2 <- numeric(L)
R2_SC <- numeric(L)
RMSE_LOOCV <- numeric(L)
RMSE_LOOCV_Bias <- numeric(L)
NSE <- numeric(L)
NSE_SC <- numeric(L)
NSE_LOOCV <- numeric(L)



fit_fim <-NULL

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  LOOCV <- cv.glm(All_atrib, y, K = nrow(All_atrib))
  RMSE_LOOCV[s]<- (LOOCV$delta[1])^0.5
  RMSE_LOOCV_Bias[s]<- (LOOCV$delta[2])^0.5
  fitted_yL <-c(fitted.values(y))
  fit <- cbind(All_atrib$biomass_Tha,fitted_yL)
  namefitted <- paste0("fit", s)
  R2[s] <-  c(cor(All_atrib$biomass_Tha,fitted_yL)^2)
  fitted_yL_1 <- ifelse(fitted_yL > 600, 600, fitted_yL)
  fitted_yL_2 <- ifelse(fitted_yL < 0, 0, fitted_yL_1)
  R2_SC[s] <-  c(cor(All_atrib$biomass_Tha,fitted_yL_2)^2)
  ER <- (fitted_yL)-(All_atrib$biomass_Tha) ########
  ER_F[s] <- (((sum(abs((ER)/All_atrib$biomass_Tha)))/h)*100)########
  # ER_RMSE[s] <- (sqrt(mean((ER/(All_atrib$biomass_Tha))^2)))########
  # BIAS_m[s] <- (sum(ER))/(sum(All_atrib$biomass_Tha))########
  BIAS[s] <- (mean(fitted_yL))-(mean(All_atrib$biomass_Tha))
  ER_SC <- (fitted_yL_2)-(All_atrib$biomass_Tha)########
  ER_SC_F[s] <- (((sum(abs((ER_SC)/All_atrib$biomass_Tha)))/h)*100)
  # ER_RMSE_SC[s] <- (sqrt(mean((ER_SC/(All_atrib$biomass_Tha))^2)))
  # BIAS_m_SC[s] <- (mean(fitted_yL))-(mean(All_atrib$biomass_Tha))
  BIAS_SC[s] <- (mean(fitted_yL_2))-(mean(All_atrib$biomass_Tha))
  NSE[s] <- 1-((sum((ER)^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  NSE_SC[s] <- 1-((sum((ER_SC)^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  NSE_LOOCV[s] <- 1-(((LOOCV$delta[1])*h)/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  fit_fim <- cbind(fit_fim, fit)
}


m = nrow(MODEL_index_ord)
print(m)
RMSE_LOOCV_SC <- numeric(m)
ER_LOOCV_SC <- numeric(m)
# ER_RMSE_LOOCV_SC <-numeric(m) 
NSE_LOOCV_SC <- numeric(m)

dfPOL<-tbl_df(All_atrib)
n = nrow(All_atrib)
em <-numeric(n)    # GUARDA OS ERROS PARA N OBSERVAES
JK <- numeric(n)

for(j in 1:m) {
  for(k in 1:n){
    lmcv<- dfPOL[-k, ]
    lmf <- as.formula(paste(MODEL_index_ord$model[j]))
    y <- glm(formula=lmf, data =lmcv,
             family= gaussian(link="identity"))
    lmes <- predict(y, dfPOL[k, ], type='response')
    lmes1 <- ifelse(lmes > 600, 600, lmes)
    lmes2 <- ifelse(lmes1 < 0, 0, lmes1)
    em[k] <- ((dfPOL[k, 2]) - (lmes2))
    RMSE_LOOCV_SC[j] <- (mean((as.numeric(em))^2))^0.5
    JK[k] <- (((dfPOL[k, 2]) - (lmes2))/(dfPOL[k, 2]))
    ER_LOOCV_SC[j] <- ((sum(abs(as.numeric(JK))))/h)*100
    # ER_RMSE_LOOCV_SC[j] <- (mean((as.numeric(JK))^2))^0.5
    NSE_LOOCV_SC[j] <- ((sum((as.numeric(em))^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  } 
}


STA <- data.frame(ER_F,	ER_SC_F, ER_LOOCV_SC,	BIAS,	BIAS_SC, RMSE_LOOCV_Bias, R2,	R2_SC,	
                  RMSE_LOOCV,	RMSE_LOOCV_SC, NSE,	NSE_SC,	NSE_LOOCV,NSE_LOOCV_SC)


STA_END <- STA %>%
  mutate(RELA_RMSE_LOOCV = (RMSE_LOOCV/mean(All_atrib$biomass_Tha))*100)%>%
  mutate(RELA_RMSE_LOOCV_SC = (RMSE_LOOCV_SC/mean(All_atrib$biomass_Tha))*100)%>%
  mutate(model= MODEL_index_ord$model)%>%
  mutate(X = MODEL_index_ord$X)%>%
  mutate(aicc = MODEL_index_ord$aicc)%>%
  mutate(weights  = MODEL_index_ord$weights)%>%
  mutate(p.value  = MODEL_index_ord$p.value)%>%
  mutate(p_level_5  = MODEL_index_ord$Result_level_5)

# Function moveme
moveMe <- function(data, tomove, where = "last", ba = NULL) {
  temp <- setdiff(names(data), tomove)
  x <- switch(
    where,
    first = data[c(tomove, temp)],
    last = data[c(temp, tomove)],
    before = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)-1))]
    },
    after = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)))]
    })
  x
}

STA_END <-moveMe(STA_END, c("X", "model", "aicc", "R2_SC", "RMSE_LOOCV_SC", "p.value", "p_level_5", 
                            "ER_SC_F", "RELA_RMSE_LOOCV_SC", "BIAS_SC"), "first")



STA_IDENT_PAL_18_END <- STA_END

FIT_IDENT_PAL_18_END <- as.data.frame(fit_fim)

write.csv(FIT_IDENT_PAL_18_END, "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_PAL_BIO/FIT_IDENT_PAL_18_END.csv")

write.csv(STA_IDENT_PAL_18_END, "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_PAL_BIO/STA_IDENT_PAL_18_END.csv")



rm(list= ls()[!(ls() %in% c('STA_IDENT_PAL_18_END','STA_LOG_PAL_18_END','STA_LOG_PAL_16_END'))])

##############################################################################################################



setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_Pol_L_2_AIC")
All_atrib <- read.csv("All_atrib1.csv", header=TRUE, sep=",")

setwd("C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/16_pts/1Bio_16_Pol_L_2_AIC/16_best_model")
MODEL_index_ord <- read.csv("POL_L3_index_ord.csv", header=TRUE, sep=",")
MODEL_index_ord = MODEL_index_ord[!MODEL_index_ord$p.value > 0.05,]
# MODEL_index_ord <- MODEL_index_ord[ which(MODEL_index_ord$X == 1) , ]

MODEL_index_ord <- MODEL_index_ord[!duplicated(MODEL_index_ord$model), ]

glimpse(MODEL_index_ord)

L <- nrow(MODEL_index_ord)

h <- as.numeric(nrow(All_atrib)) #########


ER_F <-numeric(L)
ER_SC_F<-numeric(L)
# ER_RMSE <- numeric(L)
# ER_RMSE_SC <- numeric(L)#############
BIAS <-numeric(L)
BIAS_SC<-numeric(L)
# BIAS_m <- numeric(L)
# BIAS_m_SC <- numeric(L)
R2 <- numeric(L)
R2_SC <- numeric(L)
RMSE_LOOCV <- numeric(L)
RMSE_LOOCV_Bias <- numeric(L)
NSE <- numeric(L)
NSE_SC <- numeric(L)
NSE_LOOCV <- numeric(L)



fit_fim <-NULL

for (s in 1:L){
  z <- as.formula(paste(MODEL_index_ord$model[s]))
  y <- glm(formula=z, data =All_atrib,
           family= gaussian(link="identity"))
  LOOCV <- cv.glm(All_atrib, y, K = nrow(All_atrib))
  RMSE_LOOCV[s]<- (LOOCV$delta[1])^0.5
  RMSE_LOOCV_Bias[s]<- (LOOCV$delta[2])^0.5
  fitted_yL <-c(fitted.values(y))
  fit <- cbind(All_atrib$biomass_Tha,fitted_yL)
  namefitted <- paste0("fit", s)
  R2[s] <-  c(cor(All_atrib$biomass_Tha,fitted_yL)^2)
  fitted_yL_1 <- ifelse(fitted_yL > 600, 600, fitted_yL)
  fitted_yL_2 <- ifelse(fitted_yL < 0, 0, fitted_yL_1)
  R2_SC[s] <-  c(cor(All_atrib$biomass_Tha,fitted_yL_2)^2)
  ER <- (fitted_yL)-(All_atrib$biomass_Tha) ########
  ER_F[s] <- (((sum(abs((ER)/All_atrib$biomass_Tha)))/h)*100)########
  # ER_RMSE[s] <- (sqrt(mean((ER/(All_atrib$biomass_Tha))^2)))########
  # BIAS_m[s] <- (sum(ER))/(sum(All_atrib$biomass_Tha))########
  BIAS[s] <- (mean(fitted_yL))-(mean(All_atrib$biomass_Tha))
  ER_SC <- (fitted_yL_2)-(All_atrib$biomass_Tha)########
  ER_SC_F[s] <- (((sum(abs((ER_SC)/All_atrib$biomass_Tha)))/h)*100)
  # ER_RMSE_SC[s] <- (sqrt(mean((ER_SC/(All_atrib$biomass_Tha))^2)))
  # BIAS_m_SC[s] <- (mean(fitted_yL))-(mean(All_atrib$biomass_Tha))
  BIAS_SC[s] <- (mean(fitted_yL_2))-(mean(All_atrib$biomass_Tha))
  NSE[s] <- 1-((sum((ER)^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  NSE_SC[s] <- 1-((sum((ER_SC)^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  NSE_LOOCV[s] <- 1-(((LOOCV$delta[1])*h)/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  fit_fim <- cbind(fit_fim, fit)
}


m = nrow(MODEL_index_ord)
print(m)
RMSE_LOOCV_SC <- numeric(m)
ER_LOOCV_SC <- numeric(m)
# ER_RMSE_LOOCV_SC <-numeric(m) 
NSE_LOOCV_SC <- numeric(m)

dfPOL<-tbl_df(All_atrib)
n = nrow(All_atrib)
em <-numeric(n)    # GUARDA OS ERROS PARA N OBSERVAES
JK <- numeric(n)

for(j in 1:m) {
  for(k in 1:n){
    lmcv<- dfPOL[-k, ]
    lmf <- as.formula(paste(MODEL_index_ord$model[j]))
    y <- glm(formula=lmf, data =lmcv,
             family= gaussian(link="identity"))
    lmes <- predict(y, dfPOL[k, ], type='response')
    lmes1 <- ifelse(lmes > 600, 600, lmes)
    lmes2 <- ifelse(lmes1 < 0, 0, lmes1)
    em[k] <- ((dfPOL[k, 2]) - (lmes2))
    RMSE_LOOCV_SC[j] <- (mean((as.numeric(em))^2))^0.5
    JK[k] <- (((dfPOL[k, 2]) - (lmes2))/(dfPOL[k, 2]))
    ER_LOOCV_SC[j] <- ((sum(abs(as.numeric(JK))))/h)*100
    # ER_RMSE_LOOCV_SC[j] <- (mean((as.numeric(JK))^2))^0.5
    NSE_LOOCV_SC[j] <- ((sum((as.numeric(em))^2))/(sum(((All_atrib$biomass_Tha)-(mean(All_atrib$biomass_Tha)))^2)))
  } 
}



STA <- data.frame(ER_F,	ER_SC_F, ER_LOOCV_SC,	BIAS,	BIAS_SC, RMSE_LOOCV_Bias, R2,	R2_SC,	
                  RMSE_LOOCV,	RMSE_LOOCV_SC, NSE,	NSE_SC,	NSE_LOOCV,NSE_LOOCV_SC)


STA_END <- STA %>%
  mutate(RELA_RMSE_LOOCV = (RMSE_LOOCV/mean(All_atrib$biomass_Tha))*100)%>%
  mutate(RELA_RMSE_LOOCV_SC = (RMSE_LOOCV_SC/mean(All_atrib$biomass_Tha))*100)%>%
  mutate(model= MODEL_index_ord$model)%>%
  mutate(X = MODEL_index_ord$X)%>%
  mutate(aicc = MODEL_index_ord$aicc)%>%
  mutate(weights  = MODEL_index_ord$weights)%>%
  mutate(p.value  = MODEL_index_ord$p.value)%>%
  mutate(p_level_5  = MODEL_index_ord$Result_level_5)

# Function moveme
moveMe <- function(data, tomove, where = "last", ba = NULL) {
  temp <- setdiff(names(data), tomove)
  x <- switch(
    where,
    first = data[c(tomove, temp)],
    last = data[c(temp, tomove)],
    before = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)-1))]
    },
    after = {
      if (is.null(ba)) stop("must specify ba column")
      if (length(ba) > 1) stop("ba must be a single character string")
      data[append(temp, values = tomove, after = (match(ba, temp)))]
    })
  x
}

STA_END <-moveMe(STA_END, c("X", "model", "aicc", "R2_SC", "RMSE_LOOCV_SC", "p.value", "p_level_5", 
                            "ER_SC_F", "RELA_RMSE_LOOCV_SC", "BIAS_SC"), "first")


STA_IDENT_PAL_16_END <- STA_END


FIT_IDENT_PAL_16_END <- as.data.frame(fit_fim)

write.csv(FIT_IDENT_PAL_16_END, "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_PAL_BIO/FIT_IDENT_PAL_16_END.csv")

write.csv(STA_IDENT_PAL_16_END, "C:/Users/lp469/OneDrive - University of Exeter/3_CURUAI/0_BEST_MODEL/0000_MAPAS/1RMSE_SCALE_BIO/RMSE_SCALE_PAL_BIO/STA_IDENT_PAL_16_END.csv")

rm(list= ls()[!(ls() %in% c('STA_IDENT_PAL_18_END','STA_LOG_PAL_18_END','STA_LOG_PAL_16_END','STA_IDENT_PAL_16_END'))])





